<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Modified ....... .
    Program ........ Download/Upload configuration manager for Cacti
    Version plugin . see setup.php

*******************************************************************************/

chdir('../../');
global $refreshtimeheader,$refresh_url;
global $argumentinit,$argumentinit2;

include("./plugins/configmanager/config.php");
include("./plugins/configmanager/debug.php");
include("./plugins/configmanager/functions.php");
include("./plugins/configmanager/html/hmtl-configmanager.php");
include("./include/auth.php");
include("./plugins/configmanager/html/inc_timespan_settings.php");
include("./plugins/configmanager/include/compatibily_cacti_before0.8i.php");

// check if the remote IP address has the right to use configmanager
if (!configmanager_isinlistmanagerIPs()) {
  html_authentification_error();
  exit;
}

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}
if (isset($_REQUEST["clear_x"])) {
  $_REQUEST["action"] = "clear_logfile";
  $action = "clear_logfile";
}
if (isset($_REQUEST["purge_x"])) {
  $_REQUEST["action"] = "purge";
  $action = "purge";
}

switch ($action) {
  case 'purge':
		cfgmngdelete();
		cfgmnglogutilities();
		break;
  default:
		cfgmnglogutilities();
		break;
}
exit;

function cfgmngdelete() {
  $message = date("Y-m-d H:i:s ")."purge log.\n";
  cfgmng_log($message,"w+");
}

function cfgmnglogutilities() {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
 global $colors,$config;
 global $log_tail_lines,$page_refresh_interval;
 global $refreshtimeheader,$refresh_url;

  $cfgmnglogfile = $config["base_path"]."/plugins/configmanager/cfgmng_logfile.txt";
  $configmanager_name=configmanager_programmename();
  $moreinfo=configmanager_moreinfo();
  $cfgmngformname = "form_logfile";
  $cfgmngfile_name = "cfgmngutilities.php";
//$message=date("Y-m-d H:i:s ")."TEST:cfgmnglogutilities\n";
//cfgmng_log($message);
  $new_item = "";
  // PART  COPY OF CACTI LOG
	/* helps determine output color */
	$linecolor = True;

	input_validate_input_number(get_request_var_request("tail_files"));
	input_validate_input_number(get_request_var_request("message_type"));
	input_validate_input_number(get_request_var_request("refresh"));
	input_validate_input_number(get_request_var_request("reverse"));

	/* clean up search filter */
	if (isset($_REQUEST["filter"])) {
		$_REQUEST["filter"] = sanitize_search_string(get_request_var("filter"));
	}

	/* if the user pushed the 'clear' button */
	if (isset($_REQUEST["clear_x"])) {
		kill_session_var("sess_logfile_tail_lines");
		kill_session_var("sess_logfile_message_type");
		kill_session_var("sess_logfile_filter");
		kill_session_var("sess_logfile_refresh");
		kill_session_var("sess_logfile_reverse");

		unset($_REQUEST["tail_lines"]);
		unset($_REQUEST["message_type"]);
		unset($_REQUEST["filter"]);
		unset($_REQUEST["refresh"]);
		unset($_REQUEST["reverse"]);
	}

	load_current_session_value("tail_lines", "sess_logfile_tail_lines", read_config_option("num_rows_log"));
	load_current_session_value("message_type", "sess_logfile_message_type", "-1");
	load_current_session_value("filter", "sess_logfile_filter", "");
	load_current_session_value("refresh", "sess_logfile_refresh", read_config_option("log_refresh_interval"));
	load_current_session_value("reverse", "sess_logfile_reverse", 1);

	$_REQUEST['page_referrer'] = 'view_logfile';
	load_current_session_value('page_referrer', 'page_referrer', 'view_logfile');
  // END  COPY OF CACTI LOG
  $refresh["seconds"] = $_REQUEST["refresh"];
  $refresh["page"] = "$cfgmngfile_name?action=view_logfile";
  $refreshtimeheader = $refresh["seconds"];
  $refresh_url= $refresh["page"];
//$message=date("Y-m-d H:i:s ")."TEST refresh_url=$refresh_url, refreshtimeheader=$refreshtimeheader\n";
//cfgmng_log($message);
  include_once("./plugins/configmanager/html/top_header.php");
  include_once("./plugins/configmanager/html/top_headerbody1.php");
  print "<form action='".$cfgmngfile_name."' name='".$cfgmngformname."' method='post'>";
/*
	include_once("./include/top_header.php");
*/
  include_once("./plugins/configmanager/html/top_headertable.php");

  $logfile = $cfgmnglogfile;
  // PART  COPY OF CACTI LOG
	html_start_box("<strong>Log File Filters</strong>", "98%", $colors["header"], "3", "center", "");

	include("./plugins/configmanager/html/inc_view_logfile_table.php");

	html_end_box();

	/* read logfile into an array and display */
	if (is_file($logfile)) $logcontents = tail_file($logfile, $_REQUEST["tail_lines"]);
	else $logcontents= array();

	if ($_REQUEST["reverse"] == 1) {
		$logcontents = array_reverse($logcontents);
	}
  // END  COPY OF CACTI LOG

	if ($_REQUEST["message_type"] > 0) {
		$start_string = "<strong>Log File</strong> [Total Lines: " . sizeof($logcontents) . " - Non-Matching Items Hidden] at ".date("Y-m-d H:i:s ");
	}else{
		$start_string = "<strong>Log File</strong> [Total Lines: " . sizeof($logcontents) . " - All Items Shown] at ".date("Y-m-d H:i:s ");
	}

  html_start_box($start_string, "98%", $colors["header"], "3", "center", "");

  $i = 0;
  $linecolor = false;
  foreach ($logcontents as $item) {
  $new_item = $item."<br>";
  // PART  COPY OF CACTI LOG
		/* determine if we are to display the line */
		switch ($_REQUEST["message_type"]) {
		case -1: /* all */
			$display = true;
			break;
		case 5: /* sql calls */
			if (substr_count($new_item, " SQL ")) {
				$display=true;
			}else{
				$display=false;
			}

			break;
		case 1: /* stats */
			if (substr_count($new_item, "STATS")) {
				$display=true;
			}else{
				$display=false;
			}

			break;
		case 2: /* warnings */
			if (substr_count($new_item, "WARN")) {
				$display=true;
			}else{
				$display=false;
			}

			break;
		case 3: /* errors */
			if (substr_count($new_item, "ERROR")) {
				$display=true;
			}else{
				$display=false;
			}

			break;
		case 4: /* debug */
			if (substr_count($new_item, "DEBUG")) {
				$display=true;
			}else{
				$display=false;
			}

			if (substr_count($new_item, " SQL ")) {
				$display=false;
			}

			break;
		default: /* all other lines */
			$display=true;
			break;
		}

		/* get the background color */
		if ((substr_count($new_item, "ERROR")) || (substr_count($new_item, "FATAL"))) {
			$bgcolor = "FF3932";
		}elseif (substr_count($new_item, "WARN")) {
			$bgcolor = "EACC00";
		}elseif (substr_count($new_item, " SQL ")) {
			$bgcolor = "6DC8FE";
		}elseif (substr_count($new_item, "DEBUG")) {
			$bgcolor = "C4FD3D";
		}elseif (substr_count($new_item, "STATS")) {
			$bgcolor = "96E78A";
		}else{
			if ($linecolor) {
				$bgcolor = "CCCCCC";
			}else{
				$bgcolor = "FFFFFF";
			}
			$linecolor = !$linecolor;
		}

		if ($display) {
			?>
			<tr bgcolor='#<?php print $bgcolor;?>'>
				<td>
					<?php print $new_item;?>
				</td>
			</tr>
			<?php
		}

		$i++;
	}
	html_end_box();
  // END COPY OF CACTI LOG
//  print "<input type='hidden' name='action' value=''>";
//  print "<input type='hidden' name='refresh' value='".$_REQUEST["refresh"]."'>";
  print "
  	  </td>
	</tr>";
  print "</table>";
  print "</form>\n";
  print "</body></html>";
    /* we use this session var to store field values for when a save fails,
    this way we can restore the field's previous values. we reset it here, because
    they only need to be stored for a single page */
    kill_session_var("sess_field_values");
//  include_once("./plugins/configmanager/html/bottom_footer.php");
}
?>
