<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Modified ....... .
    Program ........ Download/Upload configuration manager for Cacti
    Version plugin . see setup.php

    per default I will use Pancho (method TFTP)
    Contact for Pancho .... Charles Menzes http://www.pancho.org/
			, http://freshmeat.net/projects/pancho/

*******************************************************************************/

chdir('../../');
global $refresh,$refreshtimeheader,$refresh_url;
global $argumentinit,$argumentinit2,$argumentinit3;

include("./plugins/configmanager/config.php");
include("./plugins/configmanager/debug.php");
include("./plugins/configmanager/functions.php");
include("./include/auth.php");
include("./plugins/configmanager/html/hmtl-configmanager.php");
include("./plugins/configmanager/html/inc_timespan_settings.php");

// check if the remote IP address has the right to use configmanager
if (!configmanager_isinlistmanagerIPs()) {
  html_authentification_error();
  exit;
}

$ds_actions = array(
	1 => "Delete",
	2 => "reset last run time and execute in 5 minutes",
	3 => "Duplicate not implemented"
	);

$action = "";
$val=getPostGet('action',$action);

if (isset($_POST['drp_action']) && $_POST['drp_action'] == 1) {
	$action = 'delete';
}
if (isset($_POST['drp_action']) && $_POST['drp_action'] == 2) {
	$action = 'resetlastrun';
}
if (isset($_POST['drp_action']) && $_POST['drp_action'] == 3) {
	$action = 'duplicate';
}
$argumentinit="0";   // argument for top_headerbody
$argumentinit2="0"; // argument for top_headerbody

load_current_session_value("configtype", "sess_cfgmng_configtype", "tftp");
$configtype = $_REQUEST['configtype'];

$debug= read_config_option("cfgm_debug");

switch ($action) {
	case 'add':
	case 'edit':
 	  // for DEBUG in case of SQL or PHP version Problem
 	  if ($debug=="on") {
 	  	$message=date("d/m/Y H:i:s ")."start ADD / EDIT configuration's parameters\n";
 	  	cfgmng_log($message);
 	  }
	  template_add($action);
	  break;
	case 'save':
 	  // for DEBUG in case of SQL or PHP version Problem
 	  if ($debug=="on") {
 	  	$message=date("d/m/Y H:i:s ")."start SQL Save configuration's parameters in tables \n";
 	  	cfgmng_log($message);
 	  }
	  form_save();
	  break;
	case 'duplicate':
		template_duplicate($action);
		break;
	case 'delete':
		template_delete();
		break;
	case 'resetlastrun':
		template_reset_last_run();
		break;
	default:
		templates();
		break;
}

function getPostGet($variablename,&$variable) {
	$isval=0;
	if (isset($_POST[$variablename])) {
	  $variable = $_POST[$variablename];
	  $isval=1;
	} else if (isset($_GET[$variablename])) {
	  $variable = $_GET[$variablename];
	  $isval=1;
	} else if (isset($_REQUEST[$variablename])) {
	  $variable=$_REQUEST[$variablename];
	  $isval=1;
	}
	return $isval;
}

/* form_configmanager_button - draws a (save|create) and cancel button at the bottom of
     an html edit form
   @arg $cancel_url - the url to go to when the user clicks 'cancel'
   @arg $force_type - if specified, will force the 'action' button to be either
     'save' or 'create'. otherwise this field should be properly auto-detected 
   @arg $action */
function form_configmanager_button($cancel_url, $force_type = "", $action) {
	global $config;
	if (empty($force_type)) {
		if (empty($_GET["id"])) {
			$img = "button_create.gif";
			$alt = "Create";
		}else{
			$img = "button_save.gif";
			$alt = "Save";
		}
	}elseif ($force_type == "save") {
		$img = "button_save.gif";
		$alt = "Save";
	}elseif ($force_type == "create") {
		$img = "button_create.gif";
		$alt = "Create";
	}
	print "<table align='center' width='98%' style='background-color:#ffffff; border: 1px solid #000bbb;'>";
	print " <tr>";
	print "	<td bgcolor='#f5f5f5' align='right'>";
	print "<a href='".$cancel_url."'><img src='".$config['url_path']."images/button_cancel2.gif' alt='Cancel' align='absmiddle' border='0'></a>";
	print "	<input name='action' value='save' type='image' src='".$config['url_path']."images/".$img."'"
		."onclick='this.form.action=\"configmanager.php?action=save\"' alt='".$alt."' align='absmiddle' >";
	print "	</td> </tr></table>";
}

/* sql_save - saves data to an sql tainitable
   @arg $array_items - an array conng each column -> value mapping in the row
   @arg $table_name - the name of the table to make the replacement in
   @arg $key_cols - the primary key(s)
   @returns - the auto incriment id column (if applicable) */
function sql_save2($array_items, $table_name, $key_cols = "id", $autoinc = true) {
	global $cnn_id;

	while (list ($key, $value) = each ($array_items)) {
		$array_items[$key] = "\"" . $value . "\"";
	}

	$replace_result = $cnn_id->Replace($table_name, $array_items, $key_cols, FALSE, $autoinc);

	if ($replace_result == 0) {
		return 0;
	}

	/* get the last AUTO_ID and return it */
	if (($cnn_id->Insert_ID() == "0") || ($replace_result == 1)) {
		if (!is_array($key_cols)) {
			if (isset($array_items[$key_cols])) {
				return str_replace("\"", "", $array_items[$key_cols]);
			}
		}
		return 0;
	}else{
		return $cnn_id->Insert_ID();
	}
}

function form_save() {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
 global $debug;
	$errortoomuchupload=0;
	$nbrmaxupload=read_config_option("maxupload");
	$config_state= $_POST['chk_config_state'];
	if ($config_state==1) {
	  $uploadcfg = db_fetch_assoc("select * from $cfgmngtable where (state='up' and up_download='upload') ");
	  if ((sizeof($uploadcfg) > 0) && isset($uploadcfg)) {
		  $countuploadcfg=count($uploadcfg);
		  if ($countuploadcfg>=$nbrmaxupload) $errortoomuchupload=1;
	  }
	}
	$id = isset($_POST['id']) ? $_POST['id']: -1;
	$nameconfig = isset($_POST['name']) ? $_POST['name']: 'configmanager';
	if ($id>=0) {
	  $infoold = db_fetch_assoc("select * from $cfgmngtable where id = $id");
	  $countinfo=0;
	  if ($infoold[0]['name']!=$nameconfig) {
	     $info = db_fetch_assoc("select * from $cfgmngtable where name = '$nameconfig'");
	     if ((sizeof($info) > 0) && isset($info)) {
		  $val=$info[0]['id'];
		  $countinfo=count($info);
	     }
	   }
	} else {
	  $info = db_fetch_assoc("select * from $cfgmngtable where name = '$nameconfig'");
	  $countinfo=0;
	  if ((sizeof($info) > 0) && isset($info)) {
		  $val=$info[0]['id'];
		  $countinfo=count($info);
	  }
	}
	if (($countinfo>0)) {
	   	// this name exists
	   	$header= ($id>=0) ? "Location: configmanager.php?action=edit&id=$id&error=name"
	   	  	:"Location: configmanager.php?action=add&error=name";
		Header($header);
		raise_message(2); // save failed
		exit;
	} else {
		$save["id"] = ($id>=0) ? "$id" : "";
	        $save["name"] = $nameconfig;
//		$tempup_down = isset($_POST['up_download']) ? $_POST['up_download']: '0';
		load_current_session_value("configtype", "sess_cfgmng_configtype", "tftp"); //in case if
	     	$save["configtype"] = $_REQUEST['configtype'];
		$tempup_down = isset($_POST['up_download']) ? $_POST['up_download']: "download";
		if ($tempup_down=="upload") {
		   $save["up_download"]="upload";
		 } else {
		   $save["up_download"]="download";
		}
		$save["date"] = isset($_POST['date']) ? $_POST['date']: '0000-00-00 00:00:00';
		$save["path"] = isset($_POST['path']) ? $_POST['path']: read_config_option("defaultpathconfig");
		$save["pathdata"] = isset($_POST['pathdata']) ? $_POST['pathdata']: read_config_option("defaultpath");
		$save["fileupload"] = isset($_POST['fileupload']) ? $_POST['fileupload']: read_config_option("fileupload");
		$save["date"] = isset($_POST['date']) ? $_POST['date']: '0000-00-00 00:00:00';
		$save["state"] = isset($_POST['chk_config_state']) ? $_POST['chk_config_state']: 'down';
		if ($errortoomuchupload) $save["state"] = 'down';
		$save["monthly"] = isset($_POST['chk_monthly']) ? (($_POST['chk_monthly']=="on")?1:0): 0;	
		/* info of Checkboxes are only set if "on" */
		$save["mon"] = isset($_POST['chk_mon']) ? (($_POST['chk_mon']=="on")?1:0): 0;
		$save["tue"] = isset($_POST['chk_tue']) ? (($_POST['chk_tue']=="on")?1:0): 0;
		$save["wed"] = isset($_POST['chk_wed']) ? (($_POST['chk_wed']=="on")?1:0): 0;
		$save["thu"] = isset($_POST['chk_thu']) ? (($_POST['chk_thu']=="on")?1:0): 0;
		$save["fri"] = isset($_POST['chk_fri']) ? (($_POST['chk_fri']=="on")?1:0): 0;
		$save["sat"] = isset($_POST['chk_sat']) ? (($_POST['chk_sat']=="on")?1:0): 0;
		$save["sun"] = isset($_POST['chk_sun']) ? (($_POST['chk_sun']=="on")?1:0): 0;
		$save["snmp_version"] = isset($_POST['snmp_version']) ? $_POST['snmp_version']: read_config_option("cfgm_snmp_ver");
		$save["snmp_username"] = isset($_POST['snmp_username']) ? $_POST['snmp_username']: read_config_option("cfgm_snmp_username");
		$save["snmp_password"] = isset($_POST['snmp_password']) ? $_POST['snmp_password']: read_config_option("cfgm_snmp_password");
		$save["snmp_auth_protocol"] = isset($_POST['snmp_auth_protocol']) ? $_POST['snmp_auth_protocol']: "MD5";
		$save["snmp_priv_passphrase"] = isset($_POST['snmp_priv_passphrase']) ? $_POST['snmp_priv_passphrase']: "";
		$save["snmp_priv_protocol"] = isset($_POST['snmp_priv_protocol']) ? $_POST['snmp_priv_protocol']: "none";
		$save["snmp_community"] = isset($_POST['snmp_community']) ? $_POST['snmp_community']: read_config_option("cfgm_snmp_community");
		if ($save["id"]=="") $save["lastused"] = '0000-00-00 00:00:00';
		$save["command"] = isset($_POST['command']) ? $_POST['command']: '';
		$save["pre"] = isset($_POST['pre']) ? $_POST['pre']: '';
		$save["post"] = isset($_POST['post']) ? $_POST['post']: '';
		$save["fileformat"] = isset($_POST['fileformat']) ? $_POST['fileformat']: read_config_option("cfgm_pancho_fileformat");;
		$save["templatename"] = isset($_POST['templatename']) ? $_POST['templatename']: '';
		$commit = isset($_POST['commit']) ? $_POST['commit']: 0;
		$startup = isset($_POST['startup']) ? $_POST['startup']: 0;
		$save["commit"] = $commit;
		$save["startup"] = $startup;
		$save["tftp"] = isset($_POST['tftpserver']) ? $_POST['tftpserver']: read_config_option("cfgm_TFTPserver");
		$save["accepttrap"] = isset($_POST['chk_accepttrap']) ? (($_POST['chk_accepttrap']=="on")?1:0): 0;
		$save["usepancho"] = isset($_POST['chk_purephptftp']) ? (($_POST['chk_purephptftp']!="on")?1:0): 1;
		$save["binair"] = isset($_POST['chk_binary']) ? (($_POST['chk_binary']=="on")?1:0): 0;
		$id2 = sql_save2($save, "$cfgmngtable");

                // for DEBUG in case of SQL or PHP version Problem
                if ($debug=="on") {
                     $message=date("d/m/Y H:i:s ")."SQL Save configuration's parameters in tables "
                            .$cfgmngtable.". -> id result=$id2, code=".mysql_errno()
                            ." errortext=".mysql_error()."\ndata to save are :".print_r($save,true)."\n";
                     cfgmng_log($message);
                }
		if ($id2 && !$errortoomuchupload) {
			if ($id<=0) {
			  Header("Location: configmanager_edit.php?action=edit&configid=$id2&name=$nameconfig");
			} else { 
			  Header("Location: configmanager.php");
			}
			exit;
		} else {
	   	  if ($errortoomuchupload) {
	   	    $header= "Location: configmanager.php?"
			       .(($id>=0)?"action=edit&id=$id":"action=add&id=$id")."&error=upload";
	   	  } else {
	   	    $header="Location: configmanager.php?"
			       .(($id>=0)?"action=edit&id=$id":"action=add&id=$id")."&error=notsaved";
	   	  }
		  Header($header);
		  exit;
		}
	  }
}

function template_reset_last_run() {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	foreach($_POST as $t=>$v) {
		if (substr($t, 0,4) == "chk_") {
			$id = substr($t, 4);
			$sqlrequest= "update $cfgmngtable set lastused ='0000-00-00 00:00:00' where id ='$id'";
			$temp = db_fetch_assoc($sqlrequest);
		}
	}
	Header("Location: configmanager.php");
	exit;	
}

function template_delete() {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	foreach($_POST as $t=>$v) {
		if (substr($t, 0,4) == "chk_") {
			$id = substr($t, 4);
			$temp = db_fetch_assoc("delete from $cfgmngtable where id = $id LIMIT 1");
			$temp = db_fetch_assoc("delete from $cfgmngtable_data where configmanagerid = $id");
		}
	}
	$sql_save="optimize tables $cfgmngtable;";
	db_execute($sql_save);
	$sql_save="optimize tables $cfgmngtable_data;";
	db_execute($sql_save);
	Header("Location: configmanager.php");
	exit;
}

function template_duplicate($theaction) {
/* Later ....
*/
	exit;
}

function draw_edit_controlOnePassword($field_name, &$field_array) {
  switch ($field_array["method"]) {
	case 'textbox':
		form_text_box($field_name, $field_array["value"], ((isset($field_array["default"])) ? $field_array["default"] : ""), $field_array["max_length"], ((isset($field_array["size"])) ? $field_array["size"] : "40"), "text", ((isset($field_array["form_id"])) ? $field_array["form_id"] : ""));
		break;
	case 'textbox_password':
	  form_text_box($field_name, $field_array["value"], ((isset($field_array["default"])) ? $field_array["default"] : ""), $field_array["max_length"], ((isset($field_array["size"])) ? $field_array["size"] : "40"), "password");
		break;
	}
}

function draw_edit_control_withaction($formname,$functionscript,$field_name, &$field_array) {
	switch ($field_array["method"]) {
	case 'drop_array':
		form_dropdown_withaction($formname,$functionscript,$field_name, $field_array["array"], "", "", $field_array["value"], ((isset($field_array["none_value"])) ? $field_array["none_value"] : ""), ((isset($field_array["default"])) ? $field_array["default"] : ""));
		break;
	case 'checkbox':
		form_checkbox_withaction($formname,$functionscript,$field_name, $field_array["value"], $field_array["friendly_name"], ((isset($field_array["default"])) ? $field_array["default"] : ""), ((isset($field_array["form_id"])) ? $field_array["form_id"] : ""));
		break;
	default:
		break;
	}
}

function form_checkbox_withaction($formname,$functionscript,$field,$form_previous_value, $form_caption, $form_default_value, $current_id = 0) {
	if (($form_previous_value == "") && (empty($current_id))) {
		$form_previous_value = $form_default_value;
	}

	if (isset($_SESSION["sess_field_values"])) {
		if (!empty($_SESSION["sess_field_values"][$field])) {
			$form_previous_value = $_SESSION["sess_field_values"][$field];
		}
	}
	print "<input type='hidden' name='chk$field' value='$form_previous_value'>";
	print "<input type='checkbox' name='$field' id='$field'"
		." onClick='".$functionscript."(\"".$formname."\",this,\"chk$field\");'"
		. (($form_previous_value == "on") ? " checked" : "") . "> $form_caption\n";
}

function form_dropdown_withaction($formname,$functionscript,$field, $form_data, $column_display, $column_id, $form_previous_value, $form_none_entry, $form_default_value, $css_style = "") {
	if ($form_previous_value == "") {
		$form_previous_value = $form_default_value;
	}
	if (isset($_SESSION["sess_field_values"])) {
		if (!empty($_SESSION["sess_field_values"][$field])) {
			$form_previous_value = $_SESSION["sess_field_values"][$field];
		}
	}
	print "<select name='$field' style='$css_style' "
	     ."onChange='".$functionscript."(\"".$formname."\",this.value);'>\n";
	if (!empty($form_none_entry)) {
		print "<option value='0'" . (empty($form_previous_value) ? " selected" : "") . ">$form_none_entry</option>\n";
	}
	html_create_list($form_data, $column_display, $column_id, htmlspecialchars($form_previous_value, ENT_QUOTES));
	print "</select>\n";
}

function cfgmanagerreadtemplate(&$listtemplate,&$listhelp) {
	global $config;
	$listtemplate=array (
			"none"  => "",
		);
	$listhelp=array (
			"none"  => "choose a template or insert a command and click again on the help to see the help of a specific template.",
		);
	$templatefilename="plugins/configmanager/template.txt";
        $handle = @fopen($templatefilename, "r");
	if ($handle) {
           $gonext=0;
           while (!feof($handle)) {
              $buffer = ($gonext==1) ? $buffer : fgets($handle);
              if ($buffer) {
              	$linename=rtrim($buffer);
              	$pattern = '/(^#)/'; //$pattern = '/(^#)|( $)/';
                if (!(preg_match($pattern, $linename, $matches))) {
              	  $tlinename= preg_split('/=/',$linename,-1);
              	  $newname= $newcommand= $newhelp= "";
              	  if ((strtolower($tlinename[0])=="name") && ($tlinename[1]!=="")) {
              	  	// read the command and help
              	  	if (!feof($handle)) {
              	  	  if ($buffer = fgets($handle)) {
              			$linecommand=rtrim($buffer);
				$tlinecommand= preg_split('/=/',$linecommand,-1);
				if ((strtolower($tlinecommand[0])=="command") && ($tlinecommand[1]!=="")) {
					$newname=$tlinename[1];
					$newcommand=$tlinecommand[1];
					if (!feof($handle)) {
						if ($buffer = fgets($handle)) {
						  $linehelp=rtrim($buffer);
						  $tlinehelp= preg_split('/=/',$linehelp,-1);
						  if (strtolower($tlinehelp[0])=="help") {
						  	$newhelp= ($tlinehelp[1]!=="") ? $tlinehelp[1]:"";
						  } else {
							$gonext=1;
						  }
						}
					}
				} else {
				  $gonext=1;
				}
              	  	  }
              	  	}
              	  }
              	  if ($newname!=="") {
              	  	$listtemplate[$newname]=$newcommand;
              	  	$listhelp[$newname]=$newhelp;
		  }
               }
              }
          }
          if ($handle) fclose($handle);
	}
}

function choiceoftemplate($optname,$name) {
	global $config;
	print "<input type=hidden name='".$optname."' value='".$_REQUEST[$optname]."'>\n";
	cfgmanagerreadtemplate($listentry,$listhelp);
	$helptemplate="nothing found!";
	print "<select name='opt".$optname."'"
		."onChange='this.form.".$name.".value=this.form.opt".$optname.".options[this.form.opt".$optname.".selectedIndex].value;"
		."this.form.".$optname.".value=this.form.opt".$optname.".options[this.form.opt".$optname.".selectedIndex].text;"
		."'"
		." >\n";
	foreach ($listentry as $key => $entry) {
	  print "<option value='".$entry."'";
	  if ($_REQUEST[$optname] == $key) { print " selected"; $helptemplate=$listhelp[$key]; }
	  print ">" . $key . "</option>\n";
	}
	print "</select>\n";
	print "<script type='text/javascript'>\n";
	print "function findhelptext() {\n";
	print "  var Myvarel = document.formconfig.".$optname.".value;\n";
	print "  var el2 = 'listhelp_'+Myvarel;\n";
	print " var temp=document.getElementsByName(el2)[0];\n" ;
	print "  alert(temp.value);\n";
	print "}\n";
	print "</script>\n";
	foreach ($listhelp as $key => $entry) {
	  print "<input type=hidden name='listhelp_".$key."' value=\"".$listhelp[$key]."\">\n";
	}
	print "<img src='".$config['url_path']."plugins/configmanager/images/help.gif' "
		."alt='help method multi' width='25' height='25' onclick='findhelptext();'>";
}

function template_add($theaction) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
 global $config,$configmanager_snmp_versions;
 global $argumentinit,$argumentinit2,$argumentinit3;
 global $sharednetworkclasspath;
	
        $cfgm_accepttrapsylog =read_config_option("cfgm_accepttrapsylog");
	$help["tftp"]=configmanager_help();
	$help["multi"]="With method multi you can use scripts (like SCP,SSH, ...) or functions in order to archive"
	    		." devices configurations. Some template has been defined. The disavantage"
	    		." is you have to group the devices because this function and this cannot detect "
	    		."automatically the constructor or model of the device. The advantage is you "
	    		."don t need SNMP";
	$nbrmaxupload=read_config_option("maxupload");
        /* set variables for first time use */
        initialize_datetime($datetime);
	$configmanager_name=configmanager_programmename();
	$moreinfo=configmanager_moreinfo();
	// last data
        $optionedit = $optionnew = false;
        $optionnew=($theaction=="add");
        if ($theaction=="edit") $optionedit=getPostGet("id",$id);
	if ($optionnew || $optionedit) {
	    if ($iserrorconfig=isset($_GET['error'])) { $errorconfig=$_GET['error']; } else { $errorconfig=""; };
	    if ($optionedit) {
	     $info = db_fetch_assoc("select * from $cfgmngtable where id = $id");
	     if ((sizeof($info) > 0) && isset($info)) {
	     	$configtype=$info[0]['configtype'];
	        $up_downloaddef=$info[0]['up_download'];
	        $pathdef = $info[0]['path'];
	        $pathdatadef = $info[0]['pathdata'];
	        $fileuploaddef = $info[0]['fileupload'];
	        $statedef= $info[0]['state'];
		$namedef = $info[0]['name'];
		$datedef = $info[0]['date'];
		$monthlydef = ($info[0]['monthly']) ? "on" : "off";
		$mondef = ($info[0]['mon']) ? "on" : "off";
		$tuedef = ($info[0]['tue']) ? "on" : "off";
		$weddef = ($info[0]['wed']) ? "on" : "off";
		$thudef = ($info[0]['thu']) ? "on" : "off";
		$fridef = ($info[0]['fri']) ? "on" : "off";
		$satdef = ($info[0]['sat']) ? "on" : "off";
		$sundef = ($info[0]['sun']) ? "on" : "off";
		$snmp_versiondef = intval($info[0]['snmp_version']);
		$snmp_usernamedef = $info[0]['snmp_username'];
		$snmp_passworddef = $info[0]['snmp_password'];
		$snmp_auth_protocoldef = $info[0]['snmp_auth_protocol'];
		$snmp_priv_passphrasedef = $info[0]['snmp_priv_passphrase'];
		$snmp_priv_protocoldef = $info[0]['snmp_priv_protocol'];
		$snmp_communitydef = $info[0]['snmp_community'];
		$pancho_predef= $info[0]['pre'];
		$pancho_postdef= $info[0]['post'];
		$pancho_fileformatdef= $info[0]['fileformat'];
	        $commitdef = $info[0]['commit'];
	        $startupdef = $info[0]['startup'];
	        $tftpserverdef = $info[0]['tftp'];
		// method multi
	     	$templatename=$info[0]['templatename'];
	     	$command=$info[0]['command'];
		/* force reset REQUEST["templatename"] & sess_cfgmng_templatename*/
		$_REQUEST["templatename"]= $_SESSION["sess_cfgmng_templatename"]= $templatename;
		// Traps
		$accepttrapdef=($info[0]['accepttrap']) ? "on" : "off";
		// tftp method
		$purephptftpdef=($info[0]['usepancho']) ? "off" : "on";
		// for Nortel
		$binarydef = ($info[0]['binair']) ? "on" : "off";
	     }
	    } else { // Add first time
	// last choices
		load_current_session_value("configtype", "sess_cfgmng_configtype", "tftp");
		$configtype = $_REQUEST['configtype'];
 	        $pathdef= read_config_option("defaultpathconfig");
	        $pathdatadef= read_config_option("defaultpath");
	        $fileuploaddef= read_config_option("fileupload");
	        $statedef="down";
		$namedef = "configmanager";
		$monthlydef = "0";
		$mondef = $tuedef = $weddef = $thudef = $fridef = $satdef = $sundef = "off";
	    	$datedef='0000-00-00 00:00:00';
	    	$up_downloaddef="download";
		$snmp_versiondef = read_config_option("cfgm_snmp_ver");
		$snmp_usernamedef = read_config_option("cfgm_snmp_username");
		$snmp_auth_protocoldef = read_config_option("cfgm_snmp_authprotocol");
		$snmp_priv_passphrasedef = read_config_option("cfgm_snmp_authkey");
		$snmp_priv_protocoldef = read_config_option("snmp_priv_protocol");
		$snmp_passworddef = read_config_option("cfgm_snmp_password");
		$snmp_communitydef = read_config_option("cfgm_snmp_community");
		$pancho_predef= read_config_option("cfgm_pancho_pre");
		$pancho_postdef= read_config_option("cfgm_pancho_post");
		$pancho_fileformatdef= read_config_option("cfgm_pancho_fileformat");
		$tftpserverdef= read_config_option("cfgm_TFTPserver");
	        $commitdef= 0;
	        $startupdef= 0;
		// method multi
		load_current_session_value("templatename", "sess_cfgmng_templatename", "scp-cisco");
 		$templatename = $_REQUEST['templatename'];
		$command="";
		// Traps
		$accepttrapdef="off";
		$purephptftpdef="off";
		// for Nortel
		$binarydef = "off";
	    }
	    if (isset($_POST['up_download'])) {$valup_download=$_POST['up_download'];} else {$valup_download=$up_downloaddef;};
//	    if ($valup_download=="upload") { $valueup_download="1"; } else { $valueup_download="0";}
	    $valueup_download=$valup_download;
	    if (isset($_POST['path'])) {$valp=$_POST['path'];} else {$valp=$pathdef;};
            $valuepath=str_replace("\\\\","\\",$valp);
	    if (isset($_POST['pathdata'])) {$valpdata=$_POST['pathdata'];} else {$valpdata=$pathdatadef;};
            $valuepathdata=str_replace("\\\\","\\",$valpdata);
	    if (isset($_POST['file'])) {$valuefileupload=$_POST['file'];} else {$valuefileupload=$fileuploaddef;};
	    if (isset($_POST['state'])) {$valuestate=$_POST['state'];} else {$valuestate=$statedef;};
	    if (isset($_POST['name'])) {$valuename=$_POST['name'];} else {$valuename=$namedef;};
	    if (isset($_POST['date'])) {$valuedate=$_POST['date'];} else {$valuedate=$datedef;};
	    if ($theaction=="edit") $datetime["current_value_date"]=$valuedate;
	    if (isset($_POST['chk_monthly'])) {$valuemonthly=$_POST['chk_monthly'];} else {$valuemonthly=$monthlydef;};
	    if (isset($_POST['chk_mon'])) {$valuemon=$_POST['chk_mon'];} else {$valuemon=$mondef;};
	    if (isset($_POST['chk_tue'])) {$valuetue=$_POST['chk_tue'];} else {$valuetue=$tuedef;};
	    if (isset($_POST['chk_wed'])) {$valuewed=$_POST['chk_wed'];} else {$valuewed=$weddef;};
	    if (isset($_POST['chk_thu'])) {$valuethu=$_POST['chk_thu'];} else {$valuethu=$thudef;};
	    if (isset($_POST['chk_fri'])) {$valuefri=$_POST['chk_fri'];} else {$valuefri=$fridef;};
	    if (isset($_POST['chk_sat'])) {$valuesat=$_POST['chk_sat'];} else {$valuesat=$satdef;};
	    if (isset($_POST['chk_sun'])) {$valuesun=$_POST['chk_sun'];} else {$valuesun=$sundef;};
	    if (isset($_POST['snmp_version'])) {$valuesnmp_version=$_POST['snmp_version'];} else {$valuesnmp_version=$snmp_versiondef;};
	    if (!is_int($valuesnmp_version)) $valuesnmp_version=1;
	    $valuesnmp_version=(($valuesnmp_version>0)&&($valuesnmp_version<4))?$valuesnmp_version:1;
	    if (isset($_POST['snmp_username'])) {$valuesnmp_username=$_POST['snmp_username'];} else {$valuesnmp_username=$snmp_usernamedef;};
	    if (isset($_POST['snmp_password'])) {$valuesnmp_password=$_POST['snmp_password'];} else {$valuesnmp_password=$snmp_passworddef;};
	    if (isset($_POST['snmp_auth_protocol'])) {$valuesnmp_auth_protocol=$_POST['snmp_auth_protocol'];} else {$valuesnmp_auth_protocol=$snmp_auth_protocoldef;};
	    if (isset($_POST['snmp_priv_passphrase'])) {$valuesnmp_priv_passphrase=$_POST['snmp_priv_passphrase'];} else {$valuesnmp_priv_passphrase=$snmp_priv_passphrasedef;};
	    if (isset($_POST['snmp_priv_protocol'])) {$valuesnmp_priv_protocol=$_POST['snmp_priv_protocol'];} else {$valuesnmp_priv_protocol=$snmp_priv_protocoldef;};

	    if (isset($_POST['snmp_community'])) {$valuesnmp_community=$_POST['snmp_community'];} else {$valuesnmp_community=$snmp_communitydef;};
	    if (isset($_POST['pre'])) {$valuepre=$_POST['pre'];} else {$valuepre=$pancho_predef;};
	    if (isset($_POST['post'])) {$valuepost=$_POST['post'];} else {$valuepost=$pancho_postdef;};
	    if (isset($_POST['command'])) {$valuecommand=$_POST['command'];} else {$valuecommand=$command;};
	    if (isset($_POST['fileformat'])) {$valuefileformat=$_POST['fileformat'];} else {$valuefileformat=$pancho_fileformatdef;};
	    if (isset($_POST['startup'])) {$valuestartup=$_POST['startup'];} else {$valuestartup=$startupdef;};
	    if (isset($_POST['commit'])) {$valuecommit=$_POST['commit'];} else {$valuecommit=$commitdef;};
	    if (isset($_POST['tftpserver'])) {$valuetftpserver=$_POST['tftpserver'];} else {$valuetftpserver=$tftpserverdef;};
	    if ($valuetftpserver=="") {$valuetftpserver= read_config_option("cfgm_TFTPserver");};
	    if (isset($_POST['chk_accepttrap'])) {$valuesat=$_POST['chk_accepttrap'];} else {$valueaccepttrap=$accepttrapdef;};
	    if (isset($_POST['chk_purephptftp'])) {$valuesat=$_POST['chk_purephptftp'];} else {$valuepurephptftp=$purephptftpdef;};
	    if (isset($_POST['chk_binary'])) {$valuebinary=$_POST['chk_binary'];} else {$valuebinary=$binarydef;};
	    $rname = array("friendly_name" => "name",
				"method" => "textbox",
				"default" => $valuename,
				"description" => "",
				"max_length" => 99,
				"value" => $valuename );
	    $tabupdownload=  array("download" => 'download', "upload"=>'upload');
	    $rupdownload = array("friendly_name" => "direction",
				"method" => "drop_array",
				"default" => $valueup_download,
				"description" => "do you want download a configuration or upload",
				"value" => $valueup_download,
				"array" => $tabupdownload);
	    $rtftppath = array("friendly_name" => "path of the config",
				"method" => "textbox",
				"default" => $valuepath,
				"description" => "",
				"max_length" => 255,
				"value" => $valuepath );
	    $rtftppathdata = array("friendly_name" => "path of the data",
				"method" => "textbox",
				"default" => $valuepathdata,
				"description" => "",
				"max_length" => 255,
				"value" => $valuepathdata );
	    $ruploadfile = array("friendly_name" => "name of file to upload",
				"method" => "textbox",
				"default" => $valuefileupload,
				"description" => "",
				"max_length" => 255,
				"value" => $valuefileupload );
	    $rconfigstate = array("friendly_name" => "chk_config_state",
				"method" => "radio",
				"default" => $valuestate,
				"description" => "",
				"value" => $valuestate,
				"max_length" => 10,
				"items" => array(array("radio_value"=>"up",
				                       "radio_caption"=>"active"),
				                 array("radio_value"=>"down",
				                       "radio_caption"=>"paused")) );
	    $rmonthly = array("friendly_name" => "monthly",
				"method" => "checkbox",
				"default" => $valuemonthly,
				"description" => "monthly",
				"value" => $valuemonthly,
                              );
	    $rmon    = array("friendly_name" => "mon",
				"method" => "checkbox",
				"default" => $valuemon,
				"description" => "monday",
				"value" => $valuemon,
                              );
	    $rtue    = array("friendly_name" => "tue",
				"method" => "checkbox",
				"default" => $valuetue,
				"description" => "tuesday",
				"value" => $valuetue,
                              );
	    $rwed    = array("friendly_name" => "wen",
				"method" => "checkbox",
				"default" => $valuewed,
				"description" => "wenesday",
				"value" => $valuewed,
                              );
	    $rthu    = array("friendly_name" => "thu",
				"method" => "checkbox",
				"default" => $valuethu,
				"description" => "thursday",
				"value" => $valuethu,
                              );
	    $rfri    = array("friendly_name" => "fri",
				"method" => "checkbox",
				"default" => $valuefri,
				"description" => "friday",
				"value" => $valuefri,
                              );
	    $rsat    = array("friendly_name" => "sat",
				"method" => "checkbox",
				"default" => $valuesat,
				"description" => "saturday",
				"value" => $valuesat,
                              );
	    $rsun    = array("friendly_name" => "sun",
				"method" => "checkbox",
				"default" => $valuesun,
				"description" => "sunday",
				"value" => $valuesun,
                              );
	    $rsnmp_version = array("friendly_name" => "SNMP version",
				"method" => "drop_array",
				"value" => "$valuesnmp_version",
				"description" => "Default SNMP version for all hosts of a configuration.",
				"array" => $configmanager_snmp_versions );
	    $rsnmp_username = array("friendly_name" => "snmp_username",
				"method" => "textbox",
				"default" => $valuesnmp_username,
				"description" => "",
				"max_length" => 15,
				"value" => $valuesnmp_username );
	    $tabsnmp_auth_protocol=  array("MD5" => 'MD5', "SHA"=>'SHA');
	    $rsnmp_auth_protocol = array("friendly_name" => "snmp_auth_protocol",
				"method" => "drop_array",
				"default" => $valuesnmp_auth_protocol,
				"description" => "Choose the SNMPv3 Authorization Protocol.",
				"value" => $valuesnmp_auth_protocol,
				"array" => $tabsnmp_auth_protocol);
	    $tabsnmp_priv_protocol=  array("none" => 'none', "DES" => 'DES', "AES"=>'AES');
	    $rsnmp_priv_passphrase = array("friendly_name" => "snmp_priv_passphrase",
				"method" => "textbox",
				"default" => $valuesnmp_priv_passphrase,
				"description" => "Choose the SNMPv3 Privacy Passphrase.",
				"max_length" => 200,
				"value" => $valuesnmp_priv_passphrase );
	    $rsnmp_priv_protocol = array("friendly_name" => "snmp_priv_protocol",
				"method" => "drop_array",
				"default" => $valuesnmp_priv_protocol,
				"description" => "Choose the SNMPv3 Privacy Protocol.",
				"value" => $valuesnmp_priv_protocol,
				"array" => $tabsnmp_priv_protocol);

	    $methodpassw=($valuesnmp_password!="")?"textbox_password":"textbox";
	    $rsnmp_password = array("friendly_name" => "snmp_password",
				"method" => $methodpassw,
				"default" => $valuesnmp_password,
				"description" => "",
				"max_length" => 15,
				"value" => $valuesnmp_password );
	    $rsnmp_community = array("friendly_name" => "snmp_community",
				"method" => "textbox",
				"default" => $valuesnmp_community,
				"description" => "",
				"max_length" => 15,
				"value" => $valuesnmp_community );
	    $rcommand = array("friendly_name" => "command",
				"method" => "textbox",
				"size" => "160",
				"default" => $valuecommand,
				"description" => "command to send to the devices. You can use also a template",
				"max_length" => 255,
				"value" => $valuecommand );
	    $rpre = array("friendly_name" => "pre",
				"method" => "textbox",
				"size" => "100",
				"default" => $valuepre,
				"description" => "pre command of pancho. The command to be executed by pancho before the download/upload.",
				"max_length" => 250,
				"value" => $valuepre );
	    $rpost = array("friendly_name" => "post",
				"method" => "textbox",
				"size" => "100",
				"default" => $valuepost,
				"description" => "post command of pancho. The command to be executed by pancho after the download/upload.",
				"max_length" => 250,
				"value" => $valuepost );
	    $rfileformat = array("friendly_name" => "fileformat",
				"method" => "textbox",
				"size" => "50",
				"default" => $valuefileformat,
				"description" => "TFTP file format upload/download default.",
				"max_length" => 50,
				"value" => $valuefileformat );

	    $arraystartup = array(0 => "running file",1 => "startup");
	    $rstartup = array("friendly_name" => "startup or running",
				"method" => "drop_array",
				"value" => "$valuestartup",
				"description" => "choice to use the startup or running configuration.",
				"array" => $arraystartup );
	    $arraycommit = array(0 => "no save after upload",1 => "with save after upload");
	    $rcommit = array("friendly_name" => "commit",
				"method" => "drop_array",
				"value" => "$valuecommit",
				"description" => "choice to save or not the uploaded commands.",
				"array" => $arraycommit );
	    $rtftpserver = array("friendly_name" => "TFTPserver",
				"method" => "textbox",
				"size" => "15",
				"default" => $valuetftpserver,
				"description" => "TFTP server (never 127.0.0.1).",
				"max_length" => 50,
				"value" => $valuetftpserver );
	    $raccepttrap    = array("friendly_name" => "",
				"method" => "checkbox",
				"default" => $valueaccepttrap,
				"description" => "accept traps",
				"value" => $valueaccepttrap,
                              );
	    $rpurephptftp    = array("friendly_name" => "",
				"method" => "checkbox",
				"default" => $valuepurephptftp,
				"description" => "use pure php tftp method",
				"value" => $valuepurephptftp,
                              );
	    $rbinary    = array("friendly_name" => "try binary download instead ascii (ex: Nortel)",
				"method" => "checkbox",
				"default" => $valuebinary,
				"description" => "try binary download instead ascii for example for Nortel",
				"value" => $valuebinary,
                              );
	    // Header
	    $argumentinit=$valuesnmp_version;
	    $argumentinit2=($configtype=="tftp")?1:0;
	    $argumentinit3= $valueup_download;
	    $cfgmngformname = "formconfig";
	    $file_name="configmanager.php";
	    $widthtext = "28";
	    $widthtextmax = "28";
	    $textstyle = "inset";
            $fontstyleTxt="font-family:Verdana, Arial, Helvetica, sans-serif,Courier; font-size:12px; font-stretch:normal; font-weight:normal; font-style:normal;";
            $fontstyleComment="font-family:Verdana, Arial, Helvetica, sans-serif,Courier; font-size:10px; font-stretch:normal; font-weight:normal; font-style:italic;";
	    include_once("./plugins/configmanager/html/top_header.php");
//            include_once("./plugins/configmanager/html/top_headerbodycfgmng.php");
            print "<body leftmargin='0' topmargin='0' marginwidth='0' marginheight='0' background='"
                  .$config['url_path']."images/left_border.gif'"
                  ."onload='initconfigmanagerparam();'>";
//                  ."onload='initCfgMngParam(\"".$cfgmngformname."\",\"".$argumentinit."\",\"".$argumentinit2."\",\"".$argumentinit3."\");'>";
	    include_once("./plugins/configmanager/html/hmtl-calenderscripts.php");
            include_once("./plugins/configmanager/html/top_headertable.php");
	    // View
	?>
	<script type="text/javascript">
	<!--

	function hideshowfileupload() {
		up_download        = document.getElementById('up_download').value;
                //alert("The hideshowfileupload is up_download'" + up_download + "'");
		switch(up_download) {
		case "upload":
			document.getElementById('fileupload').style.display="";
			document.getElementById('txtfileupload').style.display="";
			document.getElementById('cmtfileupload').style.display="";
			break;
		default:
			document.getElementById('fileupload').style.display="none";
			document.getElementById('txtfileupload').style.display="none";
			document.getElementById('cmtfileupload').style.display="none";
			break;
		}
	}

	function hideshowsnmpparam() {
		snmp_version        = document.getElementById('snmp_version').value;
                //alert("The hideshowsnmpparam is snmp_version'" + snmp_version + "'");
		switch(snmp_version) {
		case "1":
		case "2":
		case "2c":
			document.getElementById('snmp_community').style.display="";
			document.getElementById('txtcommunity').style.display="";
			document.getElementById('snmp_username').style.display="none";
			document.getElementById('snmp_password').style.display="none";
			document.getElementById('txtuser').style.display="none";
			document.getElementById('txtpwd').style.display="none";
			document.getElementById('txtsnmp_auth_protocol').style.display="none";
			document.getElementById('snmp_auth_protocol').style.display="none";
			document.getElementById('txtsnmp_priv_passphrase').style.display="none";
			document.getElementById('snmp_priv_passphrase').style.display="none";
			document.getElementById('txtsnmp_priv_protocol').style.display="none";
			document.getElementById('snmp_priv_protocol').style.display="none";
			break;
		case "3":
			document.getElementById('snmp_community').style.display="none";
			document.getElementById('txtcommunity').style.display="none";
			document.getElementById('snmp_username').style.display="";
			document.getElementById('snmp_password').style.display="";
			document.getElementById('txtuser').style.display="";
			document.getElementById('txtpwd').style.display="";
			document.getElementById('txtsnmp_auth_protocol').style.display="";
			document.getElementById('snmp_auth_protocol').style.display="";
			document.getElementById('txtsnmp_priv_passphrase').style.display="";
			document.getElementById('snmp_priv_passphrase').style.display="";
			document.getElementById('txtsnmp_priv_protocol').style.display="";
			document.getElementById('snmp_priv_protocol').style.display="";
			break;
		}
	}

	function initconfigmanagerparam() {
		hideshowsnmpparam();
		hideshowfileupload();
	}
	-->
	</script>
	<?php
	    print "<form name='".$cfgmngformname."' action='".$file_name."' method='post'>";
	    print "<input type=hidden name='configtype' value='".$configtype."'>";
	    print "<table width='85%' style='background-color:#F5F5F5; color:#000099; padding: 5px; '>\n";
	    print "<tr>\n";
	    print " <td width='30' align='right'>";
	    if ($optionedit) {
	      // no action only picture
	      $imagemulti=($configtype=="tftp") ? ($config['url_path']."plugins/configmanager/images/multi_no.gif")
	      			: ($config['url_path']."plugins/configmanager/images/multiY.gif");
	      print "<img src='".$imagemulti."' alt='multipe' >";
	      print "</td>\n";
	      if ($configtype=="tftp") print " <td style='color:black; font-weight:normal; text-decoration:line-through; vertical-align:middle;' >";
	      else print " <td style='color:bue; font-weight:bold; text-decoration:none; vertical-align:middle;' >";
	      print "Multiple configuration type (for up/download with SSH,SCP,FTP,SFTP or scripts)";
	    } else {
	        print "<input name='multiple' value='multiple' type='image' src='"
		.$config['url_path']."plugins/configmanager/images/multi".(($configtype!=="tftp")?"Y":"N").".gif' alt='multipe'"
		." onclick='this.form.configtype.value=\"multiple\";this.form.action=\"configmanager.php?action=add\";' >";
	      print "</td>\n";
	      print " <td align='left'>";
	      print "<-- click here for method 'Multi' Multiple configuration type (for SSH,SCP,FTP,SFTP up/download or scripts)";
	    }
	    print "<img src='".$config['url_path']."plugins/configmanager/images/help.gif' alt='help method multi' width='25' height='25' onclick='alert(\"".$help["multi"]."\");'>";
	    print " </td>\n";
	    print "</tr>\n";
	    print "<tr>\n";
	    print " <td width='30' align='right'>";
	    if ($optionedit) {
	      // no action only picture
	      $imagetftp=($configtype=="tftp") ? ($config['url_path']."plugins/configmanager/images/panchoY.gif")
	      			: ($config['url_path']."plugins/configmanager/images/pancho_no.gif");
	      print "<img src='".$imagetftp."' alt='tftp' >";
	    } else {
	        print "<input name='tftp' value='tftp' type='image' src='"
		.$config['url_path']."plugins/configmanager/images/pancho".(($configtype=="tftp")?"Y":"N").".gif' alt='tftp'"
		." onclick='this.form.configtype.value=\"tftp\";this.form.action=\"configmanager.php?action=add\"' >";
	    }
	    print "</td>\n";
	    if ($configtype=="tftp") print " <td style='color:bue; font-weight:bold; text-decoration:none; vertical-align:left;' >";
	    else print " <td style='color:black; font-weight:normal; text-decoration:line-through; vertical-align:left;' >";
	    if ($optionedit) {
	      print " ";
	    } else {
	      print "<-- click here for ";
	    }
	    print "using $configmanager_name or pure PHP TFTP for up/download of configuration.";
	    print "<img src='".$config['url_path']."plugins/configmanager/images/help.gif' alt='help method multi' width='25' height='25' onclick='alert(\"".$help["tftp"]."\");'>";
	    print " </td>\n";
	    print "</tr>\n";
	    print "</table>\n";
	    $bgcolortable="#FFFFFF";
	    print "<table bgcolor='".$bgcolortable."' width='100%'>";
	    $titelbox1="configuration manager of routers/switchs";
	    ;
	    if ($configtype=="tftp") {
	    	 $titelmethod= "<br>TFTP method based on $configmanager_name $moreinfo and network class for pure PHP";
	    }
	    else {
	    	 $titelmethod= "<br>method open for your scripts";
	    }
	    if ($theaction=="add") {
	    	  $titelbox="<strong><center>create ".$titelbox1."</strong>\n"
	    	           ."</center>";
	    } else {
	          $titelbox="<strong><center>edit ".$titelbox1." $valuename (id=$id) </strong>"
	    	           ."</center>";
	    }
	    html_start_box($titelbox, "85%", $colors["header"], "2", "left", "");
	    html_header(array("task parameters", ""), 2);
            if ($theaction=="edit") {
	      print "<input type=hidden name=id value=$id>";
       	    }
       	    $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
            $txtconfiguration = "Config scheduler name";
//            $txtconfigurationcolor = "#".$colors["panel"];
	    if (isset($iserrorconfig)&& ($errorconfig=="name")) {
              $txtconfiguration .= " (already exists)";
              $txtconfigurationcolor = "red"; //'FFF000';
	    }
	    print "<td>";
	    print "<input name='txtconfiguration' type='text' value='".$txtconfiguration
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    print "</td><td>";
	    draw_edit_control("name", $rname);
	    print "</td></tr>";
       	    $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    print "<td>";
	    $txtdate = "date";
            print "<input name='txtdate' type='text' value='".$txtdate
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    print "</td><td>";
	    include_once("./plugins/configmanager/html/inc_timespan_selector.php");
	    print "</td></tr>";
       	    $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    print "<td>when</td><td>";
	    draw_edit_control("chk_monthly", $rmonthly);
	    draw_edit_control("chk_mon", $rmon);
	    draw_edit_control("chk_tue", $rtue);
	    draw_edit_control("chk_wed", $rwed);
	    draw_edit_control("chk_thu", $rthu);
	    draw_edit_control("chk_fri", $rfri);
	    draw_edit_control("chk_sat", $rsat);
	    draw_edit_control("chk_sun", $rsun);
	    print "</td></tr>";
       	    $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    print "<td>";
	    $txtaccepttrap = "accept events'traps";
	    print "<input name='txtaccepttrap' type='text' value='".$txtaccepttrap
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    print "</td><td>";
	    draw_edit_control("chk_accepttrap", $raccepttrap);
	    print "</td>";
	    print "</tr>";
//	    if ($cfgm_accepttrapsylog!="on") {
       	      //  $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      print "</td>";
              $fontstyleComment="font-family:Verdana, Arial, Helvetica, sans-serif,Courier; font-size:10px; font-stretch:normal; font-weight:normal; font-style:italic;";
              $cmtaccepttrap = "the trap events mode is globally ".(($cfgm_accepttrapsylog=="on")?"enabled":"disabled")."\n";
	      print "  <td>\n";
              print "   <textarea cols='50' rows='1' name='cmtaccepttrap' wrap='on' "
                      ."style='background-color:#".$txtconfigurationcolor.";$fontstyleComment;width:100%;border-style:none;color:".(($cfgm_accepttrapsylog=="on")?"black":"red")."' readonly>";
              print "$cmtaccepttrap";
              print "   </textarea>\n";	
	      print "</td>";
	      print "</tr>";
//	    }
       	    $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    // active paused choices ?
	    $txtactiverule = "active rule";
	    if (isset($iserrorconfig)&& ($errorconfig=="upload")) {
	      $txtactiverule .= "(too much upload are up. x>$nbrmaxupload)";
              $txtconfigurationcolor = "red";
	    }
            print "<td>";
	    print "<input name='txtactiverule' type='text' value='".$txtactiverule
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
            print "</td><td>";
            $txtconfigurationcolor = $colors["panel"];
	    draw_edit_control("chk_config_state", $rconfigstate);
	    print "</td></tr>";
	    html_header(array("Data parameters", ""), 2);
	    if ($configtype=="tftp") {
       	      $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      $txtpurephptftp = "pure tftp without pancho";
	      print "<input name='txtpurephptftp' type='text' value='".$txtpurephptftp
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	      print "</td><td>";
	      draw_edit_control("chk_purephptftp", $rpurephptftp);
	      $notexistclass=(!isset($sharednetworkclasspath)) || ($sharednetworkclasspath=="")
	    	                || (!is_dir($sharednetworkclasspath)) || (!is_file($sharednetworkclasspath."/snmp_networkclass.php"));
	      if ($notexistclass)
	      	 { print "Attention : shared networkclass do not exist ($sharednetworkclasspath)."; }
	      print "</td>";
	      print "</tr>";
       	      $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      $txttftpserver = "TFTP server";
//	      if (isset($iserrorconfig)&& ($errorconfig=="upload")) {
	      if ($valuetftpserver=="127.0.0.1") {
		   $txttftpserver .=" (error)";
		   $txtconfigurationcolor = "red";
	      }
              print "<input name='txttftpserver' type='text' value='".$txttftpserver
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
              $txtconfigurationcolor = $colors["panel"];
	      print "</td><td>";
	      draw_edit_control("tftpserver", $rtftpserver);
	      print "</td>";
	      print "</tr>";
	      $txtupload ="direction";
       	      $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      if (isset($iserrorconfig)&& ($errorconfig=="upload")) {
		   $txtupload .=" (too much upload are up)";
		   $txtconfigurationcolor = "red";
	      }
              print "<input name='txtupload' type='text' value='".$txtupload
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	      print "</td><td>";
//	      draw_edit_control("up_download", $rupdownload);
              draw_edit_control_withaction($cfgmngformname,"hideshowfileupload","up_download", $rupdownload);
	      print "</td></tr>";
	      //if ($valueup_download=="1") {
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    	print "<td>";
	    	$txtfileupload = "file to upload";
                print "<input name='txtfileupload' type='text' value='".$txtfileupload
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    	print "</td><td>";
	        draw_edit_control("fileupload", $ruploadfile);
	        print "</td></tr>";
		$widthcomment = 100;
		$widthcommentmax = 100;
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td><i>";
                print "   <textarea cols='100' rows='3' name='cmtfileupload' wrap='on' "
                      ."style='background-color:#".$txtconfigurationcolor.";$fontstyleComment;width:100%;border-style:none' readonly>";
		print "The file to be uploaded from the tftp server. The file path is relativ to the tftproot, "
			."so you can omitt it. Do not use here only one '\\' instead '\\\\' or '/'. "
			."%d% = day, %y% = year %m% = month. %c% = short name of the config. "
			."%id% = configuration id. %p% = path of the data. "
			."%r% = Tftp root path. Example: d:/data/%y%%m%/upload.cfg";
                print "   </textarea>\n";	
	    	print "</td><td>";
		print "</i></td> ";
	        print "</tr>";
	      //}
       	      $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      $txtstartup = "work on the startup or running configuration";
              print "<textarea name='txtstartup' cols='".$widthtext."' rows='2' "
                       ."readonly"
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
              print $txtstartup;
              print "</textarea>";
/*
              print "<input name='txtstartup' type='text' value='".$txtstartup
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$colors["panel"]."; border-width:2px; border-style:".$textstyle.";'>";
*/
	      print "</td><td>";
	      print "<table>";
       	      //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      draw_edit_control("startup", $rstartup);
	      print "</td>";
	        print "<td>.    (";
	        print "</td>";
	        print "<td>";
	        draw_edit_control("chk_binary", $rbinary);
	        print "</td>";
	        print "<td> )";
	        print "</td>";
	      print "</td></tr>";
	      print "</table>";
	      print "</td>";
       	      //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td></td><td><i>";
	      print "Attention: be carefull with the choice 'startup' in upload mode, because for this option you have "
			."to insert the whole configuration. When you want only change only one/few command(s) "
			."you can use 'running' with or not 'save configuration'"
			."' .";
	      print "</i></td> ";
       	      $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	      $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	      print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	      print "<td>";
	      $txtsaving = "save config on device after upload";
              print "<textarea name='txtsaving' cols='".$widthtext."' rows='2' "
                       ."readonly"
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
              print $txtsaving;
              print "</textarea>";
	      print "</td><td>";
	      draw_edit_control("commit", $rcommit);
	      print "</td></tr>";
	    } else { // some hidden fields to reduce error
              print "<input type=hidden name='up_download' value=''>";
              print "<input type=hidden name='fileupload' value=''>";
              print "<input type=hidden name='txtfileupload' value=''>";
              print "<input type=hidden name='cmtfileupload' value=''>";
	    }
	    if ($configtype=="tftp") {
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtconfigurationsfile = "path for configurations files";
                print "<input name='txtconfigurationsfile' type='text' value='".$txtconfigurationsfile
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("path", $rtftppath);
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txttftppath = "path for the data";
                print "<input name='txttftppath' type='text' value='".$txttftppath
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		$tftproot= read_config_option("cfgm_TFTPpath");
		draw_edit_control("pathdata", $rtftppathdata);
		print "</td></tr>";
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
   	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td><i>";
		print "It functions only if this path is under the TftpRoot. You have to insert only "
			."the last part after TftpRoot. At this time TftpRoot is '".$tftproot
			.". You could put %d% = day, %y% = year %m% = month %g% = path to configmanager plugins directory, %r% = Tftp root path."
			."Example if Tftproot is '/data/tftp' you can insert 'myconfig' in order to"
			."download to '/data/tftp/myconfig'. Some Tftp accepts you give for example '',"
			." so you could put your path everywhere."
			."' .";
		print "</i></td> ";
		print "</tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtfileformat ="fileformat for the downloaded file.";
	        print "<input name='txtfileformat' type='text' value='".$txtfileformat
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("fileformat", $rfileformat);
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td><i>";
		print "(default is ::HOST::.::DATE::.cfg). This setting is used to specify the pancho file format of "
			."the uploaded/downloaded file."
			." It is the Pancho conversion format. ::HOST::, ::NICK::, ::NODE::, ::FULLPATH::, ::DATE:: and "
			."::FILENAME::. For more information www.pancho.org.";
		print "</i></td> ";
	        print "</tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtprecommand ="pre command in pancho";
	        print "<input name='txtprecommand' type='text' value='".$txtprecommand
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("pre", $rpre);
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td>";
		print "This setting is used to specify the command pancho has to execute "
			."before uploaded/downloaded a file.<br>"
			."ex: (unix) if test -d '/data/%y%%m%%d%'; then mkdir /data/%y%%m%%d% fi<br>or (windows) if NOT EXIST c:\\\\data\\\\%y%%m%%d% mkdir c:\\\\data\\\\%y%%m%%d% ";
		print "</td> ";
	        print "</tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtpostcommand = "post command in pancho";
	        print "<input name='txtpostcommand' type='text' value='".$txtpostcommand
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("post", $rpost);
	        print "</td></tr>";
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td>";
		print "This setting is used to specify the command pancho has to execute "
			."after uploaded/downloaded a file.<br>"
			."ex: (unix) mv %n%.%y%%m%%d%.cfg /var/temp or (windows) move %n%.%y%%m%%d%.cfg c:\\\\temp";
		print "</td> ";
	        print "</tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td><i>";
		print "The parameters which will be exchange during the creation of the configfile for Pancho.Do not use only one '\\'.<br>"
			."%i% will be replaced by the ip addresse of the device. "
			."%n% = name of the device (hostname). "
			."%d% = day, %y% = year %m% = month. %f% = full name of the config. "
			."%s% = full log file name. %p% = path of the data. "
			."%u% = user. %w%= password. %g% = path to configmanager plugins directory. %r% = Tftp root path.";
		print "</i></td> ";
	        print "</tr>";
	    } else {
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtcommand = "command";
	        print "<input name='txtcommand' type='text' value='".$txtcommand
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("command", $rcommand);
	        print "</td></tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td><i>";
		print "The parameters which will be exchange during the execution. "
			."%i% will be replaced by the ip addresse of the device. "
			."%n% = name of the device listed in a configuration. "
			."%a% = list of all selected devices with the format host1,ip1,host2,ip2,host3,ip3,...."
			."%d% = day, %y% = year %m% = month. %f% = name of the config. "
			."%l% = log file name %s% = full log file name. %p% = path. "
			."%u% = user. %w%= password. %g% = path to configmanager plugins directory.";
		print "</i></td> ";
	        print "</tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txttemplate = "template";
	        print "<input name='txttemplate' type='text' value='".$txttemplate
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
	        choiceoftemplate("templatename","command");
		print "</td> ";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtpathlogfiles = "path for the log files (%p%)";
	        print "<input name='txtpathlogfiles' type='text' value='".$txtpathlogfiles
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("path", $rtftppath);
	        print "</tr>";

       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtprecommand ="pre command";
	        print "<input name='txtprecommand' type='text' value='".$txtprecommand
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("pre", $rpre);
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td>";
		print "This setting is used to specify the command to execute "
			."before.<br>"
			."ex: (unix) if test -d '/data/%y%%m%%d%'; then mkdir /data/%y%%m%%d% fi<br>or (windows) if NOT EXIST c:\\\\data\\\\%y%%m%%d% mkdir c:\\\\data\\\\%y%%m%%d% ";
		print "</td> ";
	        print "</tr>";
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td>";
		$txtpostcommand = "post command";
	        print "<input name='txtpostcommand' type='text' value='".$txtpostcommand
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
		print "</td><td>";
		draw_edit_control("post", $rpost);
	        print "</td></tr>";
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
		print "<td></td><td>";
		print "This setting is used to specify the command to execute "
			."after.<br>"
			."ex: (unix) mv %n%.%y%%m%%d%.cfg /var/temp or (windows) move %n%.%y%%m%%d%.cfg c:\\\\temp";
		print "</td> ";
	        print "</tr>";

	    }
	    html_header(array("Authentification", ""), 2);
	    if ($configtype=="tftp") {
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    	print "<td>";
	    	$txtsnmp_version = "snmp_version";
	        print "<input name='txtsnmp_version' type='text' value='".$txtsnmp_version
	             ."' size='".$widthtext."' maxlength='".$widthtextmax
	             ."' style='background-color:".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    	print "</td><td>";
//	 	draw_edit_control("snmp_version", $rsnmp_version);
                draw_edit_control_withaction($cfgmngformname,"hideshowsnmpparam","snmp_version", $rsnmp_version);
	   	print "</td></tr>";
	    } else { // some hidden fields to reduce error
	    	print "<input type=hidden name='snmp_version' value=''>";
	    	print "<input type=hidden name='txtsnmp_version' value=''>";
	    }
       	    $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    print "<td>";
            $txtuservalue = (($configtype=="tftp")?"snmpv3 user":"user (%u%)");
	    print "<input name='txtuser' type='text' value='".$txtuservalue
	           ."' size='".$widthtext."' maxlength='".$widthtextmax
	           ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    print "</td><td>";
	    draw_edit_control("snmp_username", $rsnmp_username);
	    print "</td></tr>";
       	    //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	    $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	    print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    print "<td>";
            $txtpwdvalue = (($configtype=="tftp")?"snmpv3 password":"password (%w%)");
	    print "<input name='txtpwd' type='text' value='".$txtpwdvalue
	           ."' size='".$widthtext."' maxlength='".$widthtextmax
	           ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
            print "</td><td>";
	    draw_edit_controlOnePassword("snmp_password", $rsnmp_password);
	    print "</td></tr>";
	    if ($configtype=="tftp") {
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	    	print "<td>";
	    	$txtcommunityvalue="community:";
                print "<input name='txtcommunity' type='text' value='".$txtcommunityvalue
                       ."' size='".$widthtext."' maxlength='".$widthtextmax
                       ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	    	print "</td><td>";
		draw_edit_control("snmp_community", $rsnmp_community);
		print "</td></tr>";
		// snmp v3 for tftp
       	        $alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	        print "<td>";
                $txtsnmp_auth_protocol = "SNMP Auth Protocol (v3)";
	        print "<input name='txtsnmp_auth_protocol' type='text' value='".$txtsnmp_auth_protocol
	           ."' size='".$widthtext."' maxlength='".$widthtextmax
	           ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	        print "</td><td>";
	        draw_edit_control("snmp_auth_protocol", $rsnmp_auth_protocol);
	        print "</td></tr>";
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	        print "<td>";
                $txtsnmp_priv_passphrase = "SNMP Privacy Passphrase (v3)";
	        print "<input name='txtsnmp_priv_passphrase' type='text' value='".$txtsnmp_priv_passphrase
	           ."' size='40' maxlength='200"
	           ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	        print "</td><td>";
	        draw_edit_control("snmp_priv_passphrase", $rsnmp_priv_passphrase);
	        print "</td></tr>";
       	        //$alternatenbr= (isset($alternatenbr)) ? ($alternatenbr+1) : 1;
	        $txtconfigurationcolor = (($alternatenbr%2)==0) ? $colors["light"] : $colors["alternate"];
	        print "<tr style='background-color:#".$txtconfigurationcolor.";' >";
	        print "<td>";
                $txtsnmp_priv_protocol = "SNMP Privacy Protocol (v3)";
	        print "<input name='txtsnmp_priv_protocol' type='text' value='".$txtsnmp_priv_protocol
	           ."' size='".$widthtext."' maxlength='".$widthtextmax
	           ."' style='background-color:#".$txtconfigurationcolor."; border-width:2px; border-style:".$textstyle.";".$fontstyleTxt."'>";
	        print "</td><td>";
	        draw_edit_control("snmp_priv_protocol", $rsnmp_priv_protocol);
	        print "</td></tr>";
	    }

	    $buttontyp="create";
            if ($theaction=="edit") $buttontyp="save";
	    print "</table>";
	    form_configmanager_button("configmanager.php", $buttontyp,"configmanager.php?action=save");
	    html_end_box();
	    return;
	}
       include_once("./plugins/configmanager/html/bottom_footer.php");
}

function templates() {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	global $colors, $ds_actions;
	global $argumentinit,$argumentinit2;
	$configmanager_name=configmanager_programmename();
	$moreinfo=configmanager_moreinfo();

        $cfgmngformname = "formconfig";
	// Header
	include_once("./plugins/configmanager/html/top_header.php");
        include_once("./plugins/configmanager/html/top_headerbody1.php");
        include_once("./plugins/configmanager/html/top_headertable.php");
	print "<form name='".$cfgmngformname."' action='configmanager.php' method='post'>";
        // View
	print "<table align='center' width='98%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>";
	print "	<tr> <td color='#000099' bgcolor='#f5f5f5' align='left'>";
	$ip=$_SERVER['REMOTE_ADDR']; print " Your IP address is: " . $ip . ".";
	if (isset($REMOTE_ADDR)) {
	  $youripaddress = GetHostByName($REMOTE_ADDR);
	  print " Your IP address is: " . $youripaddress . ".";
	}
	print "</td>";
	print "<td></td>";
	print "</tr>";
	print "</table>";
	$boxtext1="<strong>For tftp method upload/download configuration manager based of ".$configmanager_name;
	if ($moreinfo!="") { $boxtext1=$boxtext1." (".$moreinfo.")<br>For multi can you use SSH, SCP, FTP, ... </strong>";}
	else {$boxtext1=$boxtext1."</strong>";};
	html_start_box($boxtext1, "98%", $colors["header"], "8", "center", "configmanager.php?action=add");
	html_header_checkbox(array("config","method","Name","up/down-load", "Time", "active/paused","last run"));

	$sqlrequest="select * from $cfgmngtable order by name";
	$template_list = db_fetch_assoc($sqlrequest);
//print "SQL->$sqlrequest\n<br>".print_r($template_list,true)."<br>";
	$i = 0;
	$m = array('00','15','30','45');
	if (sizeof($template_list) > 0) {
	foreach ($template_list as $template) {
		$curr_color= form_alternate_row_color($colors["alternate"],$colors["light"],$i);
			?>
			<td width=15>
				<a class="linkEditMain" href="configmanager.php?action=edit&id=<?php print $template["id"];?>"><img src='images/edit-schedule.png' border=0 style='background-color:<?php print "#".$curr_color; ?>;' ></a>
			</td>
			<td>
				<?php print $template['configtype'];?>
			</td>
			<td>
				<a class="linkEditMain" href="configmanager_edit.php?action=edit&configid=<?php print $template["id"];?>&name=<?php print $template["name"];?>"><?php print $template["name"];?></a>
			</td>
			<td>
				<?php print $template['up_download'];?>
			</td>
			<td>
				<?php print $template['date'];?>
			</td>
			<td>
				<?php print (($template['state']=="up")?"active":"paused");?>
			</td>
			<td>
				<?php print $template['lastused'];?>
			</td>
			<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
				<input type='checkbox' style='margin: 0px;' name='chk_<?php print $template["id"];?>' title="<?php print $template["name"];?>">
			</td>
		</tr>
		<?php
		$i++;
	}
	}else{
		print "<tr><td><em>No Download / Upload configuration through ".$configmanager_name." </em></td></tr>\n";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	print "<table align='center' width='98%'>";
	print "<tr>";
	print " <td width='1' valign='top'>";
	print "  <img src='".$config['url_path']."images/arrow.gif' alt='' align='absmiddle'>&nbsp;";
	print " </td>
		<td align='right'>Choose an action:";
	form_dropdown("drp_action",$ds_actions,"","","1","","");
	print "	</td>
		<td width='1' align='right'>";
	print "   <input type='image' src='".$config['url_path']."images/button_go.gif' "
		." onclick='var txt;"
		."if (document.".$cfgmngformname.".drp_action.value==1)"
		." {xtxt=\"".$ds_actions[1]."\";} else {xtxt=\"".$ds_actions[2]."\";};"
		."var r=confirm(\"Do you really want \"+xtxt+\" ?\"); "
		." if (r==true) {return true;} "
		."   else {document.".$cfgmngformname.".drp_action.value=\"stop\";return false; }'"
	."alt='Go'>";
	print " </td>
		</tr>";
	print "</table>";
	print "<input type='hidden' name='action' value=''>";

	print "</form>\n";
       include_once("./plugins/configmanager/html/bottom_footer.php");
}

?>
