
CREATE TABLE IF NOT EXISTS plugin_cfgmng_basis (
  id int(11) NOT NULL auto_increment,
  version varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;
INSERT INTO plugin_cfgmng_basis (id, version) VALUES (1, '0.5f');

CREATE TABLE IF NOT EXISTS plugin_cfgmng_trap (
  id int(11) NOT NULL auto_increment,
  lastanalyzed datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;

CREATE TABLE IF NOT EXISTS plugin_cfgmng(
  id int(10) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  configtype varchar(10) NOT NULL default 'tftp',
  state enum('up','down','error','failed') NOT NULL default 'down',
  PCmanager varchar(100) NOT NULL default '',
  up_download enum('download','upload') NOT NULL default 'download',
  path varchar(100) NOT NULL default '',
  pathdata varchar(100) NOT NULL default '',
  fileupload varchar(100) NOT NULL default '',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  monthly  tinyint(11) NOT NULL default '0',
  mon  tinyint(11) NOT NULL default '0',
  tue  tinyint(11) NOT NULL default '0',
  wed  tinyint(11) NOT NULL default '0',
  thu  tinyint(11) NOT NULL default '0',
  fri  tinyint(11) NOT NULL default '0',
  sat  tinyint(11) NOT NULL default '0', 
  sun  tinyint(11) NOT NULL default '0',
  lastused datetime default '0000-00-00 00:00:00',
  snmp_version tinyint(1) unsigned NOT NULL default '1',
  snmp_username varchar(100) NOT NULL default '',
  snmp_password varchar(100) NOT NULL default '',
  snmp_community varchar(100) NOT NULL default '',
  command varchar(255) NOT NULL default '',
  templatename varchar(100) NOT NULL default '',
  post varchar(250) NOT NULL default '',
  pre varchar(250) NOT NULL default '',
  fileformat varchar(50) NOT NULL default '::HOST::.::DATE::.cfg',
  commit tinyint(1) unsigned NOT NULL default '0',
  startup tinyint(1) unsigned NOT NULL default '0',
  reload tinyint(1) unsigned NOT NULL default '0',
  tftp varchar(100) NOT NULL default '',
  usepancho  tinyint(11) NOT NULL default '1',
  accepttrap  tinyint(11) NOT NULL default '0',
  finishlog  tinyint(11) NOT NULL default '0',
  delay  int(10) NOT NULL default '0',
  binair  tinyint(11) NOT NULL default '0',
  KEY id (id)
) TYPE=MyISAM;


CREATE TABLE IF NOT EXISTS plugin_cfgmng_data (
  id int(10) NOT NULL auto_increment,
  configmanagerid int(10) NOT NULL default '0',
  hostid int(10) NOT NULL default '0',
  hostname varchar(100) NOT NULL default '',
  hostip varchar(100) NOT NULL default '',
  snmp_version tinyint(1) unsigned NOT NULL default '1',
  hostuser varchar(100) NOT NULL default '',
  hostpassword varchar(100) NOT NULL default '',
  hostcommunity varchar(100) NOT NULL default '',
  state enum('enable','disable','error','failed') NOT NULL default 'enable',
  gorder int(5) NOT NULL default '0',
  KEY id (id)
) TYPE=MyISAM;
