<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Modified ....... .
    Program ........ Download/Upload configuration manager for Cacti

    per default I will use Pancho
    Contact for Pancho .... Charles Menzes http://www.pancho.org/
			, http://freshmeat.net/projects/pancho/

*******************************************************************************/

chdir('../../');
include("./plugins/configmanager/config.php");
include("./plugins/configmanager/debug.php");
include("./plugins/configmanager/functions.php");
include("./plugins/configmanager/configmanager_gateway_method_multi.php");
include("./plugins/configmanager/html/hmtl-configmanager.php");
include("./include/auth.php");

// check if the remote IP address has the right to use configmanager
if (!configmanager_isinlistmanagerIPs()) {
  html_authentification_error();
  exit;
}

define("REMOVE","1");
define("ENABLE","2");
define("DISABLE","3");
define("ADD","4");

$ds_actions = array(
	REMOVE => "Remove from config",
	ENABLE => "enable in config",
	DISABLE => "disable in config",
	);

$ds_actions2 = array(
	ADD => "Add into config",
	);

$action = "";
if (isset($_POST['action'])) {
	$action = $_POST['action'];
} else if (isset($_GET['action'])) {
	$action = $_GET['action'];
}

if (isset($_POST['configid'])) {
	$configid = $_POST['configid'];
} else
  if (isset($_GET['configid'])) {
	$configid = $_GET['configid'];
  }

if (isset($_GET['name'])) {
	$configname = $_GET['name'];
} else {
  if (isset($_POST['name'])) {
	$configname = $_POST['name'];
  }
}

if ($action=="clear") {
		kill_session_var("sess_device_filter");
		kill_session_var("sess_device_host_template_id");
		unset($_REQUEST["filter"]);
		unset($_REQUEST["host_template_id"]);
} else {
  if (isset($_POST['drp_action']) && $_POST['drp_action'] == REMOVE) {
	$action = 'remove';
  }
  if (isset($_POST['drp_action']) && $_POST['drp_action'] == ENABLE) {
	$action = 'enable';
  }
  if (isset($_POST['drp_action']) && $_POST['drp_action'] == DISABLE) {
	$action = 'disable';
  }
  if (isset($_POST['drp_action']) && $_POST['drp_action'] == ADD) {
	$action = 'add';
  }
}

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var_request("host_template_id"));
	/* ==================================================== */
	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("filter", "sess_device_filter", "");
	load_current_session_value("host_template_id", "sess_device_host_template_id", "-1");

switch ($action) {
	case 'save':
	case 'add': 
		form_save($configid,$configname);
		break;
	case 'swap':
		template_swap($configid,$configname);
		break;
	case 'remove':
		template_delete($configid,$configname);
		break;
	case 'edit': 
	default:
//		include_once("./include/top_header.php");
		templates($configid,$configname);
//		include_once("./include/bottom_footer.php");
		break;
}

function template_swap($configid,$configname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	$id = $_GET['id'];
	$move = $_GET['move'];
	$t = db_fetch_assoc("select gorder from $cfgmngtable_data where configmanagerid = $configid order by gorder DESC LIMIT 1");
	$b = $t[0]['gorder'];

	$t = db_fetch_assoc("select gorder from $cfgmngtable_data where id = $id");
	$gorder = $t[0]['gorder'];
	$gorder2 = $gorder;
	if ($move == 'up' && $gorder != 1)
		$gorder2 = $gorder - 1;
	if ($move == 'down' && $gorder != $b)
		$gorder2 = $gorder + 1;

	$t = db_fetch_assoc("update $cfgmngtable_data set gorder = $gorder where configmanagerid = $configid and gorder = $gorder2");
	$t = db_fetch_assoc("update $cfgmngtable_data set gorder = $gorder2 where id = $id");
	
	Header("Location: configmanager_edit.php?action=edit&configid=$configid&name=$configname");
	exit;
}

function template_delete($configid,$configname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	foreach($_POST as $t=>$v) {
		if (substr($t, 0,4) == "chk_") {
			$id = substr($t, 4);
			//if ($id<0) $id=-$id;
			$t = db_fetch_assoc("select gorder from $cfgmngtable_data where configmanagerid=$configid and hostid = $id");
			$temp = db_fetch_assoc("delete from $cfgmngtable_data where configmanagerid=$configid and hostid ='$id'");
			if (sizeof($t) > 0) {
			  order_remove ($t[0]['gorder'],$configid,$configname);
			}
		}
	}
	Header("Location: configmanager_edit.php?action=edit&configid=$configid&name=$configname");
	exit;
}

/* sql_save - saves data to an sql table
   @arg $array_items - an array containing each column -> value mapping in the row
   @arg $table_name - the name of the table to make the replacement in
   @arg $key_cols - the primary key(s)
   @returns - the auto incriment id column (if applicable) */
function sql_save2($array_items, $table_name, $key_cols = "id", $autoinc = true) {
	global $cnn_id;

	while (list ($key, $value) = each ($array_items)) {
		$array_items[$key] = "\"" . $value . "\"";
	}

	$replace_result = $cnn_id->Replace($table_name, $array_items, $key_cols, FALSE, $autoinc);

	if ($replace_result == 0) {
		return 0;
	}

	/* get the last AUTO_ID and return it */
	if (($cnn_id->Insert_ID() == "0") || ($replace_result == 1)) {
		if (!is_array($key_cols)) {
			if (isset($array_items[$key_cols])) {
				return str_replace("\"", "", $array_items[$key_cols]);
			}
		}
		return 0;
	}else{
		return $cnn_id->Insert_ID();
	}
}

function form_save($configid,$configname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	$failed = false;
	foreach($_POST as $t=>$v) {
	  $pref=substr($t, 0,5);
	  if (($pref == "chk2_") or ($pref == "chkM_")){
	    $id = substr($t, 5);
	    if ($pref == "chkM_") {
	    	// mactrac data
		$temp = db_fetch_assoc("SELECT hostname FROM mac_track_devices WHERE device_id=$id");
		$id=-$id;
	    } else {
		$temp = db_fetch_assoc("SELECT hostname, snmp_community,snmp_version,snmp_username,snmp_password FROM host WHERE id=$id");
	    }
	    $temp2 = db_fetch_assoc("SELECT hostid FROM $cfgmngtable_data WHERE configmanagerid=$configid and hostid=$id");
	    $temp3 = db_fetch_assoc("select gorder from $cfgmngtable_data where configmanagerid = $configid order by gorder DESC LIMIT 1");
	    $tempconfig = db_fetch_assoc("SELECT * FROM $cfgmngtable where id=configid");
	    if (isset($temp3[0]['gorder']))
		$gorder = $temp3[0]['gorder'] + 1;
	    else
		$gorder = 1;
	    if ((sizeof($temp) > 0) && (sizeof($temp2) == 0)) {
		$hostname= $temp[0]['hostname'];
		$save["id"] = '';
		$save["configmanagerid"] = $configid;
		$save["hostid"] = $id;
		$save["hostname"] = $hostname;
		$save["hostip"] = GetHostByName($hostname);
		$ver = $tempconfig[0]['snmp_version'];
		if ($tempconfig[0]['configtype']!="tftp") $ver = 1;
		$save["snmp_version"] = $ver;
		$save["hostuser"] = $tempconfig[0]['snmp_username'];
		$save["hostpassword"] = $tempconfig[0]['snmp_password'];
		$save["hostcommunity"] = $tempconfig[0]['snmp_community'];
		$save["state"] = 'enable';
		$save["gorder"] = $gorder;
		$gid = sql_save2($save, $cfgmngtable_data);
/*
//for DEBUG in case of SQL or PHP version Problem
$message=date("d/m/Y H:i:s ")."SQL Save configuration's hosts in tables ".$cfgmngtable_data.". -> id result=$gid, code=".mysql_errno()
." errortext=".mysql_error()."\ndata to save are :".print_r($save,true)."\n";
cfgmng_log($message);
*/
		if (!$gid) $failed = true;
	    }
	  }
	}
	if (!$failed) {
		Header("Location: configmanager_edit.php?action=edit&configid=$configid&name=$configname");
		exit;
	} else {
		Header("Location: configmanager_edit.php?action=edit&configid=$configid&name=$configname");
		exit;
	}
	exit;
}

function order_remove ($order,$configid,$configname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	global $configid;
	$temp = db_fetch_assoc("select id, gorder from $cfgmngtable_data where configmanagerid = $configid and gorder > $order order by gorder");
	if (isset($temp[0]['gorder'])) {
		foreach ($temp as $t) {
			$j = db_fetch_assoc("update $cfgmngtable_data set gorder = $order where id = " . $t['id']);
			$order++;
		}
	}
}

function templates($configid,$configname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	global $argumentinit,$argumentinit2;
	global $colors, $ds_actions, $ds_actions2;
	global $config;

        $cfgmngformname = "formconfig";
	// Header
        $form_name1='form_devices';
        $cfgmngformname = $form_name1;
	include_once("./plugins/configmanager/html/top_header.php");
        include_once("./plugins/configmanager/html/top_headerbody1.php");
        include_once("./plugins/configmanager/html/top_headertable.php");
        // View
	$withmactracold= (isset($_SESSION["sess_device_from_mactrac"])) ? $_SESSION["sess_device_from_mactrac"] : "0";
	load_current_session_value("withmactrac", "sess_device_from_mactrac", "0");
	$withmactrac= $_REQUEST["withmactrac"];
	if ($withmactracold!==$withmactrac) {
	  // after a change reset of the templatefilter
	  $_REQUEST["host_template_id"] = $_SESSION["sess_device_host_template_id"]="-1";
	}
	
	$filter=$_REQUEST["filter"];
	$templateid=$_REQUEST["host_template_id"];
	$sql_where= $sql_where_mactrac ="";
	if ($filter!="") $sql_where = " where (host.hostname like '%%" . $filter. "%%')";
//no more description		    . "%%' OR host.description like '%%" . $filter . "%%')";
	if ($filter!="") $sql_where_mactrac = " where (mac_track_devices.hostname like '%%" . $filter . "%%')";
//no more description		    . "%%' OR mac_track_devices.description like '%%" . $filter . "%%')";

	$actionbegin="configmanager_edit.php?";
	$actionfirstparam="action=edit&configid=$configid&name=$configname";
	$action = $actionbegin . $actionfirstparam . "&host_template_id=" . $templateid;
//		. "&filter=" . $filter;

        print "<script type='text/javascript' >";
	include("./plugins/configmanager/otherjava.js");
        print "</script>";
	print "<form name='$form_name1'  method='post'>";

	$tempconfig = db_fetch_assoc("SELECT * FROM $cfgmngtable where id=$configid");
	$snmp_versiondef = read_config_option("cfgm_snmp_ver");
	$snmp_usernamedef = read_config_option("cfgm_snmp_username");
	$snmp_passworddef = read_config_option("cfgm_snmp_password");
	$snmp_communitydef = read_config_option("cfgm_snmp_community");
	if (sizeof($tempconfig) > 0) {
	  $snmp_communitycfg = $tempconfig[0]['snmp_community'];
	  $snmp_versioncfg = $tempconfig[0]['snmp_version'];
	  $snmp_usernamecfg = $tempconfig[0]['snmp_username'];
	  $snmp_passwordcfg = $tempconfig[0]['snmp_password'];
	  $configtype=$tempconfig[0]['configtype'];
	} else {
	  // should never be here
	  $snmp_communitycfg = $snmp_communitydef;
	  $snmp_versioncfg = $snmp_versiondef;
	  $snmp_usernamecfg = $snmp_usernamedef;
	  $snmp_passwordcfg = $snmp_passworddef;
	  $configtype="tftp";
	}
	if ($templateid == "-1") {
	  /* Show all items */
	} elseif ($templateid == "0") {
	    $sql_where .= ($filter!="") ? " and host.host_template_id=0"
	    				: " where host.host_template_id=0";
	  }elseif (!empty($templateid)) {
		$sql_where .= ($filter!="") ? " and host.host_template_id=" . $templateid
					    : " where host.host_template_id=" . $templateid;
		$sql_where_mactrac .= ($filter!="") ? " and mac_track_devices.site_id='" . $templateid."'"
					    : " where mac_track_devices.site_id='" . $templateid."'";
	   }

	$sql_request="SELECT id, hostname, snmp_community,snmp_version,snmp_username,snmp_password FROM host "
			.$sql_where." ORDER BY id";
	$temphosts = db_fetch_assoc($sql_request);
	// if mac_trac exist ...
	$sql_request="SELECT device_id, hostname, device_type_id FROM mac_track_devices "
			." ORDER BY device_id";
	$mactrac = db_fetch_assoc($sql_request);
	$existmactrac= 0;
	if (sizeof($mactrac) > 0) {
		$existmactrac= 1;
	} else {
		$existmactrac= 0;
		$withmactrac= 0;
	}
	if ($withmactrac) {
		$sql_request="SELECT device_id, hostname, device_type_id,site_id FROM mac_track_devices "
			.$sql_where_mactrac." ORDER BY device_id";
		$mactrac = db_fetch_assoc($sql_request);
	}
	$temp= ($withmactrac) ? $mactrac : $temphosts;
	$deviceid= ($withmactrac) ? "device_id": "id";
	
	$hosts = array();
	$snmp_community = array();
	$snmp_version = array();
	$snmp_username = array();
	$snmp_password  = array();
	if (sizeof($temp) > 0) {
	 foreach ($temp as $h) {
		$theid= $h[$deviceid];
		$hosts[$theid] = $h['hostname'];
//later		$snmp_community[$theid] = $h['snmp_community'];
//later		$snmp_version[$theid] = $h['snmp_version'];
//later		$snmp_username[$theid] = $h['hostuser'];
//later		$snmp_password[$theid] = $h['hostpassword'];
		$snmp_community[$theid] = $snmp_communitycfg;
		$snmp_version[$theid] = $snmp_versioncfg;
		$snmp_username[$theid] = $snmp_usernamecfg;
		$snmp_password[$theid] = $snmp_passwordcfg;
	 }
	}
	$template_list = db_fetch_assoc("select * from $cfgmngtable_data where configmanagerid = $configid order by gorder");
	if ($configtype=="tftp") {
		cfgmng_createTFTPconfig($configid,TRUE,$fullconfigname);
		$fulllogfile=$fullconfigname.".log";
	}
	else {
		$fulllogfile=configmanager_createlogfilename($tempconfig[0]);
	}
	$ipserver=$_SERVER['SERVER_NAME'];
	print "<table align='center' width='98%' style='background-color: #ffffff; border: 1px solid #bbbbbb;'>";
	if ($configtype=="tftp") {
	  print "	<tr> ";
	  print "<td width=15 color='#000099' bgcolor='#f5f5f5' align='left'>";
	  print "  <a class='linkEditMain' href='http://".$ipserver.$config['url_path']
	  		."plugins/configmanager/configmanagershow.php?action=show&nameconfig=".$fullconfigname."'><img src='images/edit-tool.gif' border=0></a>";
	  print " </td>";
	  print "<td>";
	  print "  <b>show final configuration file=".$fullconfigname." </b>";
	  print "</td>";
	  print "	</tr> ";
	}
	print "	<tr> ";
	if (file_exists($fulllogfile)) {
	 print "<td width=15 color='#000099' bgcolor='#f5f5f5' align='left'>";
	 print "  <a class='linkEditMain' href='http://".$ipserver.$config['url_path']
		."plugins/configmanager/configmanagershow.php?action=show&nameconfig=".$fulllogfile."'><img src='images/edit-tool.gif' border=0></a>";
	 print " </td>";
	}
	if (file_exists($fulllogfile)) {
	 print "<td>";
	 print "  <b>show last log file=".$fulllogfile." </b>";
	 print "</td>";
	}
	
	print "</tr>";
	print "</table>";

//TEST	print "<form action='configmanager_edit.php' method='post'>";
	print "<input type=hidden name='configid' value='$configid'>";
	print "<input type=hidden name='name' value='$configname'>";
	html_start_box("<strong>configmanager configuration of '$configname' (id=$configid)</strong>", "98%"
	              , $colors["header"], "4", "center", "");
	$prefix1="chk";
	if ($configtype=="tftp") {
	  if ($snmp_versioncfg!="3") $a_column = array("Host", "Ip","community","snmp version","state","");
	  else $a_column = array("Host", "Ip","snmp version","user","password","state","");
	}
	else {
	  $a_column = array("Host", "Ip","user","password","state","");
	}
	html_header_severalcheckbox($a_column,"",$form_name1,$prefix1);
	$hassomewrongdevices=false;
	$i = 0;
	if (sizeof($template_list) > 0) {
	   foreach ($template_list as $template) {
		$acthost= $template["hostname"];
		$hostid= $template['hostid'];
                // check if id is in mactrac or host. If not the host coulod be removed
                $isthere=false;
                if ($hostid>=0) {
                  $sql_requestisthere1="SELECT id, hostname FROM host "
			." where ((host.hostname='".$acthost."'));";  //(host.id='".$hostid."') and 
                  $isinhost = db_fetch_assoc($sql_requestisthere1);
                  if (sizeof($isinhost)>0) $isthere=true;
                }
                if ((!$isthere) && $existmactrac && ($hostid<0)) {
                   $sql_requestisthere2="SELECT device_id, hostname FROM mac_track_devices "
                 	 ." where ((mac_track_devices.hostname='".$acthost."'));"; //(mac_track_devices.device_id='".(-$hostid)."') and 
                   $isinmactrac = db_fetch_assoc($sql_requestisthere2);
                   if (sizeof($isinmactrac)>0) $isthere=true;
                }
                if (!$isthere) $hassomewrongdevices=true;
                // yset the color
//		if ($isthere) form_alternate_row_color('red','red',$i); //form_alternate_row_color($colors["alternate"],$colors["light"],$i);
//		else form_alternate_row_color('red','red',$i);
		if ($isthere) $thecolor=($i&0x1)?$colors["alternate"]:$colors["light"];
		else $thecolor='red';
		print "<tr style='background-color:".$thecolor."'>";
		print " <td style='width:20pc; text-align:left;'>".$acthost."</td>";
		print " <td style='width:12pc; text-align:left;'>".$template['hostip']."</td>";
	        if ($configtype=="tftp") {
		  if ($snmp_versioncfg!="3") print "<td>".$snmp_communitycfg ."</td>";
		  print "<td>".$snmp_versioncfg."</td>";
		  if ($snmp_versioncfg=="3") print "	<td>".$snmp_usernamecfg ."</td>";
		  if ($snmp_versioncfg=="3") print "	<td>"."*" ."</td>";
		}
		else {
		  print "	<td>".$snmp_usernamecfg ."</td>";
		  print "	<td>"."*" ."</td>";
	        }
		print "	<td style='width:10pc; text-align:left;'>".$template['state']."</td>";
		print "	<td>";
		print "	 <a href=configmanager_edit.php?action=swap&configid=".$configid."&id=".$template['id']."&name=".$configname."&move=down>
			   <img src=../../images/move_down.gif border=0></a>";
		print " 	<a href=configmanager_edit.php?action=swap&configid=".$configid."&id=".$template["id"]."&name=".$configname."&move=up>
			   <img src=../../images/move_up.gif border=0></a>";
		print "	</td>";
		print "	<td style='".get_checkbox_style()."' width='1%' align='right'>
			    <input type='checkbox' style='margin: 0px;' 
			           name='".$prefix1."_".$hostid."' title='".$template["id"]."'>";
		print "	</td>";
		print "	</tr>";
		$i++;
	   }
	}else{
		print "<tr><td><em>No hosts in the config</em></td></tr>\n";
	}
	html_end_box(false);
	draw_actions_dropdown($ds_actions);
	if ($hassomewrongdevices) {
          $fontalert="font-family:Verdana, Arial, Helvetica, sans-serif,Courier; font-size:20px; font-weight:bolder;"
                     ." color:red; font-stretch:normal; background-color: #ffffff;";
	  print "<table align='center' width='98%' style='background-color: #ffffff; border: 0px solid #bbbbbb;'>";
	  print "<tr>";
	  print "<td style='".$fontalert."' align='left'>";
          print "<img src='".$config['url_path']."plugins/configmanager/images/state_warning.gif' >";
          print " some device are no more in cacti or mac trac";
	  print "</td>";
	  print "</tr>";
	  print "</table>";
	}
	print "</form>\n";

	// selection of hosts
	$actionbegin2="configmanager_edit.php?";
	$actionfirstparam2="action=add&configid=$configid&name=$configname";
	$form_name2="form_devices2";
//TEST	print "<form name='$form_name2' action='".$actionbegin2.$actionfirstparam2."' method='post'>";
	print "<form name='$form_name2' action='".$actionbegin2.$actionfirstparam2."' method='post'>";
	print "<input type=hidden name='configid' value='$configid'>";
	print "<input type=hidden name='name' value='$configname'>";
	$titleinserthost= "<strong>List of the hosts to insert"
			. (($withmactrac) ? " (using MacTrac devices)": " (using cacti devices)")
			. "</strong>";
	html_start_box($titleinserthost, "98%", $colors["header"], "4", "center","");
	include("./plugins/configmanager/html/inc_device_filter_table.php");
	$prefix2= ($withmactrac) ? "chkM" : "chk2";
	html_end_box(false);
	draw_actions_dropdown($ds_actions2);
	html_start_box_withouttitle("98%", $colors["light"], "4", "center");
//later
//	html_header_severalcheckbox(array("Host", "Ip","community","snmp version","user","password"),"",$prefix2);
	html_header_severalcheckbox(array("Host", "Ip"),"","form_devices2",$prefix2);
	$i = 0;
	if (sizeof($temp) > 0) {
	  $nbr = 0;
	  foreach ($temp as $h) {
	    $indx = $h[$deviceid];
	    $acthost= $h["hostname"];
	    $rep=0;
	    if (sizeof($template_list) > 0) {
		foreach ($template_list as $template) {
		  if ($withmactrac) {
		     if ($indx==-$template["hostid"]) { $rep=1; break;}
		  } else {
		     if ($indx==$template["hostid"]) { $rep=1; break;}
		  }
		  if ($acthost==$template["hostname"]) { $rep=1; break;}		  	
		}
	    }
	    if ($rep==0) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i);
		print "<td>".$acthost."</td>";
		print "<td>".GetHostByName($acthost)."</td>";
// later
//		print "<td>".$h["snmp_community"]."</td>";
//		print "<td>".$h["snmp_version"]."</td>";
//		print "<td>".$h["snmp_username"]."</td>";
//		print "<td>".$h["snmp_password"]."</td>";
		print "<td style='".get_checkbox_style()."' width='1%' align='right'>
			 <input type='checkbox' style='margin: 0px;' name='".$prefix2."_".$indx."' title='".$indx."'>
			</td></tr>";
		$i++;
		$nbr++;
	     }
	   }
	   if ($nbr==0) print "<tr><td><em>No more hosts to choose !!</em></td></tr>\n";
	} else {
		print "<tr><td><em>No hosts in Cacti !!</em></td></tr>\n";
	}
	html_end_box(false);
	print "</form>\n";
       include_once("./plugins/configmanager/html/bottom_footer.php");
}

?>