<?php

/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Modified ....... .
    Program ........ Download/Upload configuration manager for Cacti

*******************************************************************************/

/* create the path for the data
*/
function configmanager_create_path_log_multi($info,$debug) {
   if ((sizeof($info) > 0) && isset($info) ) {
         $path = $info['path'];
         if ($path!="") {
           $path=str_replace("\\","/",$path);
           if (!is_dir($path)) mkdir($path);
         }
        }	
}

function configmanager_shortfilename($info) {
   $name= "";
   if ((sizeof($info) > 0) && isset($info)) {
     $cfgid=$info['id'];
     $cfgname= $info['name'];
     $cfilename=$cfgname."id".$cfgid;
     $name=trim($cfilename);
   }
  return $name;
}

function configmanager_shortlogfilename($info) {
   $name= "";
   $fname=configmanager_shortfilename($info);
   if ($fname!=="") {
   	$name= $fname . ".log";
   }
 return $name;
}

function configmanager_createlogfilename($info) {
  global $config;
   $name= "";
   if ((sizeof($info) > 0) && isset($info)) {
     $path = $info['path'];
     // no space at right
     $cpath=rtrim($path); 
     $cfilename=configmanager_shortlogfilename($info);
     $name= "defaultconfig";
     if ($cfilename!="") {
	  $pattern = '/[\\,\/]$/';
          if (preg_match($pattern, $cpath, $matches)) {
            $name = $cpath . $cfilename;
          } else {
	    $slash= ($config["cacti_server_os"] == "win32") ? "\\" : "/";
            $name = $cpath . $slash . $cfilename;
          }
          if ($config["cacti_server_os"] == "win32") $name=str_replace("/","\\",$name);

     }
  }
  return $name;
}
/* backup the log to make place to the new one
*/
function configmanager_init_log_multi($info,$debug) {
     $fulllogfile=configmanager_createlogfilename($info);
     if (file_exists($fulllogfile)) {
   	if (copy($fulllogfile,$fulllogfile.".bkp")) unlink($fulllogfile);
     }
}

function cfgmng_create_multi($info,$debug) {
   global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   global $settings,$config;
   $configid=$info['id'];
   $sqlrequest="select * from $cfgmngtable_data where configmanagerid = $configid order by gorder";
   $template_list = db_fetch_assoc($sqlrequest);
   cfgmng_create_multiTab($info,$debug,$template_list);
}

function cfgmng_create_multiTab(&$info,$debug,&$template_list) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   global $settings,$config;
   
  $valreturn= false;
  $countinfo=0;
  if (sizeof($template_list) > 0) {
   if ((sizeof($info) > 0) && isset($info)) {
	$configid=$info['id'];
	$configname = $info['name'];
	$configtype=$info['configtype'];
	$username=$info['snmp_username'];
	$password=$info['snmp_password'];
	$configpath=str_replace("\\","/",$info['path']);
	$valreturn= true;
	$configmanagerfile=configmanager_shortfilename($info);
   	$configmanagerlog=configmanager_createlogfilename($info);
        $configmanagershortlog=configmanager_shortlogfilename($info);
        $configmanagerplugin= $config["base_path"]."/plugins/configmanager";
	if ($debug) {
	  $cactilog="createconfig for $configname(configid=$configid)!";
//	  cacti_log("CFG MANAGER:$cactilog\n",false,"SYSTEM");
          $message=date("Y-m-d H:i:s")." ".$cactilog."\n";
          cfgmng_log($message);
	}
        $year=date('Y'); $month= date('m'); $day=date('d');
	$i = 0;
	$tempcommand=$info['command'];
	// find the command and arguments
	$prgtab= preg_split('/ /',$tempcommand);
	$prg1 = $prgtab[0];
	unset($prgtab[0]);
	$param = join(" ",$prgtab);
	$command_string=$prg1;
	$searchcmd= array('/%u%/','/%w%/','/%l%/','/%s%/','/%f%/',
	  		'/%p%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/');
	$replacecmd=array($username,$password,$configmanagerlog,$configmanagershortlog,$configmanagerfile,
	  		$configpath,
	  		$year,$month,$day,$configmanagerplugin);
	$command_string= preg_replace($searchcmd,$replacecmd,$prg1);
        // parameters
	// replace %u%, %w%, %l%, %f%, ...
	$search= array('/%u%/','/%w%/','/%l%/','/%s%/','/%f%/',
	  		'/%p%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/');
	$replace=array($username,$password,$configmanagerlog,$configmanagershortlog,$configmanagerfile,
	  		$configpath,
	  		$year,$month,$day,$configmanagerplugin);
	$temp1parameters= preg_replace($search,$replace,$param);
	$replacedebug=array($username,"***",$configmanagerlog,$configmanagershortlog,$configmanagerfile,
	  		$configpath,
	  		$year,$month,$day,$configmanagerplugin);
	$temp1parametersdebug= preg_replace($search,$replacedebug,$param);
	$search = '/%a%/';
        $listdevices="";
	$existlist= preg_match($search, $param);
	if ($existlist) {
          // will use a list of device for one script
	  foreach ($template_list as $template) {
	     // the hosts information
	     $hostname=$template["hostname"];
	     $hostip=$template["hostip"];
	     $listdevices.= ($listdevices=="")?"$hostname,$hostip":",$hostname,$hostip";
	   }
	   // pre command
	   // replace %u%, %w%, %l%, %f%, ...
	   $search= array('/%u%/','/%w%/','/%l%/','/%s%/','/%f%/',
	  		'/%p%/','/%a%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/');
	   $replace=array($username,$password,$configmanagerlog,$configmanagershortlog,$configmanagerfile,
	  		$configpath,$listdevices,
	  		$year,$month,$day,$configmanagerplugin);
	   $pre=$info["pre"];
	   $precommand= preg_replace($search,$replace,$pre);
	   if ($precommand!="") {
		exec($precommand,$prelog,$retstate);
                $message=date("Y-m-d H:i:s")." DEBUG: pre command '$precommand' return ->".(($retstate)?"OK": "not OK ".print_r($prelog,true))."\n";
                if ($debug) cfgmng_log($message);
           }
	   // the command to execute
	   // replace %a% list of devices
	   $searchcmd=  array('/%a%/');
	   $replacecmd= array($listdevices);
	   $parameters= preg_replace($searchcmd,$replacecmd,$temp1parameters);
	   if ($config["cacti_server_os"] == "win32") {
	         $searchslash= array('/\//');
	         $replaceslash=array('\\');
	         $command_string= preg_replace($searchslash,$replaceslash,$command_string);
	         $parameters= preg_replace($searchslash,$replaceslash,$parameters);
		 //$cmdlog = popen("start \"Cactiplus\" /I \"" . $command_string . "\" " . $parameters, "r");
		 exec_background($command_string, $parameters);
	    } else {
		exec_background($command_string, $parameters);
	    }
            // for each start the command 
//	    if ($debug) {
	                $parametersnopassword= preg_replace($searchcmd,$replacecmd,$temp1parametersdebug);// don't show the password in the log
			$cactilog="exec_background($command_string $parametersnopassword) ";
                        $message=date("Y-m-d H:i:s")." ".$cactilog." for following hosts:".$listdevices.((isset($cmdlog))?(". result=".(($cmdlog)?"executed":"aborted")):"")."\n";
                        cfgmng_log($message);
//	    }
	    // post command
	    $post=$info["post"];
	    $postcommand= preg_replace($search,$replace,$post);
	    if ($postcommand!="") {
		exec($postcommand,$postlog,$retstate);
                $message=date("Y-m-d H:i:s")." DEBUG: post command '$postcommand' return ->".(($retstate)?"OK": "not OK ".print_r($postlog,true))."\n";
                if ($debug) cfgmng_log($message);
             }
	     $i++;
	} else {
	  // will start for each host a script
	  foreach ($template_list as $template) {
	      	  // the hosts information
		  $hostname=$template["hostname"];
	      	  $hostip=$template["hostip"];
	      	  $hostid=$template["hostid"];
	      	  // pre command
	          // replace %u%, %w%, %l%, %f%, ...
	          $search= array('/%u%/','/%w%/','/%l%/','/%s%/','/%f%/',
	  		'/%p%/','/%i%/','/%n%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/');
	          $replace=array($username,$password,$configmanagerlog,$configmanagershortlog,$configmanagerfile,
	  		$configpath,$hostip,$hostname,
	  		$year,$month,$day,$configmanagerplugin);
		  $pre=$info["pre"];
	  	  $precommand= preg_replace($search,$replace,$pre);
		  if ($precommand!="") {
		    exec($precommand,$prelog,$retstate);
                    $message=date("Y-m-d H:i:s")." DEBUG: pre command '$precommand' return ->".(($retstate)?"OK": "not OK ".print_r($prelog,true))."\n";
                    if ($debug) cfgmng_log($message);
                  }
	  	  // the command to execute
		  // replace %i%, %n%
	  	  $searchcmd= array('/%i%/','/%n%/');
	  	  $replacecmd=array($hostip,$hostname);
	  	  $parameters= preg_replace($searchcmd,$replacecmd,$temp1parameters);
	         $searchslash= array('/\//');
	         $replaceslash=array('\\');
		 if ($config["cacti_server_os"] == "win32") {
	                $command_string= preg_replace($searchslash,$replaceslash,$command_string);
	                $parameters= preg_replace($searchslash,$replaceslash,$parameters);
		  	$cmdlog = popen("start \"Cactiplus\" /I \"" . $command_string . "\" " . $parameters, "r");
                        pclose($cmdlog);
//			exec_background($command_string, $parameters);
//			system("$command_string $parameters");
		  } else {
			exec_background($command_string, $parameters);
		  }
                  // for each start the command 
//		  if ($debug) {
	                $parametersnopassword= preg_replace($searchcmd,$replacecmd,$temp1parametersdebug);// don't show the password in the log
	                if ($config["cacti_server_os"] == "win32") $parametersnopassword= preg_replace($searchslash,$replaceslash,$parametersnopassword);
			$cactilog="exec_background($command_string $parametersnopassword) ";
//			cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
                        $message=date("Y-m-d H:i:s")." ".$cactilog." for following hosts:".$hostname.((isset($cmdlog))?(". result=".(($cmdlog)?"executed":"aborted")):"")."\n";
                        cfgmng_log($message);
//		  }
	      	  // post command
		  $post=$info["post"];
	  	  $postcommand= preg_replace($search,$replace,$post);
		  if ($postcommand!="") {
		      exec($postcommand,$postlog,$retstate);
                      $message=date("Y-m-d H:i:s")." DEBUG: post command '$postcommand' return ->".(($retstate)?"OK": "not OK ".print_r($postlog,true))."\n";
                      if ($debug) cfgmng_log($message);
                  }
		  $i++;
	   }
	}
     }
  }
  return $valreturn;
}


