<?php

/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Modified ....... .
    Program ........ using PHP pure. Download/Upload configuration manager for Cacti

*******************************************************************************/

/* create the path for the data
*/

//does sharednetworkclass exist ?
if (cfgmng_sharednetworkclass_exist()) {
 //overwrite the default function
 function networkclass_debug($message) {
  global $networkclass_isdebug,$networkclass_islog,$networkclass_debugfile;
  if ($networkclass_isdebug) cfgmng_log($message);
 }
 include($sharednetworkclasspath."/snmp_networkclass.php");
 $networkclass_islog = true;

}

function cfgmng_sharednetworkclass_exist() {
   global $sharednetworkclasspath;
   if (!isset($sharednetworkclasspath) || ($sharednetworkclasspath=="")
      || (!is_dir($sharednetworkclasspath) || (!is_file($sharednetworkclasspath."/snmp_networkclass.php")) ))
      return 0;
   else
      return 1;
}

function cfgmng_create_tftp_php(&$info,$debug) {
   global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   global $settings,$config;
   global $sharednetworkclasspath,$networkclass_isdebug,$networkclass_islog;
   $networkclass_isdebug = $debug;
   $configid=$info['id'];
   $sqlrequest="select * from $cfgmngtable_data where configmanagerid = $configid order by gorder";
   $template_list = db_fetch_assoc($sqlrequest);
   cfgmng_create_tftp_phpTab($info,$debug,$template_list);
}

function cfgmng_create_tftp_phpTab(&$info,$debug,&$template_list) {
   global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   global $settings,$config;
   global $sharednetworkclasspath,$networkclass_isdebug,$networkclass_islog;
   $networkclass_isdebug = $debug;
   
  //does sharednetworkclass exist ?
  if (!cfgmng_sharednetworkclass_exist()) {
     $cfgmnglog = "Error: The sharednetworkclass is not installed.";
     $message=date("Y-m-d H:i:s")." ".$cfgmnglog."\n";
     cfgmng_log($message);     
     exit;
  }
  $method = (read_config_option("cfgm_usenetsnmp")=="on") ? SNMP_METHOD_BINARY: SNMP_METHOD_PHP;
  if ($method==SNMP_METHOD_BINARY) {
     $longfilesnmpget= read_config_option("path_snmpget");
     $other_get_filename = basename($longfilesnmpget);
     $path_to_snmp_binary = "";
     if ($other_get_filename!="") $path_to_snmp_binary = dirname($longfilesnmpget);
     $other_getnext_filename = basename(read_config_option("path_snmpgetnext"));
     //read_config_option("path_snmpbulkwalk");
     $other_walk_filename = basename(read_config_option("path_snmpwalk"));
     $other_set_filename = basename(read_config_option("cfgm_name_snmpset"));
     $snmpbinversiontmp = read_config_option("snmp_version");
     $snmpbinversion = ($snmpbinversiontmp=="UCD-SNMP 4.x") ? SNMP_METHOD_UCD : SNMP_METHOD_NET;
/*
$cfgmnglog = "TEST: longfilesnmpget=$longfilesnmpget, other_get_filename=$other_get_filename, path_to_snmp_binary=$path_to_snmp_binary,"
." other_getnext_filename=$other_getnext_filename, other_walk_filename=$other_walk_filename, other_set_filename=$other_set_filename,"
." snmpbinversiontmp=$snmpbinversiontmp, snmpbinversion=$snmpbinversion.";
$message=date("Y-m-d H:i:s")." ".$cfgmnglog."\n";
cfgmng_log($message);     
*/
     $alarm="";
     $existget = file_exists($longfilesnmpget);
     if (!$existget) $alarm .="Error: snmpget function not found =>snmp path not found.";
     else {
           $alarm= "Path is:".$path_to_snmp_binary;
     }
     if ($debug && ($alarm!="")) {
          $message=date("Y-m-d H:i:s")." ".$alarm."\n";
          cfgmng_log($message);
     }
  } else {
     $other_get_filename = "";
     $path_to_snmp_binary = "";
     $other_getnext_filename = "";
     $other_walk_filename = "";
     $other_set_filename = "";
     $snmpbinversion = SNMP_METHOD_NET;
  }
  $port = read_config_option("cfgm_snmp_port");
  $timeout = intval(read_config_option("cfgm_SnmpWait")*1000); //in ms
  $retries = read_config_option("cfgm_snmp_retries");
  
  //
  $valreturn= false;
  $countinfo=0;
  if (sizeof($template_list) > 0) {
   if ((sizeof($info) > 0) && isset($info)) {
	$configid=$info['id'];
	$configname = $info['name'];
	$configtype=$info['configtype'];
	$configpath=str_replace("\\","/",$info['path']);
	$snmpversiondefault=$info['snmp_version'];
	if (($snmpversiondefault<1) || ($snmpversiondefault>3)) $snmpversiondefault=1; //to be sure
	$version =($snmpversiondefault==2)?"2c":$snmpversiondefault;
	$SnmpCommunity=$info['snmp_community'];
	$username=$info['snmp_username'];
	$password=$info['snmp_password'];
        $snmp_auth_protocol= $info["snmp_auth_protocol"];   // MD5 or SHA (SNMPv3 Authorization Protocol)
        if (($snmp_auth_protocol!="MD5") && ($snmp_auth_protocol!="SHA")) $snmp_auth_protocol="MD5";
        $snmp_priv_passphrase= $info["snmp_priv_passphrase"];     // (SNMPv3 Privacy Passphrase)
        $snmp_priv_protocol= $info["snmp_priv_protocol"];  // none or DES or AES (SNMPv3 Privacy Protocol)
	$val= read_config_option("cfgm_snmpdebug");
	($val=="on") ? $SnmpDebug=1 : $SnmpDebug=0;
	$val=read_config_option("cfgm_SnmpMtu");
	((484<=$val)&&($val<=65535)&&is_numeric($val)) ? $SnmpMtu="$val": $SnmpMtu="1500";
	
	$valreturn= true;
        $configmanagerplugin= $config["base_path"]."/plugins/configmanager";
	if ($debug) {
	  $cactilog="createconfig for $configname(configid=$configid)! (only as information because not needed for PHP TFTP method)";
//	  cacti_log("CFG MANAGER:$cactilog\n",false,"SYSTEM");
          $message=date("Y-m-d H:i:s")." ".$cactilog."\n";
          cfgmng_log($message);
	}
        $year=date('Y'); $month= date('m'); $day=date('d');
        $configmanagerplugin= $config["base_path"]."/plugins/configmanager";
	$i = 0;
	$tempcommand=$info['command'];
	// find the command and arguments
	$prgtab= preg_split('/ /',$tempcommand);
	$prg1 = $prgtab[0];
	unset($prgtab[0]);
	$param = join(" ",$prgtab);
	$command_string=$prg1;
	// replace %u%, %w%, %l%, %f%, ...
	$search= array('/%u%/','/%w%/','/%p%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/');
	$replace=array($username,$password,$configpath,
	  		$year,$month,$day,$configmanagerplugin);
	$temp1parameters= preg_replace($search,$replace,$param);
        //tftpdirection
        $tftpdirection= ($info['up_download']=="upload")? "upload":"download"; // default "download"
        //tftpserver
        $val = $info['tftp'];
	if ($val=="") $val= read_config_option("cfgm_TFTPserver");
	($val=="") ? $tftpserver="127.0.0.1" : $tftpserver= GetHostByName($val);
	$rootpath= read_config_option("cfgm_TFTPpath"); // root path
	if ($config["cacti_server_os"] == "win32") $rootpath=str_replace("/","\\",$rootpath);
	$tftproot= ($rootpath=="")? "": $rootpath;
	$search= array('/%y%/','/%m%/','/%d%/','/%g%/','/%r%/');
	$replace=array($year,$month,$day,$configmanagerplugin,$rootpath);
        $val= preg_replace($search,$replace,$tftproot);
	if ($config["cacti_server_os"] == "win32") $val=str_replace("/","\\",$val);
	$tftppath= $val;
        $valpath = $info['pathdata'];
	$search= array('/%y%/','/%m%/','/%d%/','/%g%/','/%r%/','/%p%/');
	$replace=array($year,$month,$day,$configmanagerplugin,$rootpath,$configpath);
        $valpath= preg_replace($search,$replace,$valpath);
        if ($valpath=="") $pathdata = "";
        else $pathdata = (preg_match('/\/$/', $valpath)) ? $valpath: ($valpath."/");
	if ($config["cacti_server_os"] == "win32") $pathdata=str_replace("/","\\",$pathdata);

	foreach ($template_list as $template) {
	      	  // the hosts information
		  $hostname=$template["hostname"];
	      	  $hostip=$template["hostip"];
	      	  $hostid=$template["hostid"];
//	      	  $SnmpCommunity=$template["hostcommunity"];
//	      	  $snmpversion=$template["snmp_version"];
	      	  // pre command
	          // replace %u%, %w%, %l%, %f%, ...
	          $search= array('/%u%/','/%w%/',
	  		'/%p%/','/%i%/','/%n%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/');
	          $replace=array($username,$password,
	  		$configpath,$hostip,$hostname,
	  		$year,$month,$day,$configmanagerplugin);
		  $pre=$info["pre"];
	  	  $precommand= preg_replace($search,$replace,$pre);
		  if ($precommand!="") {
		    exec($precommand,$prelog);
                    $message=date("Y-m-d H:i:s")." DEBUG: pre command '$precommand' return ->$prelog\n";
                    if ($debug) cfgmng_log($message);
                  }
	  	  // the command to execute
		  // replace %i%, %n%
	  	  $search= array('/%i%/','/%n%/');
	  	  $replace=array($hostip,$hostname);
	  	  $parameters= preg_replace($search,$replace,$temp1parameters);
	  	  // file to upload/download
	  	  $fileformattemp = $info['fileformat'];
	          // replace ::HOST::, ::NICK::, ::NODE::, ::FULLPATH::, ::DATE:: and ::FILENAME::.
	          $search= array('/::NODE::/','/::HOST::/','/::NICK::/','/::DATE::/','/::FULLPATH::/',
	                    '/%u%/','/%w%/','/%p%/','/%i%/','/%n%/','/%y%/','/%m%/','/%d%/','/%g%/');
	          $replace=array($hostip,$hostname,$hostname,"$year$month$day",$rootpath,
	                    $username,$password,$configpath,$hostip,$hostname,$year,$month,$day,$configmanagerplugin);
	  	  $fileformat= $pathdata.preg_replace($search,$replace,$fileformattemp);
	  	  $fileupload = $pathdata.$info['fileupload'];
	  	  $startup = $info['startup'];
	  	  $startup = ($startup==1)? true: false;
	  	  // set the file 's parameters
	  	  if ($tftpdirection=="upload") {
	  	  	$filesource= $fileupload;
	  	  	$filedestination= ($startup) ? "startup" : "run";
	  	  	$fromsource = "tftp";
	  	  } else {
	  	  	$filesource= ($startup) ? "startup" : "run";
	  	  	$filedestination= $fileformat;
	  	  	$fromsource = $filesource;
	  	  }
                  // initalise the object
                  $tftpparam = array(
	             "tftpdirection" => $tftpdirection
	             ,"filesource" => $filesource
	             ,"filedestination" => $filedestination
	             ,"tftpserver" => $tftpserver
	          );
	          $binair = $info['binair'];
                  $sess = array($hostip,$version,$SnmpCommunity,$username,$password,$snmp_auth_protocol,$snmp_priv_passphrase,$snmp_priv_protocol,$port,$timeout,$retries,$method);
                  if ($debug) {
                     $cfgmnglog = "PHP TFTP: (debug=$debug) tftp paramameter=>".print_r($tftpparam,true)." Init session=>".print_r($sess,true);
                     $message=date("Y-m-d H:i:s")." ".$cfgmnglog."\n";
                     cfgmng_log($message);  
                  }   
                  $obdevice=new networkclass;
                  if ($SnmpDebug)   $obdevice->setdebug(0,1);
                  if ($method==SNMP_METHOD_BINARY) 
                      $obdevice->Init($sess,$path_to_snmp_binary,$other_get_filename,$other_getnext_filename,$other_walk_filename,$other_set_filename,$snmpbinversion);
                  else $obdevice->Init($sess);
	  	  // Execute the upload/download
                  if (!$obdevice->ini) {
                     $message=date("Y-m-d H:i:s")." Error: initialisation the $tftpdirection of $hostname($hostip).".$obdevice->errormsg." \n";
                     //if ($debug) 
                     cfgmng_log($message);
                  } else {
                    $obdevice->LoadClass("networkclass"); // needed if you want to use other functions than get,set,getnext,walk
                    $message=date("Y-m-d H:i:s")." Load class \"".$obdevice->vendor."\" of $hostname for $tftpdirection \n";
                    if ($debug) cfgmng_log($message);
                  }
                  $tftp = array($startup,$fromsource,$tftpparam["tftpserver"],$tftpparam["filesource"],$tftpparam["filedestination"],$binair);
	          if (!$obdevice->active)  {
                     $message=date("Y-m-d H:i:s")." Error: Cannot $tftpdirection. $hostname not activ. \n".print_r($tftp,true);
	  	     cfgmng_log($message);
	          } else {
//$message=date("Y-m-d H:i:s")." DEBUGTEMP: $tftpdirection. $hostname \n".print_r($tftp,true);
//cfgmng_log($message);
	             $obdevice->InitTftp($tftp);
	             // TFTP download
	             $obdevice->RunFunction('tftp',$obdevice);
//$message=date("Y-m-d H:i:s")." DEBUG-TEMP: $tftpdirection hostname:$hostname \n".print_r($tftp,true);
//cfgmng_log($message);
                     $message=date("Y-m-d H:i:s")." Error: $tftpdirection. RESULT: ".$obdevice->result." not activ. \n";
	             if (!$obdevice->retcode) cfgmng_log($message);
	          }
                  if ($SnmpDebug)   $obdevice->setdebug(0,0);
                  $obdevice->close();
                  // for each start the command 
		  if ($debug) {
	                $search= array('/'.$password.'/');
	                $replace=array('***');
	  	        $parametersnopassword= preg_replace($search,$replace,$parameters);
			$cactilog="exec_background ($command_string $parametersnopassword) ";
//			cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
                        $message=date("Y-m-d H:i:s")." ".$cactilog." for following hosts:".$hostname.((isset($cmdlog))?(". result=".$cmdlog):"")."\n";
                        cfgmng_log($message);
		  }
	      	  // post command
		  $post=$info["post"];
		  if ($post!="") {
	              $search= array('/::NODE::/','/::HOST::/','/::NICK::/','/::DATE::/','/::FULLPATH::/',
	                    '/%u%/','/%w%/','/%p%/','/%i%/','/%n%/','/%y%/','/%m%/','/%d%/','/%g%/');
	              $replace=array($hostip,$hostname,$hostname,"$year$month$day",$rootpath,
	                    $username,$password,$configpath,$hostip,$hostname,$year,$month,$day,$configmanagerplugin);
	  	      $postcommand= preg_replace($search,$replace,$post);
		      exec($postcommand,$postlog);
                      $message=date("Y-m-d H:i:s")." DEBUG: post command '$postcommand' return ->$postlog\n";
                      if ($debug) cfgmng_log($message);
                  }
		  $i++;
	   }
     }
  }
  return $valreturn;
}


