<?php

/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Program ........ Download/Upload configuration manager for Cacti

    per default I will use Pancho (method TFTP)
    Contact for Pancho .... Charles Menzes http://www.pancho.org/
			, http://freshmeat.net/projects/pancho/

*******************************************************************************/

function configmanager_programmename() {
  $val= "Pancho";
  return $val;
}

function configmanager_moreinfo() {
  $val= "www.pancho.org";
  return $val;
}

function configmanager_moreinfo2() {
  $val= "freshmeat.net/projects/pancho/";
  return $val;
}

function configmanager_help() {
  $val= "This method allows the network administrators to archive device configurations "
  	."as well as make changes to these remote nodes through the use of "
  	."SNMP and TFTP."
  	."Pancho can automatically discover the model of the router/switch in order to give "
  	."the good commands. Pancho allow you to change also one or more commands on the "
  	."devices.";
  return $val;
}

/* create the configurations file name for the configuration download manager
*/
function configmanager_createfullcfgname($cfgid,$cpath,$cfgname) {
  global $config;
        $cpath=rtrim($cpath); // no space at left & right
        $cpath=rtrim($cpath);
        $cfilename=$cfgname."id".$cfgid.".conf";
        $cfilename=trim($cfilename);
        $pattern = '/[\\,\/]$/';
        $name= "defaultconfig";
        if (($cfgname!="") && ($cfgid>=0)) {
          if (preg_match($pattern, $cpath, $matches)) {
            $name = $cpath . $cfilename;
          } else {
	    $slash= ($config["cacti_server_os"] == "win32") ? "\\" : "/";
            $name = $cpath . $slash . $cfilename;
          }
          if ($config["cacti_server_os"] == "win32") $name=str_replace("/","\\",$name);

        }
	return $name;
}

/* create the upload file name 
*/
function configmanager_fulluploadfile($cfgid,$configpath,$cfilename,$cfgname,$tftppath) {
  global $config;
        $configpath=rtrim($configpath); // no space at left & right
        $cfilename=rtrim($cfilename);
        $cfilename=trim($cfilename);
        $year=date('Y'); $month= date('m'); $day=date('d');
	$search= array('/%y%/','/%m%/','/%d%/','/%c%/','/%id%/','/%p%/','/%r%/');
	$replace=array($year,$month,$day,$cfgname,$cfgid,$configpath,$tftppath);
        $cfilename= preg_replace($search,$replace,$cfilename);
        $name= $cfilename;
        if ($config["cacti_server_os"] == "win32") $name=str_replace("/","\\",$name);
	return $name;
}

/* create the parameters for the configuration download manager
*/
function configmanager_createparameter($configid,$debug,$requestdebug) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   $param='';
   $info = db_fetch_assoc("select * from $cfgmngtable where id = $configid");
   $countinfo=0;
   if ((sizeof($info) > 0) && isset($info)) {
	 $val=$info[0]['id'];
	 $configname = $info[0]['name'];
         $path = $info[0]['path'];
         $pathdata = $info[0]['pathdata'];
	 $countinfo=count($info);
	 $ispre  = ($info[0]['pre']!=="");
	 $ispost = ($info[0]['post']!=="");
	 $rootpath= read_config_option("cfgm_TFTPpath");
	 $startup = $info[0]['startup'];
	 $commit = $info[0]['commit'];
   	 $updown= $info[0]['up_download'];
	 if ($updown!=="upload") $commit= 0;
   }
   if ($countinfo>0) {
	$fullconfigname=configmanager_createfullcfgname($configid,$path,$configname);
	$uploadfile= configmanager_fulluploadfile($configid,$pathdata,$info[0]['fileupload'],$configname,$rootpath);
	$param2= ($updown=="upload") ? "--upload --filename ".$uploadfile : "--download";
	$param3= "" . (($commit==1) ? " --commit " : "") . (($startup==1) ? " --start " : "");
	$param= $param3 . " ".$param2." ".(($ispre)?"--pre ":"").(($ispost)?"--post ":"")." --config ".$fullconfigname;
   }
  return $param;
}

/* create the path for the data
*/
function configmanager_create_pathdata($configid,$debug) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   $info = db_fetch_assoc("select * from $cfgmngtable where id = $configid");
   $countinfo=0;
   if ((sizeof($info) > 0) && isset($info)) {
	 $countinfo=count($info);
   }
   if ($countinfo>0) {
   	$updown=$info[0]['up_download'];
   	// if upload we do not need to create a repertory
   	if ($updown!=="upload") {
         $path = $info[0]['pathdata']."/".date('Ymd');
         $path=str_replace("\\","/",$path);
         //if (!is_dir($path)) 
            mkdir($path);
        }	
   }
}

/* backup the log to make place to the new one
*/
function configmanager_rotate_log($fullconfigname,$debug) {
   $fulllogfile=$fullconfigname.".log";
   if (file_exists($fulllogfile)) {
    if (copy($fulllogfile,$fulllogfile.".bkp")) {
	// clear the logfile before to clear it because in some case the system refuse the removing
        $handle=fopen($fulllogfile,"w");
        if ($handle) fclose($handle);
        // clear the log
   	unlink($fulllogfile);
    }
   }
}

function configmanager_moveallfiles($info,$debug) {
   global $settings,$config;
   
   $valreturn= false;
   $countinfo=0;
   if ((sizeof($info) > 0) && isset($info)) {
	$configid=$info['id'];
	$configname = $info['name'];
	$configtype=$info['configtype'];
	if ($configtype=="tftp"){
         $pathdata = $info['pathdata'];
         if ($config["cacti_server_os"] == "win32") {
		$pathdata=str_replace("/","\\",$pathdata);
		$panchofilename=$pathdata."\\*.".date('Ymd').".cfg";
         }
         else {	$panchofilename=$pathdata."/*.".date('Ymd').".cfg";  }
         $command_string = ($config["cacti_server_os"] == "win32") ? "move " : "mv ";
         $parameters = ($config["cacti_server_os"] == "win32")
                         ? $panchofilename." $pathdata\\".date('Ymd')."\\"
                         : $panchofilename." $pathdata/".date('Ymd')."/";
	if ($config["cacti_server_os"] == "win32") {
		popen("start \"Cactiplus\" /I /WAIT " . $command_string . " " . $parameters, "r");
//		exec("$command_string parameters");
	} else {
		exec_background($command_string, $parameters);
        }
       }
  }
}

function cfgmng_createTFTPconfig($configid,$debug,&$fullconfigname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
 global $settings,$config;
  $valreturn= false;
  $info = db_fetch_assoc("select * from $cfgmngtable where id = $configid");
  if ((sizeof($info) > 0) && isset($info)) {
    $template_list = db_fetch_assoc("select * from $cfgmngtable_data where configmanagerid = $configid order by gorder");
    $valreturn = cfgmng_createTFTPconfigTab($configid,$debug,$info,"",$template_list,$fullconfigname);
   }
  return $valreturn;
}

function cfgmng_createTFTPconfigTab($configid,$debug,&$info,$confignameinit,&$template_list,&$fullconfigname) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
   global $settings,$config;
   
   $fullconfigname="";
   $valreturn= false;
   $countinfo=0;
   $val=$info[0]['id'];
   if ($confignameinit=="") $configname = $info[0]['name'];
   else $configname = $confignameinit;
   $configtype=$info[0]['configtype'];
   $countinfo=count($info);
   $download= ($info[0]['up_download']<>"upload");
   $pre  = $info[0]['pre'];
   $post = $info[0]['post'];
   $fileformat = $info[0]['fileformat'];
   $pathdata = $info[0]['pathdata'];
   $path = $info[0]['path'];
   if (($countinfo>0) && ($configtype=="tftp")){
        $year=date('Y'); $month= date('m'); $day=date('d');
        $configmanagerplugin= $config["base_path"]."/plugins/configmanager";
	$valreturn= true;
	if ($confignameinit=="") $fullconfigname=configmanager_createfullcfgname($configid,$path,$configname);
	else $fullconfigname = $confignameinit;
        $configmanagerlog = $fullconfigname.".log";
	if ($debug) {
	  $cactilog=date("Y-m-d H:i:s ")."create pancho config for $configname(configid=$configid) --> $fullconfigname!";
//	  cacti_log("CFG MANAGER:$cactilog\n",false,"SYSTEM");
	  cfgmng_log($cactilog);
	}
        $handle = @fopen($fullconfigname, "w");
        if ($handle) {
          $val = $info[0]['tftp'];
	  if ($val=="") $val= read_config_option("cfgm_TFTPserver");
	  ($val=="") ? $tftpserver="127.0.0.1" : $tftpserver=$val;
          // write the header file
          fwrite($handle,"[global]\n");
          fwrite($handle,"TftpServer=$tftpserver\n");
	  $rootpath= read_config_option("cfgm_TFTPpath"); // root path
	  if ($config["cacti_server_os"] == "win32") $rootpath=str_replace("/","\\",$rootpath);
	  $tftproot= ($rootpath=="")? "#TftpRoot=\n": "TftpRoot=$rootpath\n";
          fwrite($handle,$tftproot);
	  $search= array('/%y%/','/%m%/','/%d%/','/%g%/','/%r%/');
	  $replace=array($year,$month,$day,$configmanagerplugin,$rootpath);
          $val= preg_replace($search,$replace,$pathdata);
	  if ($config["cacti_server_os"] == "win32") $val=str_replace("/","\\",$val);
	  $tftppath= ($val=="")? "#TftpPath=\n": "TftpPath=$val\n";
          fwrite($handle,$tftppath);
          fwrite($handle,"LogFile=$configmanagerlog\n");
	  $val= read_config_option("cfgm_snmpforkLimitdefault");
	  (($val>0)&&($val<20)) ? $snmpforkLimitdefault=$val: $snmpforkLimitdefault=10;
          fwrite($handle,"ForkLimit=$snmpforkLimitdefault\n");
	  $fileformat1= ($fileformat=="")?"::HOST::.::DATE::.cfg":$fileformat;
          fwrite($handle,"StylePattern=".$fileformat1."\n");
          fwrite($handle,"StyleDate=%Y%m%d\n");
          # sets snmp options
	  $snmpversiondefault=$info[0]['snmp_version'];
	  if (($snmpversiondefault<1) || ($snmpversiondefault>3)) $snmpversiondefault=1; //to be sure
	  $SnmpCommunitydefault=$info[0]['snmp_community'];
	  $snmp_usernamedefault=$info[0]['snmp_username'];
	  $snmp_passworddefault=$info[0]['snmp_password'];
//	  $val=read_config_option("cfgm_snmp_authprotocol");
//	  (($val=="md5")||($val=="sha1")) ? $snmp_authprotocoldefault=$val: $snmp_authprotocoldefault="md5";
	  $snmp_authprotocoldefault= $info[0]['snmp_auth_protocol'];
	  $snmp_authkeydefault= $info[0]['snmp_priv_passphrase'];//read_config_option("cfgm_snmp_authkey");
	  $snmp_auth_protocoldefault= $info[0]['snmp_auth_protocol'];//read_config_option("cfgm_snmp_auth_protocol");
	  $val=read_config_option("cfgm_snmp_retries");
	  (($val>0)&&($val<=20)) ? $SnmpRetries=$val: $SnmpRetries=1;
	  $val=read_config_option("cfgm_SnmpWait");
	  ((1.0<=$val)&&($val<=60.0)&&(is_numeric($val))) ? $SnmpWait="$val": $SnmpWait="5.0";
	  $val=read_config_option("cfgm_SnmpMtu");
	  ((484<=$val)&&($val<=65535)&&is_numeric($val)) ? $SnmpMtu="$val": $SnmpMtu="1500";
	  $val= read_config_option("cfgm_snmpdebug");
	  ($val=="on") ? $SnmpDebug=1 : $SnmpDebug=0;
	  $valversion =($snmpversiondefault==2)?"2c":$snmpversiondefault;
          fwrite($handle,"SnmpVersion=".$valversion."\n");
          fwrite($handle,"SnmpRetries=$SnmpRetries\n");
          fwrite($handle,"SnmpWait=$SnmpWait\n");
          fwrite($handle,"SnmpMtu=$SnmpMtu\n");
          fwrite($handle,"SnmpDebug=$SnmpDebug\n");
          if ($snmpversiondefault==3) {
        	fwrite($handle,"Snmpusername=$snmp_usernamedefault\n");
        	fwrite($handle,"SnmpAuthPassword=$snmp_passworddefault\n");
        	fwrite($handle,"SnmpAuthProtocol=$snmp_authprotocoldefault\n");
        	fwrite($handle,"SnmpAuthKey=$snmp_authkeydefault\n");
//        	fwrite($handle,"SnmpPrivProtocol=$snmp_priv_protocoldefault\n");
          } else {
		fwrite($handle,"SnmpCommunity=$SnmpCommunitydefault\n");
          }
	  $i = 0;
	  if (sizeof($template_list) > 0) {
              $pathdata = $info[0]['pathdata'];
	      foreach ($template_list as $template) {
//	      	  $SnmpCommunity=$template["hostcommunity"];
//	      	  $snmpversion=$template["snmp_version"];
	      	  // SNMP information
		  $snmpversion= $snmpversiondefault;
		  $SnmpCommunity= $SnmpCommunitydefault;
	      	  $snmp_username= $snmp_usernamedefault;
	      	  $snmp_password= $snmp_passworddefault;
	      	  $snmp_authprotocol= $snmp_authprotocoldefault;
	      	  $snmp_authkey= $snmp_authkeydefault;
	      	  // the hosts information
		  $hostname=$template["hostname"];
	      	  $hostip=$template["hostip"];
	      	  $hostid=$template["hostid"];
	  	  $search= array('/%u%/','/%w%/','/%l%/',
	  		'/%p%/','/%n%/','/%i%/',
	  		'/%y%/','/%m%/','/%d%/','/%g%/','/%r%/');
	  	  $replace=array($snmp_username,$snmp_password,$configmanagerlog,
	  		$pathdata,$hostname,$hostip,
	  		$year,$month,$day,$configmanagerplugin,$rootpath);
          	  $pre1= preg_replace($search,$replace,$pre);
          	  $post1= preg_replace($search,$replace,$post);
//                  fwrite($handle,"[".$hostname."_".$hostid."]\n");
                  fwrite($handle,"[".$hostname."]\n");
                  fwrite($handle,"IpAddress=$hostip\n");
                  if ($config["cacti_server_os"] == "win32") {
			$pathdata=str_replace("/","\\",$pathdata);
			$panchofilename=$pathdata."\\".$hostname."_".$hostid.".".date('Ymd').".cfg";
                  }
                  else {
			$panchofilename=$pathdata."/".$hostname."_".$hostid.".".date('Ymd').".cfg";
                  }
                  if ($pre!=="") fwrite($handle,"pre=".$pre1."\n");
                  if ($post!=="") fwrite($handle,"post=".$post1."\n");
		  $i++;
	      }
	  }
         fclose($handle);
        }
     }
  return $valreturn;
}

