<?php

$dir = dirname(__FILE__);
chdir($dir);
if (strpos($dir, 'configmanager') !== false) {
	chdir('../../');
}

/* Start Initialization Section */
include("./plugins/configmanager/config.php");
if (is_file("./include/global.php")) {
  include("./include/global.php");
} else {
  // old cacti + plugin architecture (before 0.8.7)
  include("./include/config.php");
}

include_once("./plugins/configmanager/debug.php");
include("./lib/poller.php");
include("./plugins/configmanager/configmanager_gateway_method_multi.php");
include("./plugins/configmanager/configmanager_gateway_php_tftp.php");

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
  die("<br><strong>This script is only meant to run at the command line.</strong>");
}

/* We are not talking to the browser */
$no_http_headers = true;

readparameters($isdebug,$isstoprun);
snmp_config_manager($isdebug);
exit;

function readparameters(&$debug,&$stoprun) {
	/* process calling arguments */
	$parms = $_SERVER["argv"];
	array_shift($parms);
	$debug = 0;
	$stoprun = FALSE;
	foreach($parms as $parameter) {
		@list($arg, $value) = @explode("=", $parameter);
		switch ($arg) {
		case "-d":
			$debug = 1;
			break;
		case "--help":
			display_help();
			exit;
		case "-h":
			display_help();
			exit;
		case "-x":
			$stoprun = TRUE;
			break;
		case "--version":
			display_help();
			exit;
		case "-v":
			display_help();
			exit;
		default:
			print "ERROR: Invalid Parameter " . $parameter . "\n\n";
			display_help();
			exit;
		}
	}
}

/*	display_help - displays the usage of the function */
function display_help () {
	print "Configmanager plugin poller. Plugin for downloading/uploading the configuration of switches or routers \n\n";
	print "usage: configmanager_poller.php [ [-d] | [-x] | [-h | --help] | [-v | --version]\n\n";
	print "-x            - stop the execution\n";
	print "-d            - Display verbose output during execution\n";
	print "-v --version  - Display this help message\n";
	print "-h --help     - display this help message\n";
}

/* Example
mydebugpoller("DEBUG SAVE:"."\n","new");
or
$cactilog="blabla !";
mydebugpoller("CFG MANAGER:_RESULT $cactilog"."\n","");
*/
function mydebugpoller($line,$new) {
     global $config;
     $mode = ($new=="new") ? "w" : "a";
     $file = $config["base_path"]."/plugins/configmanager/DEBUG.txt";
     if ($new!="close") {
//     	if ($mode=="w") { unlink($file.".bak"); rename($file,$file.".bak"); }
     	$handletest = fopen($file, $mode);
        if ($handletest) fwrite($handletest,$line);
    }
    if ($handletest) fclose($handletest);
}

/* function comparedate($date2,$date1)
compare date1 and date2 ($date2-$date1) with following date formats:
 "Y-m-d H:i:s", "Y-m-d H:i", "Y-m-d H", "Y-m-d"
return +1 when greater, 0 for equal, -1 for less and -2 when the format is wrong 
*/
function comparedate($date2,$date1) {
  $comp =-2;
  $elem1=strtotime($date1);
  $elem2=strtotime($date2);
  if (($elem1!==false) and ($elem2!==false)) {
  	$val = ($elem2-$elem1);
  	$comp = ($val) ? ($val/(abs($val))): 0; 
  }
  return $comp;
}

/* function date_recurrence($curdate,$date,$monthly,$daily,$mon,$tue,$wed,$thu,$fri,$sat,$sun)
check is the date has to be scheduled again. Date with following date formats:
 "Y-m-d H:i:s", "Y-m-d H:i", "Y-m-d H", "Y-m-d"
$monthly,$daily,$mon,$tue,$wed,$thu,$fri,$sat,$sun are true or false
return 1 if again, 0 for not 
*/
function date_recurrence($curdate,$date,$monthly,$daily,$mon,$tue,$wed,$thu,$fri,$sat,$sun) {
  if ($daily) $mon=$tue=$wed=$thu=$fri=$sat=$sun=1;
  $comp =0;
  $enddate = 0;
  $stampcurdate= strtotime($curdate);
  $stampdate= strtotime($date);
  if ($mon or $tue or $wed or $thu or $fri or $sat or $sun) {
	$numday= date('w',$stampcurdate);
	$ok= 0;
	if (($numday==0) and $sun) $ok=1;
	if (($numday==1) and $mon) $ok=1;
	if (($numday==2) and $tue) $ok=1;
	if (($numday==3) and $wed) $ok=1;
	if (($numday==4) and $thu) $ok=1;
	if (($numday==5) and $fri) $ok=1;
	if (($numday==6) and $sat) $ok=1;
  	if ($ok) $enddate= strtotime('+1 day' ,$stampdate);
  }
  if ($monthly) $enddate= strtotime('+1 month' ,$stampdate);
  if (($stampcurdate!==false) and ($stampdate!==false) and ($enddate>0)) {
  	$comp = ($stampcurdate>=$enddate); 
  }
  return $comp;
}

function snmp_config_manager($debug) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data;
	global $config;
	$etime = time();
	$scan_date = date("Y-m-d H:i:s");
	$current_time = strtotime("now");
	$already_one_configmanager_executed = 0;
	$one_time=1;
	$queryrows = db_fetch_assoc("select * from $cfgmngtable ");
	if ($queryrows>0) {
	  foreach($queryrows as $row) {
	  // only one download/upload file will be executed at one-time (each 5 minutes)
	  // because of the load
	    if ($row['state'] == "up") {
	     $configid=$row['id'];
	     $configtype=$row['configtype'];
	     $usepancho=$row['usepancho'];
	     //check the execution date
	     $dateok= FALSE;
	     $configdate =$row['date']; //'0000-00-00 00:00:00';
	     $lastrun= $row['lastused'];
	     // first time ?
	     $compt =comparedate($scan_date,$configdate);
	     $comp = ($compt>0) && (($lastrun=='0000-00-00 00:00:00') || ($lastrun==''));
	     // again ?
	     $date1 = (($lastrun!='')&&($lastrun!='0000-00-00 00:00:00')) ? $lastrun: $configdate;
	     $comprecurr = date_recurrence($scan_date,$date1,$row['monthly'],0
	     	,$row['mon'],$row['tue'],$row['wed'],$row['thu'],$row['fri'],$row['sat'],$row['sun']);
	     $dateok = ($comp) || ($comprecurr);
	     if ($dateok) {
	      if ($one_time) {
		// starts TFTP or something else
		$filetostartbefore= read_config_option("cfgm_file_to_start_before");
		if ($filetostartbefore!="") {
			// in case where the value as several parameters
			$prgtab= preg_split('/ /',$filetostartbefore);
			$command_string = $prgtab[0];
			unset($prgtab[0]);
			$parameters = join(" ",$prgtab);
			exec_background($command_string, $parameters);
			if ($debug) {
			  $cactilog="exec of $filetostartbefore => !";
                          $message=date("Y-m-d H:i:s")." DEBUG: $cactilog\n";
                          cfgmng_log($message);
			  cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
			}
		  sleep(1);
		}
		$one_time=0;
	      }
	      if ($debug) {
		   $cactilog="id=$configid date=$scan_date time=$current_time !";
		   cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
	      }
	      if ($configtype=="tftp") {
	        cfgmng_createTFTPconfig($configid,$debug,$configname);
	      	// method classic TFTP
	      	$prg= read_config_option('cfgm_program');
		if ($prg!='') {
			// create the download config for configmanager 
	      		configmanager_rotate_log($configname,$debug);
//	      		configmanager_create_pathdata($configid,$debug);
	      		$requestdebug= read_config_option('cfgm_snmpdebug');
	      		// in case where the value as several parameters
	      		$prgtab= preg_split('/ /',$prg);
	      		$prg1 = $prgtab[0];
	      		unset($prgtab[0]);
	      		$firstparam = join(" ",$prgtab);
		  	$parameters= $firstparam. configmanager_createparameter($configid,$debug,$requestdebug);
		  	$command_string=$prg1;
			// check TFTP activ ?
                       $message=date("Y-m-d H:i:s")." INFO: execute the upload/download configuration $configid ($configname) "
                                 . (($usepancho==1) ? "with Pancho.": "with php tftp."). "\n";
                        cfgmng_log($message);
			if ($debug) {
 			  if ($usepancho==1) $message=date("Y-m-d H:i:s")." DEBUG: exec_background($command_string $parameters).\n";
 			  else $message=date("Y-m-d H:i:s")." DEBUG: cfgmng_create_tftp_php(".print_r($row,true)."$debug).\n";
                          cfgmng_log($message);
                        }
			// execute the upload/download configuration
			if ($usepancho==1) {
			  if ($debug) {
			    $cactilog="exec_background($command_string $parameters) ";
			    cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
			  }
			  if ($config["cacti_server_os"] == "win32") {
			    exec_background($command_string, $parameters);
//			    popen("start \"Cactiplus\" /I /WAIT \"" . $command_string . "\" " . $parameters, "r");
//			    configmanager_moveallfiles($row,$debug);
			  } else {
			    exec_background($command_string, $parameters);
			  }
			} else {
			  // pure php tftp 
			  cfgmng_create_tftp_php($row,$debug);
		        }
		}
	      } else {
                        $message=date("Y-m-d H:i:s")." INFO: execute Multi method configuration $configid (".$row['name'].").\n";
                        cfgmng_log($message);
			// method "multi" for your batch or scp, ftp, ...
	      		configmanager_create_path_log_multi($row,$debug);			
	      		configmanager_init_log_multi($row,$debug);
			cfgmng_create_multi($row,$debug);
	      }
	      /* save the scan date information */
	      $sqlrequest= "update $cfgmngtable set lastused ='" . $scan_date . "' where id ='" . $configid."'";
	      $temp = db_fetch_assoc($sqlrequest);
	      $sqlrequest= "update $cfgmngtable set finishlog ='1' where id ='" . $configid."'";
	      $temp = db_fetch_assoc($sqlrequest);
	      // file to start. something like move %f% mydirectory
	      $filetostartafter= read_config_option("cfgm_file_to_start_after");
	      if ($filetostartafter!="") {
        		$year=date('Y'); $month= date('m'); $day=date('d');
	  		// replace %u%, %w%, %l%, %f%, ...
	  		$search= array('/%y%/','/%m%/','/%d%/');
	  		$replace=array($year,$month,$day);
	  		$temp1= preg_replace($search,$replace,$filetostartafter);
			// in case where the value as several parameters
			$prgtab= preg_split('/ /',$temp1);
			$command_string = $prgtab[0];
			unset($prgtab[0]);
			$parameters = join(" ",$prgtab);
			exec_background($command_string, $parameters);
			if ($debug) {
                         $message=date("Y-m-d H:i:s")." INFO: execute $filetostartafter\n";
                         cfgmng_log($message);
			 $cactilog="after exec of $command_string with parameters $parameters => !";
			 cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
			}
		}
		// only one file each 5 minutes
		$already_one_configmanager_executed = 1;
		break;
	      } else {
	      	 // if finishlog is set to 1 so we are 5 minutes after the download
	      	 // we can copy the log of this configmanager for TFTP pancho
	         $finishlog= $row['finishlog'];
	         if ($configtype=="tftp") {
	           $origconfigname = $row['name'];
		   $path = $row['path'];
		   $configname=configmanager_createfullcfgname($configid,$path,$origconfigname);
	           if ($usepancho==1) {
                     //Check to see if all the devices have reported back in the log file
                     $logfilelinecount = count(file($configname . ".log"));
                     $sqlrequest = "select * from plugin_cfgmng_data where configmanagerid='" . $configid . "' and state = 'enable'";
                     $temp = db_fetch_assoc($sqlrequest);
                     $devicecount = count($temp);
                     if (($finishlog=="1") && ($logfilelinecount<$devicecount)) {
                      $message=date("Y-m-d H:i:s")." INFO: " . $configname . ".log has " . $logfilelinecount . " of " . $devicecount . " devices with a reported status.  Not copying logfile yet.\n";
                      cfgmng_log($message);
                      $finishlog="0";
                     }
                   }
                   // copy pancho log in configmanagerlog
	      	   if (($finishlog=="1")&&($usepancho==1)) {
	  	      $confignamelog = $configname .".log";
	      	      if (is_file($confignamelog)) {
	               $message=date("Y-m-d H:i:s")." COPY LOGFILE $configname.\n";
                       cfgmng_log($message);
	      	       // copy the log file
	      	       $filelog = fopen($confignamelog, "r");
		       while (1) {
		         $line = fgets($filelog);
	  	         $search= array('/^(.*\])/');
	  	         $replace=array('');
	  	         $linex= preg_replace($search,$replace,$line);
		         if (feof($filelog)) { break;
		         }else{
			   $message=date("Y-m-d H:i:s")." ".$linex;
                           cfgmng_log($message);
		         }
		       }
		       if (file_exists($confignamelog)) {
		       	// clear the logfile before to clear it because in some case the system refuse the removing
                        $handle=fopen($confignamelog,"w");
                        if ($handle) fclose($handle);
                        // clear the log
		       	unlink($confignamelog);
		       }
		     }
	           }
	      	   // not read a second time
	           $sqlrequest= "update $cfgmngtable set finishlog ='0' where id ='" . $configid."'";
	           $temp = db_fetch_assoc($sqlrequest);
	      	 }
	      }
	    }
	  }
	  // if none config has been executed we can look at the traps (to reduce the load)
	  if ($already_one_configmanager_executed==0) {
	     $cfgm_accepttrapsylog =read_config_option("cfgm_accepttrapsylog");
             if ($cfgm_accepttrapsylog=="on") {
                $p = $config["base_path"];
                $val = read_config_option("cfgm_debug");
                ($val=="on") ? $debugmode="-d" : $debugmode="";
                if ($config["cacti_server_os"] == "unix") {
                   $command_string = read_config_option("path_php_binary");
                   $extra_args = "-q " . $p . "/plugins/configmanager/configmanager_trap_poller.php ".$debugmode;
                } else {
                  $winpathfile = read_config_option("path_php_binary");
                  $command_string = strtr($winpathfile,"\\", "/");
                  $mfile=strtr($p,"\\", "/"). "/plugins/configmanager/configmanager_trap_poller.php ".$debugmode;
                  $extra_args = "-q " . strtolower($mfile);
                }
                exec_background($command_string, $extra_args);
             }
	  }
	}
}

?>
