<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************
    Author ......... Jean-Michel Pepin
    Modified ....... .
    Program ........ part for analysing if the Syslog Databank has some Trap for
     change of configuration and starts TFTP or Multi method for these hosts
     
*******************************************************************************/

$dir = dirname(__FILE__);
chdir($dir);
if (strpos($dir, 'configmanager') !== false) {
	chdir('../../');
}

/* Start Initialization Section */
include("./plugins/configmanager/config.php");
include("./include/config.php");
include_once("./plugins/configmanager/debug.php");
if (is_file("./include/global.php")) {
  include("./include/global.php");
} else {
  // old cacti + plugin architecture (before 0.8.7)
  include("./include/config.php");
}
include("./lib/poller.php");
include("./plugins/configmanager/configmanager_gateway_method_multi.php");
include("./plugins/configmanager/configmanager_gateway_php_tftp.php");

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
  die("<br><strong>This script is only meant to run at the command line.</strong>");
}

/* We are not talking to the browser */
$no_http_headers = true;

$cfgm_accepttrapsylog =read_config_option("cfgm_accepttrapsylog");
if ($cfgm_accepttrapsylog=="on") {
  $syslogpluginname = (is_file("./include/global.php")) ? "syslog" :"haloe";
  if (in_array($syslogpluginname, $plugins)) {
    readparameters($isdebug,$isstoprun);
    if ($isdebug) {
    	$message=date("Y-m-d H:i:s ")."TRAP analyze."."\n";
        cfgmng_log($message);
    }
    config_manager_trap($isdebug);
  }
}
exit;

function readparameters(&$debug,&$stoprun) {
	/* process calling arguments */
	$parms = $_SERVER["argv"];
	array_shift($parms);
	$debug = FALSE;
	$stoprun = FALSE;
	foreach($parms as $parameter) {
		@list($arg, $value) = @explode("=", $parameter);
		switch ($arg) {
		case "-d":
			$debug = TRUE;
			break;
		case "--help":
			display_help();
			exit;
		case "-h":
			display_help();
			exit;
		case "-x":
			$stoprun = TRUE;
			break;
		case "--version":
			display_help();
			exit;
		case "-v":
			display_help();
			exit;
		default:
			print "ERROR: Invalid Parameter " . $parameter . "\n\n";
			display_help();
			exit;
		}
	}
}

/*	display_help - displays the usage of the function */
function display_help () {
	print "Configmanager plugin Traps poller. Plugin for downloading/uploading the configuration of switches or routers using as reference the Syslog Database.\n";
	print "usage: configmanager_trap_poller.php [ [-d] | [-x] | [-h | --help] | [-v | --version]\n\n";
	print "-x            - stop the execution\n";
	print "-d            - Display verbose output during execution\n";
	print "-v --version  - Display this help message\n";
	print "-h --help     - display this help message\n";
}

function config_manager_trap($debug) {
 global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data,$cfgmngtable_trap;
 global $config;
 global $database_hostname,$database_username,$database_password,$database_default, $database_type;
if (is_file("./include/global.php")) {
  include_once("./plugins/syslog/config.php");
} else {
  // old cacti + plugin architecture (before 0.8.7) + old haloe/syslog
  include_once("./plugins/haloe/config.php");
  $syslog_config = $haloe_config;
  $syslogdb_hostname = $haloedb_hostname;
  $syslogdb_username = $haloedb_username;
  $syslogdb_password = $haloedb_password;
  $syslogdb_default = $haloedb_default;
  $syslogdb_type = $haloedb_type;
}

    $sqlqueryconfig= "SELECT count(*) FROM $cfgmngtable "
                        ."WHERE accepttrap=1 AND state='up' AND up_download='download'";
    $num_count = db_fetch_cell($sqlqueryconfig);
    if ($num_count<1) {
    	exit();
    }

    $trapsfile = $config["base_path"]."/plugins/configmanager/configmanager_trap_list.txt";
    $etime = time();
    $scan_date = date("Y-m-d H:i:s");
    $cfgm_accepttrapdelay =intval(read_config_option("cfgm_accepttrapdelay"));
    //strtotime("2007-01-15 11:40:00");
    $pattern = "/^(\d{4})-(\d{1,2})-(\d{1,2}) (\d{1,2}):(\d{2}):(\d{2})$/";
//print "scan_date=$scan_date";
    list($year,$month,$day,$hours,$minutes,$seconds) = preg_split ($pattern, $scan_date, -1, PREG_SPLIT_DELIM_CAPTURE | PREG_SPLIT_NO_EMPTY);
    $delaydate = date("Y-m-d H:i:s",mktime ( intval($hours) , intval($minutes)-$cfgm_accepttrapdelay, intval($seconds)
                    , intval($month),intval($day), intval($year)));
    // LOAD the trap events
    /* read logfile into an array and display */
    $list_of_traps = array();
    $list_restriction = array();
    $emty_file=1;
    if (is_file($trapsfile)) {
      $trapscontents = file($trapsfile);
      foreach ($trapscontents as $item) {
      	$new_item = ltrim($item);
      	$a_traps = preg_split('/[;|\n]/',$new_item);
      	$vendor = isset($a_traps[0]) ? $a_traps[0]: "";
        $exists = strpos($vendor,"#");
      	if (($new_item!="") && ($exists===false) ) {
      	  $vendoroid = isset($a_traps[1]) ? $a_traps[1] : "";
      	  $trap = isset($a_traps[2])? $a_traps[2] : "";
	  $searchcmd= array('/\n+$/','/\s+$/');
	  $replacecmd=array('','');
	  $trap= preg_replace($searchcmd,$replacecmd,$trap);
      	  if (count($trap)>0) {
      	    if (($vendor=="-1") || ($vendoroid=="-1")) {
      	      $list_restriction[] = $trap;
      	      $list_restrictionoid[] = ($vendoroid=="-1") ? "":$vendoroid;
      	    }
      	    else {
      	      $emty_file=0;
              $list_of_traps[] = $trap;
              $list_of_trapsoid[] = $vendoroid;
            }
          }
        }
      }
    }

// FOR DEBUG
//$message=date("Y-m-d H:i:s ")."List of traps =".print_r($list_of_traps,true)."\n";
//cfgmng_log($message);
//$message=date("Y-m-d H:i:s ")."SQL request =".$sqlrequest."\n";
//cfgmng_log($message);
// END FOR DEBUG
    if ($emty_file==1) {
    	$trapsfile= array();
        if ($debug) {
        	$message ="$scan_date ERROR: the file with the traps events has no traps.\n";
        	cfgmng_log($message);
        }
    	exit;
    }
    // search the events
    db_connect_real($database_hostname,$database_username,$database_password,$database_default, $database_type);
    $datelastsearch = ""; //"Y-m-d H:i:s"
    $sqlquerydata = "SELECT * FROM $cfgmngtable_trap";
    $querydata = db_fetch_assoc($sqlquerydata);
    if (sizeof($querydata)>0) {
	$datelastsearch = $querydata[0]["lastanalyzed"];
	$idlastsearch = $querydata[0]["id"];
    } else {
      $sqlrequest= "INSERT INTO $cfgmngtable_trap (id,lastanalyzed) VALUE (1,'0000-00-00 00:00:00')";
      $temp = db_fetch_assoc($sqlrequest);
      $datelastsearch = '0000-00-00 00:00:00';
    }
    if ($datelastsearch == '0000-00-00 00:00:00') $datelastsearch ="";
    $current_time = strtotime("now");
    db_connect_real($syslogdb_hostname,$syslogdb_username,$syslogdb_password,$syslogdb_default, $syslogdb_type);
    // search between now and the last time the traps have been analyzed
    $sql_where = "";
    if (!empty($datelastsearch)) {
        $sql_where .= " where (concat(DATE_FORMAT(" . $syslog_config["dateField"] . ",'%Y-%m-%d'),' ',TIME_FORMAT(" . $syslog_config["timeField"] . ",'%H:%i:%s'))"
                      ." BETWEEN '". $datelastsearch . "' AND '" . $delaydate . "' ) ";
    }
    if (sizeof($list_of_traps)>0) {
     if (!empty($sql_where)) {
       	 $sql_where .= "\n AND (";
     } else { $sql_where .= "\n WHERE ("; }
     $i=0;
     foreach ( $list_of_traps as $ndx => $val) {
      if (!empty($val)) {
	 $sql_where .= (($i==0)?"(":"\n OR (") . $syslog_config["textField"] . " like '%%" . $val . "%%'";
	 $valoid = $list_of_trapsoid[$ndx];
	 if ($valoid!="") $sql_where .= " AND " .$syslog_config["textField"] . " like '%" . $valoid . "%'";
	 $sql_where .= ")\n";
      }
      $i++;
     }
     $sql_where .= " )";
    }
    if (sizeof($list_restriction)>0) {
     if (!empty($sql_where)) {
       	 $sql_where .= " AND \n (";
     } else { $sql_where .= "\n WHERE ("; }
     $i=0;
     foreach ( $list_restriction as $ndx => $val) {
      if (!empty($val)) {
	 $sql_where .= (($i==0)?" \nNOT(":" \n and NOT (") .$syslog_config["textField"] . " like '%" . $val . "%'";
	 $valoid = $list_restrictionoid[$ndx];
	 if ($valoid!="") $sql_where .= " \n AND " .$syslog_config["textField"] . " like '%" . $valoid . "%'";
	 $sql_where .= ")";
      }
      $i++;
     }
     $sql_where .= " )";
    }
    $sqlrequest= "SELECT ".$syslog_config["hostField"].",".$syslog_config["dateField"].",".$syslog_config["timeField"].",".$syslog_config["textField"]
		." FROM " . $syslog_config["syslogTable"] . " \n" .$sql_where . "\n"
		." ORDER BY " . $syslog_config["dateField"] ."\n"
		. " ASC," . $syslog_config["timeField"] . " ASC," . $syslog_config["hostField"];
    $syslog_messages = db_fetch_assoc($sqlrequest);
    $events = array();
    if (sizeof($syslog_messages) > 0) {
      foreach ($syslog_messages as $syslog_message) {
      	// in this ways we remove the doubles
      	$events[$syslog_message[$syslog_config["hostField"]]]
      	   = array("dateField"=>$syslog_message[$syslog_config["dateField"]]
      	          ,"timeField"=>$syslog_message[$syslog_config["timeField"]]
      	          ,"textField"=>$syslog_message[$syslog_config["textField"]]
      	          ,"active"=>0
      	          ,"hostid"=>0
      	          ,"configmanagerid"=>0);
      }
    }
   // search the configs for these hosts
   // ONLY when state is 'up', accepttrap is on, config has 'download', date later as lastused
    db_connect_real($database_hostname,$database_username,$database_password,$database_default, $database_type);
    if (sizeof($events) > 0) {
      $t2= $cfgmngtable_data;
      $t1= $cfgmngtable;
      foreach ($events as $host=>$event) {
      	$sqlquerydata = "SELECT t2.id AS dataid, t2.hostid,t2.configmanagerid,t2.hostname,t2.hostip,t1.id,t1.accepttrap from $cfgmngtable_data AS t2, $cfgmngtable AS t1 "
      	               ."WHERE t1.accepttrap='1' AND (t2.hostname LIKE '" . $host . "'"
      	               ." OR t2.hostip like '".$host."')";
        $querydata = db_fetch_assoc($sqlquerydata);
        if (sizeof($querydata)>0) {
	 foreach($querydata as $data) {
	  if (sizeof($data)>0) {
	   $longdate = $event["dateField"]." ".$event["timeField"];
           $sqlqueryconfig= "SELECT id,lastused from $cfgmngtable "
                        ."WHERE id='".$data['configmanagerid']."' "
                        ." AND accepttrap=1"
                        ." AND state='up' AND up_download='download'"
                        ." AND lastused <'". $longdate . "' AND lastused <='" . $delaydate . "'"
                        ." ";
           $queryconfig = db_fetch_assoc($sqlqueryconfig);
           if (sizeof($queryconfig)>0) {
            $itimeevent = strtotime($longdate);
            $itimelastused = strtotime($queryconfig[0]["lastused"]);
	    $search= '/'.$data["tftp"].'/';
	    $param = $event["textField"];
	    $result= preg_match($search,$param);
//            $message=date("Y-m-d H:i:s ")."Detected for timeevent($longdate)=$timeevent, itimelastused($itimelastused)=$itimelastused";
//            cfgmng_log($message);
            if (($result<=0) || (($itimelastused+60)<$itimeevent)) {
              $events[$host]["active"]=1;
              $events[$host]["dataid"]=$data["dataid"];
              $events[$host]["hostid"]=$data["hostid"];
              $events[$host]["configmanagerid"]=$data["configmanagerid"];
              break;
            }
           }
          }
      	 }
       }
     }
    }
    $message="";
    if (sizeof($events) > 0) {
      $message=date("Y-m-d H:i:s ")."Detected traps for hosts:";
      foreach ($events as $host=>$event) {
      	 $message .=$host.",";
      }
      $message .=". Analysing if the configuration is enables for traps.\n";
     cfgmng_log($message);
    $configmanagerplugin= $config["base_path"]."/plugins/configmanager/temp";
//unlink($fulllogfile)
      // put the hosts together when same configuration
      $id_list = array();
      foreach ($events as $host=>$event) {
      	$sqlreq = "SELECT * FROM ".$cfgmngtable_data." WHERE id = ".$event["dataid"];
        $hostsql = db_fetch_assoc($sqlreq);
//$message=date("Y-m-d H:i:s ")."DEBUG $sqlreq --> hostsql=".print_r($hostsql,true)." event=".print_r($event,true)."\n";
//cfgmng_log($message);
      	if (sizeof($hostsql) > 0) {
      	  $id_list[$event["configmanagerid"]][] = $hostsql[0];
      	}
      }
      // create the temporary configuration to execute
      $number=0;
      foreach ($id_list as $configid=>$template_list) {
        $info = db_fetch_assoc("SELECT * FROM $cfgmngtable WHERE id = $configid");
         if ((sizeof($info) > 0) && isset($info)) {
           $configtype=$info[0]['configtype'];
           $startup = $info[0]['startup'];
           $usepancho=$info[0]['usepancho'];
           if ($configtype=="tftp") {
            if ($usepancho==1) {
	     // method classic TFTP
	     $confignamebase=$configmanagerplugin."/temptrapcfg".$number.".conf";
	     cfgmng_createTFTPconfigTab($configid,$debug,$info,$confignamebase,$template_list,$configname);
// FOR DEBUG
//$message=date("Y-m-d H:i:s ")."DEBUG TFTP configid=$configid template_list=".print_r($template_list,true)." configname=$configname\n";
//cfgmng_log($message);
// END FOR DEBUG
             $number++;
	      	$prg= read_config_option('cfgm_program');
		if ($prg!='') {
			// create the download config for configmanager 
	      		configmanager_rotate_log($configname,$debug);
	      		$requestdebug= read_config_option('cfgm_snmpdebug');
	      		// in case where the value as several parameters
	      		$prgtab= preg_split('/ /',$prg);
	      		$prg1 = $prgtab[0];
	      		unset($prgtab[0]);
	      		$firstparam = join(" ",$prgtab);
	                $param2= "--download";
	                $param3= "" . (($startup==1) ? " --start " : "");
	                $param= $param3 . " ".$param2. " --pre --post --config ".$configname;
		  	$parameters= $firstparam. $param;
		  	$command_string=$prg1;
			// check TFTP activ ?
                        $message=date("Y-m-d H:i:s")." INFO: execute the download configuration $configid ($configname) with Pancho.\n";
                        cfgmng_log($message);
			// execute the upload/download configuration
			if ($debug) {
//			  $cactilog="exec_background($command_string $parameters) ";
//			  cacti_log("CFG MANAGER:$cactilog\n",true,"SYSTEM");
                          $message=date("Y-m-d H:i:s")." DEBUG: exec_background($command_string $parameters).\n";
                          cfgmng_log($message);
			}
			if ($config["cacti_server_os"] == "win32") {
			    exec_background($command_string, $parameters);
			} else {
			    exec_background($command_string, $parameters);
			}
		}
	    } else {
	    	 // method tftp  pure PHP
     	         $message=date("Y-m-d H:i:s")." INFO: execute TFTP pure PHP.";
     	         $partmess="";
     	         foreach ($template_list as $template) {
		    $hostname=$template["hostname"];
		    $hostip=$template["hostip"];
		    if ($partmess=="") $partmess.= " for $hostname($hostip)"; else $partmess.= ",$hostname($hostip)";
		 }
		 $message.= $partmess ."\n";
     	         cfgmng_log($message);
	    	 cfgmng_create_tftp_phpTab($info[0],$debug,$template_list);
	    }
	    /* save the scan date information */
	    $sqlrequest= "update $cfgmngtable set lastused ='" . $scan_date . "' where id ='" . $configid."'";
	    $temp = db_fetch_assoc($sqlrequest);
           } else {
     	     // method "multi" for your batch or scp, ftp, ...
     	     $message=date("Y-m-d H:i:s")." INFO: execute Multi method configuration $configid.";
     	     $partmess="";
     	     foreach ($template_list as $template) {
		    $hostname=$template["hostname"];
		    $hostip=$template["hostip"];
		    if ($partmess=="") $partmess.= " for $hostname($hostip)"; else $partmess.= ",$hostname($hostip)";
             }
             $message.= $partmess ."\n";
     	     cfgmng_log($message);
	     $confignamebase=$configmanagerplugin."/temptrapcfg".$number.".conf";
     	     configmanager_create_path_log_multi($info[0],$debug);
     	     configmanager_init_log_multi($info[0],$debug);
             cfgmng_create_multiTab($info[0],$debug,$template_list);
           }
         }
       }
    }
   
   // not read a second time
   $sqlrequest= "UPDATE $cfgmngtable_trap SET lastanalyzed ='".$delaydate."' where id =1";
   $temp = db_fetch_assoc($sqlrequest);
   if ($debug) {
     $message=date("Y-m-d H:i:s ")."DEBUG: read event ".(($datelastsearch=="")?"":("from ".$datelastsearch." "))."until ".$delaydate."\n";
     cfgmng_log($message);
   }
}

?>
