<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
define("CFGMNGVERSIONPLUGIN", "0.76");

$dir = dirname(__FILE__);
chdir($dir);
if (strpos($dir, 'configmanager')!==false) {
	chdir('../../');
}

/* Start Initialization Section */

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

include("./plugins/configmanager/config.php");
include("./plugins/configmanager/debug.php");
if (is_file("./include/global.php")) {
  include("./include/global.php");
} else {
  // old cacti + plugin architecture (before 0.8.7)
  include("./include/config.php");
}
include_once("./lib/database.php");
upgrade();
exit;

function cfgmng_log2($message) {
    print "$message\n";
}
  
function upgrade() {
  global $config;
  global $cfgmngtable_basis,$database_default,$cfgmngtable,$cfgmngtable_data,$cfgmngtable_trap;

/* older release */
$message=date("d/m/Y H:i:s ")."INFO: Database upgrade.\n";
cfgmng_log($message);
print "database_default=$database_default,cfgmngtable=$cfgmngtable,cfgmngtable_data=$cfgmngtable_data. config[base_path]=".$config["base_path"]."\n";

print "upgrade from release before 0.4 \n";
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `configtype` varchar(10) NOT NULL default 'tftp';");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `command` varchar(255) NOT NULL default '';");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `templatename` varchar(100) NOT NULL default '';");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `post` varchar(250) NOT NULL default '';");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `pre` varchar(250) NOT NULL default '';");
print db_execute("ALTER TABLE `configmanager` DEL COLUMN `fileformat`;");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `fileformat` varchar(50) NOT NULL default '::HOST::.::DATE::.cfg';");
print "\n";
/* for release X to 0.4f */
print "upgrade from release X to 0.4f \n";
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `commit` tinyint(1) unsigned NOT NULL default '0';");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `startup`tinyint(1) unsigned NOT NULL default '0';");
print db_execute("ALTER TABLE `configmanager` ADD COLUMN `reload`tinyint(1) unsigned NOT NULL default '0';");
print "\n";

print "upgrade from release 0.4f to 0.5 \n";
$sql = "show tables from `" . $database_default . "`";
$result = db_fetch_assoc($sql) or die (mysql_error());
	$tables = array();
	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
}
	$sql = array();
	$currentcfgmngversion="";
	if (!in_array($cfgmngtable_basis, $tables)) {
	  $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable_basis (
  id int(11) NOT NULL auto_increment,
  version varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;";
	  $sql[] = "INSERT INTO $cfgmngtable_basis (id, version) VALUES (1, '".CFGMNGVERSIONPLUGIN."');";
	  $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
          $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable_basis. -> result=$result\n";
          cfgmng_log($message);
        } else {
	  $sqlrequest = "SELECT * FROM $cfgmngtable_basis";
	  $info = db_fetch_assoc($sqlrequest);
	  if ((sizeof($info) > 0) && isset($info)) {
	    $currentcfgmngversion=$info[0]['version'];
	  }
        }
	if (!in_array($cfgmngtable, $tables)) {
	  if (in_array('configmanager', $tables)) {
            //  upgrade
	    unset($sql);$sql = array();
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `tftp` varchar(100) NOT NULL default '';";
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `usepancho`  tinyint(11) NOT NULL default '1';";
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `accepttrap`  tinyint(11) NOT NULL default '0';";
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `finishlog`  tinyint(11) NOT NULL default '0';";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a]);}}
            $message=date("Y-m-d H:i:s ")."Upgrade of SQL data configmanager before renaming. -> result=$result\n";
            cfgmng_log($message);
	    unset($sql);$sql = array();
            $sql[] = "CREATE TABLE $cfgmngtable SELECT * FROM configmanager;";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a]);}}
            $message=date("Y-m-d H:i:s ")."Copy of SQL table configmanager. -> result=$result\n";
            cfgmng_log($message);
          } else {
            //  very new installation
            unset($sql);$sql = array();
	    $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable (
  id int(10) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  configtype varchar(10) NOT NULL default 'tftp',
  state enum('up','down','error','failed') NOT NULL default 'down',
  PCmanager varchar(100) NOT NULL default '',
  up_download enum('download','upload') NOT NULL default 'download',
  path varchar(100) NOT NULL default '',
  pathdata varchar(100) NOT NULL default '',
  fileupload varchar(100) NOT NULL default '',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  monthly  tinyint(11) NOT NULL default '0',
  mon  tinyint(11) NOT NULL default '0',
  tue  tinyint(11) NOT NULL default '0',
  wed  tinyint(11) NOT NULL default '0',
  thu  tinyint(11) NOT NULL default '0',
  fri  tinyint(11) NOT NULL default '0',
  sat  tinyint(11) NOT NULL default '0', 
  sun  tinyint(11) NOT NULL default '0',
  lastused datetime default '0000-00-00 00:00:00',
  snmp_version tinyint(1) unsigned NOT NULL default '1',
  snmp_username varchar(100) NOT NULL default '',
  snmp_password varchar(100) NOT NULL default '',
  snmp_community varchar(100) NOT NULL default '',
  snmp_auth_protocol varchar(5) default 'MD5',
  snmp_priv_passphrase varchar(200) default '',
  snmp_priv_protocol varchar(6) default '',
  command varchar(255) NOT NULL default '',
  templatename varchar(100) NOT NULL default '',
  post varchar(250) NOT NULL default '',
  pre varchar(250) NOT NULL default '',
  fileformat varchar(50) NOT NULL default '::HOST::.::DATE::.cfg',
  commit tinyint(1) unsigned NOT NULL default '0',
  startup tinyint(1) unsigned NOT NULL default '0',
  reload tinyint(1) unsigned NOT NULL default '0',
  tftp varchar(100) NOT NULL default '',
  usepancho  tinyint(11) NOT NULL default '1',
  accepttrap  tinyint(11) NOT NULL default '0',
  finishlog  tinyint(11) NOT NULL default '0',
  delay  int(10) NOT NULL default '0',
  KEY id (id)
  ) TYPE=MyISAM;";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
            $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable. -> result=$result\n";
            cfgmng_log($message);
          }
        }
	if (!in_array($cfgmngtable_data, $tables)) {
	  if (in_array('configmanager_data', $tables)) {
            //  upgrade
	    unset($sql);$sql = array();
            $sql[] = "CREATE TABLE $cfgmngtable_data SELECT * FROM configmanager_data;";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a]);}}
            $message=date("Y-m-d H:i:s ")."Copy of SQL table configmanager_data. -> result=$result\n";
            cfgmng_log($message);
          } else {
            //  very new installation
            unset($sql);$sql = array();
	    $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable_data (
  id int(10) NOT NULL auto_increment,
  configmanagerid int(10) NOT NULL default '0',
  hostid int(10) NOT NULL default '0',
  hostname varchar(100) NOT NULL default '',
  hostip varchar(100) NOT NULL default '',
  snmp_version tinyint(1) unsigned NOT NULL default '1',
  hostuser varchar(100) NOT NULL default '',
  hostpassword varchar(100) NOT NULL default '',
  hostcommunity varchar(100) NOT NULL default '',
  state enum('enable','disable','error','failed') NOT NULL default 'enable',
  gorder int(5) NOT NULL default '0',
  KEY id (id)
  ) TYPE=MyISAM;";
	  $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
          $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable_data. -> result=$result\n";
          cfgmng_log($message);
	 }
        }
        if (!isset($cfgmngtable_trap)) $cfgmngtable_trap = "plugin_cfgmng_trap";
	if (!in_array($cfgmngtable_trap, $tables)) {
            unset($sql);$sql = array();
	    $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable_trap (
  id int(11) NOT NULL auto_increment,
  lastanalyzed datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;";
	  $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
          $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable_trap. -> result=$result\n";
          cfgmng_log($message);
        }
	// check again before drop
	unset($tables);
	$showsql = "show tables from `" . $database_default . "`";
	$result = db_fetch_assoc($showsql) or die (mysql_error());
	$tables = array();
	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}
	if (($cfgmngtable!='configmanager') && (in_array('configmanager', $tables))) {
	  // remove the tables
	  $sqlrequest = "RENAME TABLE configmanager TO OLDconfigmanager;";
	  $result = mysql_query($sqlrequest)?"OK":"ERROR";
          $message=date("Y-m-d H:i:s ")."$sqlrequest -> result=$result\n";
          cfgmng_log($message);
	}
	if (($cfgmngtable_data!='configmanager_data') && (in_array('configmanager_data', $tables))) {
	  // remove the tables
	  $sqlrequest = "RENAME TABLE configmanager_data TO OLDconfigmanager_data;";
	  $result =mysql_query($sqlrequest)?"OK":"ERROR";
          $message=date("Y-m-d H:i:s ")."$sqlrequest -> result=$result\n";
          cfgmng_log($message);
	}
        // correct Bug of auto_increment
	if (($currentcfgmngversion=="0.5")||($currentcfgmngversion=="0.5a")
	      ||($currentcfgmngversion=="0.5b")||($currentcfgmngversion=="0.5c")) {
	    unset($sql);$sql = array();
	    $sql[] = "ALTER TABLE $cfgmngtable_data MODIFY column id INT NOT NULL AUTO_INCREMENT,ADD INDEX (id)";
	    $sql[] = "ALTER TABLE $cfgmngtable MODIFY column id INT NOT NULL AUTO_INCREMENT,ADD INDEX (id)";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK,":"ERROR,";}}
            $message=date("Y-m-d H:i:s ")."Correct the SQL auto_increment id. -> result=$result\n";
            cfgmng_log($message);
	}
	if (floatval($currentcfgmngversion)<= 0.5) {
            //  upgrade
	    unset($sql);$sql = array();
	    $sqlreq = "ALTER TABLE $cfgmngtable ADD COLUMN `delay` int(10) NOT NULL default '0';";
	    $result = mysql_query($sqlreq);
            $message=date("Y-m-d H:i:s ")."Upgrade of SQL data $cfgmngtable $sqlreq . -> result=$result\n";
            cfgmng_log($message);
        }
	if (floatval($currentcfgmngversion)< 0.71) {
            //  upgrade
	    unset($sql);$sql = array();
	    $sqlreq = "ALTER TABLE $cfgmngtable ADD COLUMN `binair` tinyint(11) NOT NULL default '0';";
	    $result = mysql_query($sqlreq);
            $message=date("Y-m-d H:i:s ")."Upgrade of SQL data $cfgmngtable $sqlreq . -> result=$result\n";
            cfgmng_log($message);
        }
	if (floatval($currentcfgmngversion)< 0.76) {
            //  upgrade
	    unset($sql);$sql = array();
            $sql[] = "ALTER TABLE $cfgmngtable ADD COLUMN `snmp_priv_protocol` varchar(6) default '' after snmp_community";
            $sql[] = "ALTER TABLE $cfgmngtable ADD COLUMN `snmp_priv_passphrase` varchar(200) default '' after snmp_community";
            $sql[] = "ALTER TABLE $cfgmngtable ADD COLUMN `snmp_auth_protocol` varchar(5) default 'MD5' after snmp_community";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK,":"ERROR,";}}
            $message=date("Y-m-d H:i:s ")."Correct the SQL auto_increment id. -> result=$result\n";
            cfgmng_log($message);
        }
        // INSERT the new version number
	if (in_array($cfgmngtable_basis, $tables) && ($currentcfgmngversion!=CFGMNGVERSIONPLUGIN)) {
	    $save["id"] = "1";
	    $save["version"] = CFGMNGVERSIONPLUGIN;
	    $id2 = sql_save($save, "$cfgmngtable_basis");
            $message=date("Y-m-d H:i:s ")
                    ."update version number from $currentcfgmngversion to ".CFGMNGVERSIONPLUGIN
                    .". -> result=".(($id2)?"OK($id2)":"ERROR")."\n";
            cfgmng_log($message);
	}
}


?>