<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004 Ian Berry                                            |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | cacti: a php-based graphing solution                                    |
 +-------------------------------------------------------------------------+
 | Most of this code has been designed, written and is maintained by       |
 | Ian Berry. See about.php for specific developer credit. Any questions   |
 | or comments regarding this code should be directed to:                  |
 | - iberry@raxnet.net                                                     |
 +-------------------------------------------------------------------------+
 | - raXnet - http://www.raxnet.net/                                       |
 +-------------------------------------------------------------------------+
 + change for configmanager
*/

/* html_start_box2 - draws the start of an HTML box with an optional title
   @arg $title - the title of this box ("" for no title)
   @arg $width - the width of the box in pixels or percent
   @arg $background_color - the color of the box border and title row background
     color
   @arg $cell_padding - the amount of cell padding to use inside of the box
   @arg $align - the HTML alignment to use for the box (center, left, or right)
   @arg $fct_text - the url to use when the user clicks 'Add' in the upper-right
     corner of the box ("" for no 'Add' link) */
function html_start_box2($title, $width, $background_color, $cell_padding, $align, $fct_text,$slt_text) {
	global $colors; ?>
	<table align="<?php print $align;?>" width="<?php print $width;?>" cellpadding=1 cellspacing=0 border=0 bgcolor="#<?php print $background_color;?>">
	  <tr>
	   <td>
	   <table cellpadding=<?php print $cell_padding;?> cellspacing=0 border=0 bgcolor="#<?php print $colors["form_background_dark"];?>" width="100%">
		<?php if ($title != "") {?><tr>
		<td bgcolor="#<?php print $background_color;?>" style="padding: 3px;" colspan="10">
		<table width="100%" cellpadding="0" cellspacing="0">
		  <tr>
		  <td bgcolor="#<?php print $background_color;?>" class="textHeaderDark"><?php print $title;?></td>
		  <?php if ($fct_text != "") {?><td class="textHeaderDark" align="right" bgcolor="#<?php print $colors["header"];?>"><strong><a class="linkOverDark" href="<?php print $fct_text?>"><?php print $slt_text;?></a>&nbsp;</strong></td><?php }?>
		  </tr>
	        </table>
	   </td>
	  </tr><?php }?>

<?php }

function html_start_box_withouttitle($width, $background_color, $cell_padding, $align) {
	global $colors;
	print "<table align='"
	       .$align."' width='".$width."' cellpadding=1 cellspacing=0 border=0 bgcolor='#".$background_color."'>";
	print "<tr><td>
		<table cellpadding='".$cell_padding."' cellspacing=0 border=0 bgcolor='#".$colors["form_background_dark"]."' width='100%'>";
}


/* html_header_checkbox - draws a header row with a 'select all' checkbox in the last cell
     suitable for display inside of a box element
   @arg $header_items - an array containing a list of items to be included in the header
   @arg $form_action - the url to post the 'select all' form to */
function html_header_severalcheckbox($header_items, $form_action,$formname,$prefix) {
	global $colors;
        if ($prefix=="") $prefix="chk";
	/* default to the 'current' file */
	if ($form_action == "") { $form_action = basename($_SERVER["PHP_SELF"]); }

	print "<tr bgcolor='#" . $colors["header_panel"] . "'>\n";

	for ($i=0; $i<count($header_items); $i++) {
		print "<td class='textSubHeaderDark'>" . $header_items[$i] . "</td>\n";
	}

	print "<td width='1%' align='right' bgcolor='#819bc0' style='". get_checkbox_style(). "'>";
//SelectAllSeveralCheckbox(\"".$formname."_\",this.checked)
//	$txt="SelectAllSeveralCheckbox(\"this.".$formname.".chk.".$prefix."_\",this.checked)";
	$txt="SelectAllSeveralCheckbox(\"".$formname."\",\"".$prefix."_\",this.checked)";
	print "<input type='checkbox' style='margin: 0px;' name='all' title='Select All' onClick='".$txt."'>";
//	print "</td>\n<form name=".$formname." method='post' action='$form_action'>\n";
	print "</tr>\n";
}

function html_authentification_error() {
?>
<html>
<head>
	<title>cacti error</title>
</head>
<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<script type="text/javascript">
alert("error ! No rights to do this from your worstation. !!");
</script>
</body>
</html>
<?php
}

function cfgmngdraw_actions_add($basislink) {
	global $config;
	?>
	<table align='center' width='98%'>
	  <tr>
	    <td width='1' valign='top'>
	    </td>
	    <td align='right'>
	    </td>
	    <td width='1' align='right'>
		<a class='linkEditMain' href='<?php echo $basislink."&sub=add"; ?>'>
		<img src='<?php echo $config['url_path']; ?>images/button_add.gif' alt='Go' border='0'>
		</a>
	    </td>
	  </tr>
	</table>
	<?php
}

function cfgmngdraw_actions_addN($name,$strURL) {
	global $config;
	?>
	<table align='center' width='98%'>
	  <tr>
	    <td width='1' valign='top'>
	    </td>
	    <td align='right'>
	    </td>
	    <td width='1' align='right'>
		<button name='<?php echo $name; ?>' type='button' value='nothing'
			 onclick='this.form.<?php echo $name; ?>.value="activ"; document.location = "<?php echo $strURL?>"'>
		  <img src='<?php echo $config['url_path']; ?>images/button_add.gif' alt='add'>
		</button>
	    </td>
	  </tr>
	</table>
	<?php
}

?>