<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************

    Author ......... Jean-Michel Pepin plugin for Cacti (PEPJ in forum.cacti.net)
    Modified ....... .
    Program ........ Download/Upload configuration manager for Cacti
    Version plugin . see below

    per default I will use Pancho for the method TFTP
    Contact for Pancho .... Charles Menzes http://www.pancho.org/
			, http://freshmeat.net/projects/pancho/

*******************************************************************************/

define("CFGMNGVERSIONPLUGIN", "0.76");
define("CFGMNGREALMPLUGIN", "70");

function configmanager_version () {
	return array( 'name' 	=> 'configmanager'
			,'version'	=> CFGMNGVERSIONPLUGIN
			,'longname'	=> 'Configuration manager'
			,'author'	=> 'Pepin Jean-Michel'
			,'homepage'	=> 'http://www.cactiusers.net'
			,'email'		=> ''
			,'url'		=> ''
		      );
}

function plugin_init_configmanager() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['configmanager'] = 'configmanager_config_arrays';
	$plugin_hooks['config_settings']['configmanager'] = 'configmanager_config_settings';
	$plugin_hooks['draw_navigation_text']['configmanager'] = 'configmanager_draw_navigation_text';
	$plugin_hooks['poller_bottom']['configmanager'] = 'configmanager_poller_bottom';
}

function configmanager_config_settings () {
	global $tabs, $settings, $database_default, $config,$configmanager_snmp_versions,$configmanager_snmp_authprotocol;
	global $configmanager_snmp_priv_protocol;

        include_once($config["base_path"] ."/plugins/configmanager/config.php");
        include_once($config["base_path"] ."/plugins/configmanager/debug.php");
	include_once($config["base_path"] . '/plugins/configmanager/functions.php');
	include_once($config["base_path"] . '/lib/functions.php');
	$listofManagerIPs="";
	configmanager_listmanagerIPs($listofManagerIPs);
	if ($listofManagerIPs=="") $listofManagerIPs="open for all IPs! Danger !";
	$tabs["configmanager"] = "Up/Download Config Manager";
        $netsnmpsetdefault="";
        if ($config["cacti_server_os"] == "unix") {
          $netsnmpsetdefault="snmpset";
        } else {
          $netsnmpsetdefault="snmpset.exe";
        }
	$settings["configmanager"] = array(
	   "configmanager_firstdata" => array(
			"friendly_name" => "configmanager General Settings",
			"method" => "spacer",
			),
		"IPmanagers" => array(
			"friendly_name" => "The IP addresses of the manager",
			"description" => "Cannot be changed here for security reasons. Show all the IP addresses which are able to open/change the setting of the Configmanager plugin. You can insert the IP addresses in the file <path of cacti>/plugins/secure.cfg",
			"default" => $listofManagerIPs,
			"method" => "textbox",
			"max_length" => "255"
			),
		"cfgm_debug" => array(
			"friendly_name" => "debug mode",
			"description" => "debug mode for config manager (only for the GUI not SNMP request). For the SNMP debug see below.",
			"method" => "checkbox",
			"default" => "yes",
			),
		"cfgm_file_to_start_before" => array(
			"friendly_name" => "file to start before",
			"description" => "File to start before will be executed. For example starts/restart the TFTP server. With full path",
			"method" => "textbox",
			"default" => "",
			"max_length" => "200"
			),
		"cfgm_file_to_start_after" => array(
			"friendly_name" => "file to start after",
			"description" => "File to start after will be executed. For example cp /data/%y%%m%%d% mydirectory. If it is a shell to execute you have to insert the full path. %y% = year %m%=month %d%=day.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "200"
			),
		"cfgm_accepttrapsylog" => array(
			"friendly_name" => "accept traps",
			"description" => "Active this option in order to accept that traps could start configuration's file download. You have to active the option in each configmanager too.",
			"method" => "checkbox",
			"default" => "off",
			),
		"cfgm_accepttrapdelay" => array(
			"friendly_name" => "delay to wait after a trap",
			"description" => "Delay (minutes) to wait after a trap appear in order not to backup when someone is configuring this device at this time.",
			"method" => "textbox",
			"default" => "10",
			"max_length" => "5"
			),
	   "configmanager_tftp_independent" => array(
			"friendly_name" => "configmanager Settings used for TFTP shared class the pure PHP TFTP independent of Pancho. Only if needed.",
			"method" => "spacer",
			),
		"cfgm_usenetsnmp" => array(
			"friendly_name" => "use netsnmp",
			"description" => "Check it you always want use NET-SNMP.",
			"method" => "checkbox",
			"default" => "off",
			),
		"cfgm_name_snmpset" => array(
			"friendly_name" => "snmpsetname",
			"description" => "snmpset name. (default snmpset for unix, snmpset.exe for windows)."
			                ." The path will be taken from the 'Paths settings' of Cacti."
			                ." the Snmp get, walk, genext of Cacti will also be used.",
			"method" => "textbox",
			"default" => $netsnmpsetdefault,
			"max_length" => "15"
			),
	   "configmanager_panchodata" => array(
			"friendly_name" => "configmanager Settings for TFTP method with Pancho or the pure TFTP.",
			"method" => "spacer",
			),
		"cfgm_TFTPserver" => array(
			"friendly_name" => "TFTP server",
			"description" => "You can give here the TFTP server IP or name, but never 127.0.0.1",
			"method" => "textbox",
			"default" => "127.0.0.1",
			"max_length" => "20"
			),
		"cfgm_TFTPpath" => array(
			"friendly_name" => "TFTP path",
			"description" => "this setting is used to specify the tftp rootpathname of the data.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "100"
			),
		"maxupload" => array(
			"friendly_name" => "Max upload of configuration",
			"description" => "You can change here the maximum of the active Upload configuration. Too much active upload configuration could be dangerous. Too much up/down configuration could slow down the system.",
			"method" => "textbox",
			"default" => "1",
			"max_length" => "1"
			),
		"defaultpath" => array(
			"friendly_name" => "data default path",
			"description" => "default path for the data",
			"method" => "textbox",
			"default" => "/data",
			"max_length" => "255"
			),
		"defaultpathconfig" => array(
			"friendly_name" => "configurations file default path",
			"description" => "default path for the configurations files",
			"method" => "textbox",
			"default" => "/data",
			"max_length" => "255"
			),
		"fileupload" => array(
			"friendly_name" => "default file to upload",
			"description" => "default file to upload with full path.",
			"method" => "textbox",
			"default" => "/data/upload.cfg",
			"max_length" => "255"
			),
		"cfgm_pancho_pre" => array(
			"friendly_name" => "TFTP pre command default",
			"description" => "this setting is used to specify the pancho pre command to run after each download.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "250"
			),
		"cfgm_pancho_post" => array(
			"friendly_name" => "TFTP post command default",
			"description" => "this setting is used to specify the pancho postcommand to run after each download.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "250"
			),
		"cfgm_pancho_fileformat" => array(
			"friendly_name" => "TFTP file format upload/download default",
			"description" => "this setting is used to specify the pancho file format of the uploaded/downloaded file."
				." It is the Pancho conversion format. ::HOST::, ::NICK::, ::NODE::, ::FULLPATH::, ::DATE:: and "
				."::FILENAME::. For more information www.pancho.org.",
			"method" => "textbox",
			"default" => "::HOST::.::DATE::.cfg",
			"max_length" => "50"
			),
	   "configmanager_panchoonlydata" => array(
			"friendly_name" => "pancho Settings for TFTP method.",
			"method" => "spacer",
			),
		"cfgm_program" => array(
			"friendly_name" => "program",
			"description" => "program to start for the up/download of the configuration. Give also the parameters. The default is for pancho (www.pancho.org) =>'perl -Id:\programme\pancho\lib pancho.pl'.",
			"method" => "textbox",
			"default" => "perl -Id:\programme\pancho\lib pancho.pl ",
			"max_length" => "255"
			),
	   "configmanager_seconddata" => array(
			"friendly_name" => "Default SNMP parameters (you can change it in each config)",
			"method" => "spacer",
			),
		"cfgm_snmp_retries" => array(
			"friendly_name" => "SNMP Retries",
			"description" => "SnmpRetries - This setting is optional (1 by default). Acceptable values are whole numbers from 1 to 20.",
			"method" => "textbox",
			"default" => "1",
			"max_length" => "2"
			),
		"cfgm_snmp_ver" => array(
			"friendly_name" => "SNMP Version",
			"description" => "Default SNMP version for all hosts of a configuration.",
			"method" => "drop_array",
			"default" => "Version 1",
			"array" => $configmanager_snmp_versions,
			),
		"cfgm_snmp_community" => array(
			"friendly_name" => "SNMP Community",
			"description" => "Not for SNMP version 3. Default SNMP read community for all hosts of a configuration.",
			"method" => "textbox",
			"default" => "public",
			"max_length" => "20"
			),
		"cfgm_snmp_username" => array(
			"friendly_name" => "SNMP user",
			"description" => "Only for SNMP version 3. Default SNMP user for all hosts of a configuration.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "20"
			),
		"cfgm_snmp_password" => array(
			"friendly_name" => "SNMP password",
			"description" => "Only for SNMP version 3. Default SNMP password for all hosts of a configuration.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "100"
			),
		"cfgm_snmp_authprotocol" => array(
			"friendly_name" => "SNMP authentification protocol",
			"description" => "Only for SNMP version 3. Default SNMP authentification protocol for all hosts of a configuration. (md5 or sha1).",
			"method" => "drop_array",
			"default" => "md5",
			"array" => $configmanager_snmp_authprotocol,
			),
		"cfgm_snmp_authkey" => array(
			"friendly_name" => "SNMP authentification key",
			"description" => "Only for SNMP version 3. Default SNMP authentification key for all hosts of a configuration.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "200"
			),
		"cfgm_snmp_priv_protocol" => array(
			"friendly_name" => "SNMP Privacy Protocol (v3)",
			"description" => "Only for SNMP version 3. Choose the SNMPv3 Privacy Protocol.",
			"method" => "drop_array",
			"default" => "none",
			"array" => $configmanager_snmp_priv_protocol,
			),
	   "configmanager_thirddata" => array(
			"friendly_name" => "special options",
			"method" => "spacer",
			),
		"cfgm_snmpforkLimit" => array(
			"friendly_name" => "SNMP fork Limit",
			"description" => "Optional parameter used to configure the max number of forked processes running at one time. The value should be a whole integer. Default is 10. For all hosts of a configuration.",
			"method" => "textbox",
			"default" => "5",
			"max_length" => "2"
			),
		"cfgm_SnmpWait" => array(
			"friendly_name" => "SNMP Timeout",
			"description" => "SnmpWait. Optional parameter (5.0 by default). Acceptable values may be between 1.0 and 60.0. For all hosts of a configuration.",
			"method" => "textbox",
			"default" => "5.2",
			"max_length" => "4"
			),
		"cfgm_SnmpMtu" => array(
			"friendly_name" => "SNMP MTU",
			"description" => "Optional parameter 1500 by default. the value can be whole numbers from 484 to 65535. For all hosts of a configuration.",
			"method" => "textbox",
			"default" => "1500",
			"max_length" => "5"
			),
		"cfgm_snmp_port" => array(
			"friendly_name" => "SNMP Port",
			"description" => "At this time NOT USED. The UDP/TCP Port to use for SNMP.",
			"method" => "textbox",
			"default" => "161",
			"max_length" => "5"
			),
		"cfgm_snmpdebug" => array(
			"friendly_name" => "debug mode for SNMP upload/download request",
			"description" => "debug mode forSNMP request. Its depend of the capabilities of the upload/download programme.",
			"method" => "checkbox",
			"default" => "yes",
			)
		);
		
//		$settings["visual"]["configmanager_header"] = array( ......

}
function configmanager_show_tab () {
}

function configmanager_config_arrays () {
	global $user_auth_realms, $user_auth_realm_filenames, $menu,$configmanager_snmp_versions,$cfgmngversion;
	global $config,$configmanager_snmp_authprotocol,$configmanager_snmp_priv_protocol;	
	$cfgmngversion= CFGMNGVERSIONPLUGIN;

	$user_auth_realms[CFGMNGREALMPLUGIN]='Configure configmanager';
	$user_auth_realm_filenames['configmanager.php'] = CFGMNGREALMPLUGIN;
	$user_auth_realm_filenames['configmanagershow.php'] = CFGMNGREALMPLUGIN;
	$user_auth_realm_filenames['configmanager_edit.php'] = CFGMNGREALMPLUGIN;
	$user_auth_realm_filenames['compare.php'] = CFGMNGREALMPLUGIN;
	$user_auth_realm_filenames['cfgmngutilities.php'] = CFGMNGREALMPLUGIN;
	$user_auth_realm_filenames['showtraps.php'] = CFGMNGREALMPLUGIN;
	$menu2 = array ();
	foreach ($menu as $temp => $temp2 ) {
		$menu2[$temp] = $temp2;
		if ($temp == 'Configuration') {
			$menu2["config up/down-load"]['plugins/configmanager/configmanager.php'] = "manage configs";
			$menu2["config up/down-load"]['plugins/configmanager/compare.php'] = "compare configs";
			$menu2["config up/down-load"]['plugins/configmanager/cfgmngutilities.php'] = "logfile";
			$menu2["config up/down-load"]['plugins/configmanager/showtraps.php'] = "trap events";
		}
	}
	$menu = $menu2;
	$configmanager_snmp_versions = array(
		1 => "Version 1",
		2 => "Version 2",
		3 => "Version 3");
	$configmanager_snmp_authprotocol = array(
		"md5" => "md5",
		"sha1" => "sha1");
	$configmanager_snmp_priv_protocol = array(
		"none" => "none",
		"DES" => "DES",
		"AES" => "AES");
}

function configmanager_draw_navigation_text ($nav) {
	$nav["configmanager.php:"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager.php", "level" => "1");
	$nav["configmanager.php:add"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager.php", "level" => "1");
	$nav["configmanager.php:save"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager.php", "level" => "1");
	$nav["configmanager.php:delete"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager.php", "level" => "1");
	$nav["configmanager.php:edit"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager.php", "level" => "1");
	$nav["configmanager.php:update"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager.php", "level" => "1");
	$nav["configmanager_edit.php:"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "1");
	$nav["configmanager_edit.php:add"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "1");
	$nav["configmanager_edit.php:delete"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "1");
	$nav["configmanager_edit.php:edit"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "1");
	$nav["configmanager_edit.php:swap"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "1");
	$nav["configmanager_edit.php:save"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "1");
	$nav["configmanager_edit.php:actions"] = array("title" => "configmanager", "mapping" => "index.php:", "url" => "configmanager_edit.php", "level" => "2");
	$nav["configmanagershow.php:"] = array("title" => "show of configmanager", "mapping" => "index.php:", "url" => "configmanagershow.php", "level" => "1");
	$nav["configmanagershow.php:show"] = array("title" => "(show)", "mapping" => "index.php:", "url" => "configmanagershow.php", "level" => "2");
	$nav["compare.php:"] = array("title" => "(show)", "mapping" => "index.php:", "url" => "compare.php", "level" => "1");
	$nav["compare.php:compare"] = array("title" => "(show)", "mapping" => "index.php:", "url" => "compare.php", "level" => "1");
	$nav["cfgmngutilities.php:"] = array("title" => "logfile", "mapping" => "index.php:", "url" => "cfgmngutilities.php", "level" => "1");
	$nav["cfgmngutilities.php:view_logfile"] = array("title" => "logfile", "mapping" => "index.php:", "url" => "cfgmngutilities.php", "level" => "1");
	$nav["cfgmngutilities.php:purge"] = array("title" => "logfile", "mapping" => "index.php:", "url" => "cfgmngutilities.php", "level" => "1");
	$nav["cfgmngutilities.php:clear_logfile"] = array("title" => "logfile", "mapping" => "index.php:", "url" => "cfgmngutilities.php", "level" => "1");
	$nav["cfgmngutilities.php:purge"] = array("title" => "logfile", "mapping" => "index.php:", "url" => "cfgmngutilities.php", "level" => "1");
	$nav["showtraps.php:"] = array("title" => "(show)", "mapping" => "index.php:", "url" => "showtraps.php", "level" => "1");
	$nav["showtraps.php:reset"] = array("title" => "(show)", "mapping" => "index.php:", "url" => "showtraps.php", "level" => "1");
	$nav["showtraps.php:save"] = array("title" => "(show)", "mapping" => "index.php:", "url" => "showtraps.php", "level" => "1");
	return $nav;
}

function configmanager_setup_table () {
	global $config, $database_default;
        global $cfgmngtable_basis,$cfgmngtable,$cfgmngtable_data,$cfgmngtable_trap;
        include_once($config["base_path"] ."/plugins/configmanager/config.php");
        include_once($config["base_path"] ."/plugins/configmanager/debug.php");
	include_once($config["library_path"] . "/database.php");
	$showsql = "show tables from `" . $database_default . "`";
	$result = db_fetch_assoc($showsql) or die (mysql_error());
	$tables = array();
	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}
	$sql = array();
	$currentcfgmngversion="";
	if (!in_array($cfgmngtable_basis, $tables)) {
	  $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable_basis (
  id int(11) NOT NULL auto_increment,
  version varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;";
	  $sql[] = "INSERT INTO $cfgmngtable_basis (id, version) VALUES (1, '".CFGMNGVERSIONPLUGIN."');";
	  $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
          $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable_basis. -> result=$result\n";
          cfgmng_log($message);
        } else {
	  $sqlrequest = "SELECT * FROM $cfgmngtable_basis";
	  $info = db_fetch_assoc($sqlrequest);
	  if ((sizeof($info) > 0) && isset($info)) {
	    $currentcfgmngversion=$info[0]['version'];
	  }
        }
	if (!in_array($cfgmngtable, $tables)) {
	  if (in_array('configmanager', $tables)) {
            //  upgrade
	    unset($sql);$sql = array();
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `tftp` varchar(100) NOT NULL default '';";
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `usepancho`  tinyint(11) NOT NULL default '1';";
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `accepttrap`  tinyint(11) NOT NULL default '0';";
	    $sql[] = "ALTER TABLE `configmanager` ADD COLUMN `finishlog`  tinyint(11) NOT NULL default '0';";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a]);}}
            $message=date("Y-m-d H:i:s ")."Upgrade of SQL data configmanager before renaming. -> result=$result\n";
            cfgmng_log($message);
	    unset($sql);$sql = array();
            $sql[] = "CREATE TABLE $cfgmngtable SELECT * FROM configmanager;";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a]);}}
            $message=date("Y-m-d H:i:s ")."Copy of SQL table configmanager. -> result=$result\n";
            cfgmng_log($message);
          } else {
            //  very new installation
            unset($sql);$sql = array();
	    $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable (
  id int(10) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  configtype varchar(10) NOT NULL default 'tftp',
  state enum('up','down','error','failed') NOT NULL default 'down',
  PCmanager varchar(100) NOT NULL default '',
  up_download enum('download','upload') NOT NULL default 'download',
  path varchar(100) NOT NULL default '',
  pathdata varchar(100) NOT NULL default '',
  fileupload varchar(100) NOT NULL default '',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  monthly  tinyint(11) NOT NULL default '0',
  mon  tinyint(11) NOT NULL default '0',
  tue  tinyint(11) NOT NULL default '0',
  wed  tinyint(11) NOT NULL default '0',
  thu  tinyint(11) NOT NULL default '0',
  fri  tinyint(11) NOT NULL default '0',
  sat  tinyint(11) NOT NULL default '0', 
  sun  tinyint(11) NOT NULL default '0',
  lastused datetime default '0000-00-00 00:00:00',
  snmp_version tinyint(1) unsigned NOT NULL default '1',
  snmp_username varchar(100) NOT NULL default '',
  snmp_password varchar(100) NOT NULL default '',
  snmp_community varchar(100) NOT NULL default '',
  snmp_auth_protocol varchar(5) default 'MD5',
  snmp_priv_passphrase varchar(200) default '',
  snmp_priv_protocol varchar(6) default '',
  command varchar(255) NOT NULL default '',
  templatename varchar(100) NOT NULL default '',
  post varchar(250) NOT NULL default '',
  pre varchar(250) NOT NULL default '',
  fileformat varchar(50) NOT NULL default '::HOST::.::DATE::.cfg',
  commit tinyint(1) unsigned NOT NULL default '0',
  startup tinyint(1) unsigned NOT NULL default '0',
  reload tinyint(1) unsigned NOT NULL default '0',
  tftp varchar(100) NOT NULL default '',
  usepancho  tinyint(11) NOT NULL default '1',
  accepttrap  tinyint(11) NOT NULL default '0',
  finishlog  tinyint(11) NOT NULL default '0',
  delay  int(10) NOT NULL default '0',
  KEY id (id)
  ) TYPE=MyISAM;";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
            $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable. -> result=$result\n";
            cfgmng_log($message);
          }
        }
	if (!in_array($cfgmngtable_data, $tables)) {
	  if (in_array('configmanager_data', $tables)) {
            //  upgrade
	    unset($sql);$sql = array();
            $sql[] = "CREATE TABLE $cfgmngtable_data SELECT * FROM configmanager_data;";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a]);}}
            $message=date("Y-m-d H:i:s ")."Copy of SQL table configmanager_data. -> result=$result\n";
            cfgmng_log($message);
          } else {
            //  very new installation
            unset($sql);$sql = array();
	    $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable_data (
  id int(10) NOT NULL auto_increment,
  configmanagerid int(10) NOT NULL default '0',
  hostid int(10) NOT NULL default '0',
  hostname varchar(100) NOT NULL default '',
  hostip varchar(100) NOT NULL default '',
  snmp_version tinyint(1) unsigned NOT NULL default '1',
  hostuser varchar(100) NOT NULL default '',
  hostpassword varchar(100) NOT NULL default '',
  hostcommunity varchar(100) NOT NULL default '',
  state enum('enable','disable','error','failed') NOT NULL default 'enable',
  gorder int(5) NOT NULL default '0',
  KEY id (id)
  ) TYPE=MyISAM;";
	  $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
          $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable_data. -> result=$result\n";
          cfgmng_log($message);
	 }
        }
        if (!isset($cfgmngtable_trap)) $cfgmngtable_trap = "plugin_cfgmng_trap";
	if (!in_array($cfgmngtable_trap, $tables)) {
            unset($sql);$sql = array();
	    $sql[] = "
CREATE TABLE IF NOT EXISTS $cfgmngtable_trap (
  id int(11) NOT NULL auto_increment,
  lastanalyzed datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;";
	  $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK":"ERROR";}}
          $message=date("Y-m-d H:i:s ")."Create of SQL tables $cfgmngtable_trap. -> result=$result\n";
          cfgmng_log($message);
        }
	// check again before drop
	unset($tables);
	$showsql = "show tables from `" . $database_default . "`";
	$result = db_fetch_assoc($showsql) or die (mysql_error());
	$tables = array();
	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}
	if (($cfgmngtable!='configmanager') && (in_array('configmanager', $tables))) {
	  // remove the tables
	  $sqlrequest = "RENAME TABLE configmanager TO OLDconfigmanager;";
	  $result = mysql_query($sqlrequest)?"OK":"ERROR";
          $message=date("Y-m-d H:i:s ")."$sqlrequest -> result=$result\n";
          cfgmng_log($message);
	}
	if (($cfgmngtable_data!='configmanager_data') && (in_array('configmanager_data', $tables))) {
	  // remove the tables
	  $sqlrequest = "RENAME TABLE configmanager_data TO OLDconfigmanager_data;";
	  $result =mysql_query($sqlrequest)?"OK":"ERROR";
          $message=date("Y-m-d H:i:s ")."$sqlrequest -> result=$result\n";
          cfgmng_log($message);
	}
        // correct Bug of auto_increment
	if (($currentcfgmngversion=="0.5")||($currentcfgmngversion=="0.5a")
	      ||($currentcfgmngversion=="0.5b")||($currentcfgmngversion=="0.5c")) {
	    unset($sql);$sql = array();
	    $sql[] = "ALTER TABLE $cfgmngtable_data MODIFY column id INT NOT NULL AUTO_INCREMENT,ADD INDEX (id)";
	    $sql[] = "ALTER TABLE $cfgmngtable MODIFY column id INT NOT NULL AUTO_INCREMENT,ADD INDEX (id)";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK,":"ERROR,";}}
            $message=date("Y-m-d H:i:s ")."Correct the SQL auto_increment id. -> result=$result\n";
            cfgmng_log($message);
	}
	if (floatval($currentcfgmngversion)<= 0.5) {
            //  upgrade
	    unset($sql);$sql = array();
	    $sqlreq = "ALTER TABLE $cfgmngtable ADD COLUMN `delay` int(10) NOT NULL default '0';";
	    $result = mysql_query($sqlreq);
            $message=date("Y-m-d H:i:s ")."Upgrade of SQL data $cfgmngtable $sqlreq . -> result=$result\n";
            cfgmng_log($message);
        }
	if (floatval($currentcfgmngversion)< 0.71) {
            //  upgrade
	    unset($sql);$sql = array();
	    $sqlreq = "ALTER TABLE $cfgmngtable ADD COLUMN `binair` tinyint(11) NOT NULL default '0';";
	    $result = mysql_query($sqlreq);
            $message=date("Y-m-d H:i:s ")."Upgrade of SQL data $cfgmngtable $sqlreq . -> result=$result\n";
            cfgmng_log($message);
        }
	if (floatval($currentcfgmngversion)< 0.76) {
            //  upgrade
	    unset($sql);$sql = array();
            $sql[] = "ALTER TABLE $cfgmngtable ADD COLUMN `snmp_priv_protocol` varchar(6) default '' after snmp_community";
            $sql[] = "ALTER TABLE $cfgmngtable ADD COLUMN `snmp_priv_passphrase` varchar(200) default '' after snmp_community";
            $sql[] = "ALTER TABLE $cfgmngtable ADD COLUMN `snmp_auth_protocol` varchar(5) default 'MD5' after snmp_community";
	    $result ="";if (!empty($sql)) {for ($a = 0; $a < count($sql); $a++) {$result .= mysql_query($sql[$a])?"OK,":"ERROR,";}}
            $message=date("Y-m-d H:i:s ")."Correct the SQL auto_increment id. -> result=$result\n";
            cfgmng_log($message);
        }
        // INSERT the new version number
	if (in_array($cfgmngtable_basis, $tables) && ($currentcfgmngversion!=CFGMNGVERSIONPLUGIN)) {
	    $save["id"] = "1";
	    $save["version"] = CFGMNGVERSIONPLUGIN;
	    $id2 = sql_save($save, "$cfgmngtable_basis");
            $message=date("Y-m-d H:i:s ")
                    ."update version number from $currentcfgmngversion to ".CFGMNGVERSIONPLUGIN
                    .". -> result=".(($id2)?"OK($id2)":"ERROR")."\n";
            cfgmng_log($message);
	}
}

function configmanager_poller_bottom() {
  global $config;

    configmanager_setup_table();
    $p = $config["base_path"];
    $val = read_config_option("cfgm_debug");
    ($val=="on") ? $debugmode="-d" : $debugmode="";
    if ($config["cacti_server_os"] == "unix") {
        $command_string = read_config_option("path_php_binary");
        $extra_args = "-q " . $p . "/plugins/configmanager/configmanager_poller.php ".$debugmode;
    } else {
    	$winpathfile = read_config_option("path_php_binary");
        $command_string = strtr($winpathfile,"\\", "/");
        $mfile=strtr($p,"\\", "/"). "/plugins/configmanager/configmanager_poller.php ".$debugmode;
        $extra_args = "-q " . strtolower($mfile);
    }
    if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_MEDIUM) {
	$cacti_log="EXEC=$command_string $extra_args / $debugmode\n";
	cacti_log("CFG MANAGER POLLER:$cacti_log\n",true,"SYSTEM");
    }
    exec_background($command_string, "$extra_args");
}

?>